SystemOrganization addCategory: #CSA!
SystemOrganization addCategory: #'CSA-Events'!
SystemOrganization addCategory: #'CSA-Metrics'!
SystemOrganization addCategory: #'CSA-Metrics-3rdParty'!
SystemOrganization addCategory: #'CSA-UI'!
SystemOrganization addCategory: #'CSA-Test'!
SystemOrganization addCategory: #'CSA-Util'!
SystemOrganization addCategory: #'CSA-Demo'!

Trait named: #TCSAAccessors
	uses: {}
	category: 'CSA-Metrics'!

!TCSAAccessors methodsFor: 'as yet unclassified' stamp: 'ck 1/16/2012 23:07:40.738'!
accessorsForClassOf: aCompiledMethod
	"retrieves the number of accessors of a given class"
	| instanceVariables methods |
	instanceVariables := aCompiledMethod methodClass allInstVarNames asOrderedCollection.
	instanceVariables addAll: (instanceVariables collect: [:each | each, ':']).  
	methods := CSACallCollector collectSelfAndSuperCallsFrom: aCompiledMethod.
	^ methods intersection: (instanceVariables collect: [:each | each asSymbol ])
! !

!TCSAAccessors methodsFor: 'as yet unclassified' stamp: 'ck 1/16/2012 21:22:59'!
variablesForClassOf: aCompiledMethod
	^ aCompiledMethod methodClass allInstVarNames! !

Trait named: #TCSAEventHandler
	uses: {}
	category: 'CSA-Events'!

!TCSAEventHandler methodsFor: 'class events' stamp: 'sk 12/16/2011 21:41:00.595'!
addedClass: aCSAClassAddedEvent
	^ self doDefaultHandlingFor: aCSAClassAddedEvent! !

!TCSAEventHandler methodsFor: 'method events' stamp: 'sk 12/16/2011 23:28:43.042'!
addedMethod: aCSAMethodAddedEvent
	^ self doDefaultHandlingFor: aCSAMethodAddedEvent! !

!TCSAEventHandler methodsFor: 'class events' stamp: 'sk 1/6/2012 19:43:39.096'!
commentedClass: aCSAClassCommentedEvent
	^ self doDefaultHandlingFor: aCSAClassCommentedEvent   ! !

!TCSAEventHandler methodsFor: 'general handling' stamp: 'sk 12/16/2011 21:40:23.582'!
doDefaultHandlingFor: aCSAEvent
	self requirement! !

!TCSAEventHandler methodsFor: 'general handling' stamp: 'sk 12/16/2011 23:41:19.443'!
handle: aCSAEvent
	^ aCSAEvent accept: self! !

!TCSAEventHandler methodsFor: 'class events' stamp: 'sk 12/17/2011 15:58:42.746'!
modifiedClass: aCSAClassModifiedEvent
	^ self doDefaultHandlingFor: aCSAClassModifiedEvent  ! !

!TCSAEventHandler methodsFor: 'method events' stamp: 'sk 12/17/2011 00:03:19.198'!
modifiedMethod: aCSAMethodChangedEvent
	^ self doDefaultHandlingFor: aCSAMethodChangedEvent  ! !

!TCSAEventHandler methodsFor: 'class events' stamp: 'sk 12/17/2011 16:09:42.133'!
recategorizedClass: aCSAClassRecategorizedEvent
	^ self doDefaultHandlingFor: aCSAClassRecategorizedEvent  ! !

!TCSAEventHandler methodsFor: 'method events' stamp: 'sk 1/6/2012 20:14:43.448'!
recategorizedMethod: aCSAMethodRecategorizedEvent
	^ self doDefaultHandlingFor: aCSAMethodRecategorizedEvent  ! !

!TCSAEventHandler methodsFor: 'class events' stamp: 'sk 12/16/2011 21:42:15.194'!
removedClass: aCSAClassRemovedEvent
	^ self doDefaultHandlingFor: aCSAClassRemovedEvent   ! !

!TCSAEventHandler methodsFor: 'method events' stamp: 'sk 12/16/2011 23:42:31.492'!
removedMethod: aCSAMethodRemovedEvent
	^ self doDefaultHandlingFor: aCSAMethodRemovedEvent  ! !

!TCSAEventHandler methodsFor: 'class events' stamp: 'sk 12/16/2011 23:39:00.133'!
renamedClass: aCSAClassRenamedEvent
	^ self doDefaultHandlingFor: aCSAClassRenamedEvent   ! !

DockingBarMenuMorph subclass: #CSAMenu
	instanceVariableNames: 'metrics metricItems coDriver'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-UI'!

!CSAMenu class methodsFor: 'instance creation' stamp: 'f.z 1/18/2012 15:44:32.484'!
for: aCoDriver
	^ self new
		coDriver: aCoDriver;
		yourself! !

!CSAMenu methodsFor: 'metric activation' stamp: 'f.z 1/18/2012 16:03:35.235'!
activateAllMetrics
	self metricItems do:
		[ :item | item checked: true ].
	self metrics do:
		[ :metric | self coDriver addMetric: metric ].
	self coDriver refreshLayout! !

!CSAMenu methodsFor: 'metric activation' stamp: 'f.z 1/18/2012 19:07:48.819'!
activateDemoMetrics
	self demoMetrics do:
		[ :metric | | index |
			index := self metrics indexOf: metric.
			(self metricItems at: index) checked: true.
			self coDriver addMetric: metric ].
	self coDriver refreshLayout! !

!CSAMenu methodsFor: 'initialization' stamp: 'f.z 1/18/2012 19:00:00.538'!
addDefaultEntries
	self
		add: 'Add all' target: self action: #activateAllMetrics;
		add: 'Add demo metrics' target: self action: #activateDemoMetrics;
		add: 'Remove all' target: self action: #deactivateAllMetrics;
		addLine! !

!CSAMenu methodsFor: 'adding' stamp: 'f.z 1/18/2012 15:46:05.26'!
addMetric: aMetricClass selector: aSymbol
	| item |
	item := self createMenuItemFor: aMetricClass selector: aSymbol.
	self addMorphBack: item.
	self metricItems add: item.
	self metrics add: aMetricClass.
	^ item! !

!CSAMenu methodsFor: 'accessing' stamp: 'f.z 1/18/2012 15:30:14.718'!
coDriver
	^ coDriver! !

!CSAMenu methodsFor: 'accessing' stamp: 'f.z 1/18/2012 15:30:14.751'!
coDriver: aCoDriver
	coDriver := aCoDriver
! !

!CSAMenu methodsFor: 'adding' stamp: 'f.z 1/18/2012 15:46:56.324'!
createMenuItemFor: aMetricClass selector: aSymbol
	^ CSAMenuItem new
		contents: aMetricClass longTitle;
		target: self coDriver;
		selector: aSymbol;
		arguments: (Array with: aMetricClass);
		yourself! !

!CSAMenu methodsFor: 'metric activation' stamp: 'f.z 1/18/2012 15:40:31.412'!
deactivateAllMetrics
	self coDriver removeAllMetrics.
	self metricItems do: [ :item | item checked: false ]! !

!CSAMenu methodsFor: 'accessing' stamp: 'f.z 1/18/2012 19:06:52.45'!
demoMetrics
	^ { CSACINTMetric. CSALawOfDemeterMetric. CSAMethodCycloMetric.
		CSAMethodNestingMetric. CSATransitiveResponseForClass.
		CSAWeightedMethodCount. CSAUnclassifiedMethodsMetric  }! !

!CSAMenu methodsFor: 'initialization' stamp: 'f.z 1/18/2012 15:38:57.332'!
initialize
	super initialize.
	self
		initializeState;
		addDefaultEntries! !

!CSAMenu methodsFor: 'initialization' stamp: 'f.z 1/18/2012 15:39:18.796'!
initializeState
	self
		metrics: OrderedCollection new;
		metricItems: OrderedCollection new! !

!CSAMenu methodsFor: 'accessing' stamp: 'f.z 1/18/2012 15:16:04.414'!
metricItems
	^ metricItems! !

!CSAMenu methodsFor: 'accessing' stamp: 'f.z 1/18/2012 15:16:04.445'!
metricItems: aCollection
	metricItems := aCollection
! !

!CSAMenu methodsFor: 'accessing' stamp: 'f.z 1/18/2012 15:38:23.894'!
metrics
	^ metrics! !

!CSAMenu methodsFor: 'accessing' stamp: 'f.z 1/18/2012 15:38:23.919'!
metrics: aCollection
	metrics := aCollection
! !

Morph subclass: #CSADemoCalculator
	instanceVariableNames: 'clearOnNextDigit digitEntered nextOperation previousArgument ui'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Demo'!

!CSADemoCalculator class methodsFor: 'instance creation' stamp: 'f.z 1/18/2012 18:01:45.403'!
start
	^ self new
		openInWindowLabeled: 'CSA Calculator';
		yourself! !

!CSADemoCalculator methodsFor: 'display operations' stamp: 'f.z 1/18/2012 18:23:46.682'!
appendDigit: aString
	self ui display theText: self ui display theText, aString.
	self digitEntered: true  ! !

!CSADemoCalculator methodsFor: 'display operations' stamp: 'f.z 1/18/2012 17:41:05.834'!
appendEight
	self appendDigit: '8'! !

!CSADemoCalculator methodsFor: 'display operations' stamp: 'f.z 1/18/2012 17:40:52.81'!
appendFive
	self appendDigit: '5'! !

!CSADemoCalculator methodsFor: 'display operations' stamp: 'f.z 1/18/2012 17:40:49.034'!
appendFour
	self appendDigit: '4'! !

!CSADemoCalculator methodsFor: 'display operations' stamp: 'f.z 1/18/2012 17:41:10.89'!
appendNine
	self appendDigit: '9'! !

!CSADemoCalculator methodsFor: 'display operations' stamp: 'f.z 1/18/2012 17:40:37.146'!
appendOne
	self appendDigit: '1'! !

!CSADemoCalculator methodsFor: 'display operations' stamp: 'f.z 1/18/2012 17:41:01.81'!
appendSeven
	self appendDigit: '7'! !

!CSADemoCalculator methodsFor: 'display operations' stamp: 'f.z 1/18/2012 17:40:56.978'!
appendSix
	self appendDigit: '6'! !

!CSADemoCalculator methodsFor: 'display operations' stamp: 'f.z 1/18/2012 17:40:44.69'!
appendThree
	self appendDigit: '3'! !

!CSADemoCalculator methodsFor: 'display operations' stamp: 'f.z 1/18/2012 17:40:30.643'!
appendTwo
	self appendDigit: '2'! !

!CSADemoCalculator methodsFor: 'display operations' stamp: 'f.z 1/18/2012 17:40:41.218'!
appendZero
	self appendDigit: '0'! !

!CSADemoCalculator methodsFor: 'events' stamp: 'f.z 1/18/2012 18:03:49.42'!
buttonPressed: aString
	(aString = '0')
		ifTrue: [ 
			self clearOnNextDigit ifTrue: [ self clearDisplay ].
			self appendZero ].
	(aString = '1')
		ifTrue: [ 
			self clearOnNextDigit ifTrue: [ self clearDisplay ].
			self appendOne ].
	(aString = '2')
		ifTrue: [ 
			self clearOnNextDigit ifTrue: [ self clearDisplay ].
			self appendTwo ].
	(aString = '3')
		ifTrue: [ 
			self clearOnNextDigit ifTrue: [ self clearDisplay ].
			self appendThree ].
	(aString = '4')
		ifTrue: [ 
			self clearOnNextDigit ifTrue: [ self clearDisplay ].
			self appendFour ].
	(aString = '5')
		ifTrue: [ 
			self clearOnNextDigit ifTrue: [ self clearDisplay ].
			self appendFive ].
	(aString = '6')
		ifTrue: [ 
			self clearOnNextDigit ifTrue: [ self clearDisplay ].
			self appendSix ].
	(aString = '7')
		ifTrue: [ 
			self clearOnNextDigit ifTrue: [ self clearDisplay ].
			self appendSeven ].
	(aString = '8')
		ifTrue: [ 
			self clearOnNextDigit ifTrue: [ self clearDisplay ].
			self appendEight ].
	(aString = '9')
		ifTrue: [ 
			self clearOnNextDigit ifTrue: [ self clearDisplay ].
			self appendNine ].
	(aString = '+')
		ifTrue: [ self performOperation: '+' ].
	(aString = '-')
		ifTrue: [ self performOperation: '-' ].
	(aString = '*')
		ifTrue: [ self performOperation: '*' ].
	(aString = '/')
		ifTrue: [ self performOperation: '/' ].
	(aString = '=')
		ifTrue: [ self performOperation: '=' ]! !

!CSADemoCalculator methodsFor: 'display operations' stamp: 'f.z 1/18/2012 18:04:57.547'!
clearDisplay
	self ui display theText: ''.
	self clearOnNextDigit: false  ! !

!CSADemoCalculator methodsFor: 'accessing' stamp: 'f.z 1/18/2012 17:59:55.452'!
clearOnNextDigit
	^ clearOnNextDigit! !

!CSADemoCalculator methodsFor: 'accessing' stamp: 'f.z 1/18/2012 17:59:55.482'!
clearOnNextDigit: aBoolean
	clearOnNextDigit := aBoolean
! !

!CSADemoCalculator methodsFor: 'initialization' stamp: 'f.z 1/18/2012 17:32:46.827'!
connectButtons
	self 
		connect: self ui zeroButton signal: #clicked: toSelector: #zeroPressed;
		connect: self ui oneButton signal: #clicked: toSelector: #onePressed;
		connect: self ui twoButton signal: #clicked: toSelector: #twoPressed;
		connect: self ui threeButton signal: #clicked: toSelector: #threePressed;
		connect: self ui fourButton signal: #clicked: toSelector: #fourPressed;
		connect: self ui fiveButton signal: #clicked: toSelector: #fivePressed;
		connect: self ui sixButton signal: #clicked: toSelector: #sixPressed;
		connect: self ui sevenButton signal: #clicked: toSelector: #sevenPressed;
		connect: self ui eightButton signal: #clicked: toSelector: #eightPressed;
		connect: self ui nineButton signal: #clicked: toSelector: #ninePressed;
		connect: self ui plusButton signal: #clicked: toSelector: #plusPressed;
		connect: self ui minusButton signal: #clicked: toSelector: #minusPressed;
		connect: self ui timesButton signal: #clicked: toSelector: #timesPressed;
		connect: self ui divideButton signal: #clicked: toSelector: #dividePressed;
		connect: self ui equalsButton signal: #clicked: toSelector: #equalsPressed! !

!CSADemoCalculator methodsFor: 'accessing' stamp: 'f.z 1/18/2012 18:23:21.085'!
digitEntered
	^ digitEntered! !

!CSADemoCalculator methodsFor: 'accessing' stamp: 'f.z 1/18/2012 18:23:21.119'!
digitEntered: aBoolean
	digitEntered := aBoolean
! !

!CSADemoCalculator methodsFor: 'events' stamp: 'f.z 1/18/2012 17:34:41.89'!
dividePressed
	self buttonPressed: '/'! !

!CSADemoCalculator methodsFor: 'as yet unclassified' stamp: 'f.z 1/18/2012 18:37:28.675'!
dummyMethod
	| dummyVar |
	self nextOperation = 'this is just a really long string to test whether long lines are detected' ifTrue: [ ^ self] ifFalse: [ self nextOperation = 'and another long string to even stress this line' ] ! !

!CSADemoCalculator methodsFor: 'events' stamp: 'f.z 1/18/2012 17:34:45.522'!
eightPressed
	self buttonPressed: '8'! !

!CSADemoCalculator methodsFor: 'events' stamp: 'f.z 1/18/2012 17:34:34.018'!
equalsPressed
	self buttonPressed: '='! !

!CSADemoCalculator methodsFor: 'events' stamp: 'f.z 1/18/2012 17:34:51.786'!
fivePressed
	self buttonPressed: '5'! !

!CSADemoCalculator methodsFor: 'events' stamp: 'f.z 1/18/2012 17:34:55.522'!
fourPressed
	self buttonPressed: '4'! !

!CSADemoCalculator methodsFor: 'initialization' stamp: 'f.z 1/18/2012 18:23:30.866'!
initialize
	super initialize.
	self 
		ui: CSADemoCalculatorUi new;
		clearOnNextDigit: true;
		digitEntered: true;
		previousArgument: '0';
		nextOperation: ''.
	self ui setupUi: self.
	self ui display theText: '0'.
	self connectButtons! !

!CSADemoCalculator methodsFor: 'events' stamp: 'f.z 1/18/2012 17:35:02.194'!
minusPressed
	self buttonPressed: '-'! !

!CSADemoCalculator methodsFor: 'accessing' stamp: 'f.z 1/18/2012 17:58:36.796'!
nextOperation
	^ nextOperation! !

!CSADemoCalculator methodsFor: 'accessing' stamp: 'f.z 1/18/2012 17:58:36.827'!
nextOperation: aString
	nextOperation := aString
! !

!CSADemoCalculator methodsFor: 'events' stamp: 'f.z 1/18/2012 17:35:07.883'!
ninePressed
	self buttonPressed: '9'! !

!CSADemoCalculator methodsFor: 'events' stamp: 'f.z 1/18/2012 17:35:11.994'!
onePressed
	self buttonPressed: '1'! !

!CSADemoCalculator methodsFor: 'calculation operations' stamp: 'f.z 1/18/2012 18:27:00.445'!
performOperation: aString  
	| prevPlus prevMinus prevTimes prevDivide result |
	self clearOnNextDigit: true.
	self digitEntered ifFalse: [
			self nextOperation: '='.
			(aString = '+')
				ifTrue: [self nextOperation: '+' ].
			(aString = '-')
				ifTrue: [self nextOperation: '-' ].
			(aString = '*')
				ifTrue: [self nextOperation: '*' ].
			(aString = '/')
				ifTrue: [self nextOperation: '/' ].
			^ self
		].
	self digitEntered: false.  
	
	(aString = '+')
		ifTrue: [
			prevPlus := self ui display theText asNumber.
			(self nextOperation = '+')
				ifTrue: [ prevPlus := self previousArgument asNumber + self ui display theText asNumber ].
			(self nextOperation = '-')
				ifTrue: [ prevPlus := self previousArgument asNumber - self ui display theText asNumber ].
			(self nextOperation = '*')
				ifTrue: [ prevPlus := self previousArgument asNumber * self ui display theText asNumber ].
			(self nextOperation = '/')
				ifTrue: [ prevPlus := self previousArgument asNumber // self ui display theText asNumber ].
			
			self ui display theText: prevPlus asString.
			self
				previousArgument: prevPlus asString;
				nextOperation: '+' ].
	(aString = '-')
		ifTrue: [
			prevMinus := self ui display theText asNumber.
			(self nextOperation = '+')
				ifTrue: [ prevMinus := self previousArgument asNumber + self ui display theText asNumber ].
			(self nextOperation = '-')
				ifTrue: [ prevMinus := self previousArgument asNumber - self ui display theText asNumber ].
			(self nextOperation = '*')
				ifTrue: [ prevMinus := self previousArgument asNumber * self ui display theText asNumber ].
			(self nextOperation = '/')
				ifTrue: [ prevMinus := self previousArgument asNumber // self ui display theText asNumber ].
			
			self ui display theText: prevMinus asString.
			self
				previousArgument: prevMinus asString;
				nextOperation: '-' ].
	(aString = '*')
		ifTrue: [
			prevTimes := self ui display theText asNumber.
			(self nextOperation = '+')
				ifTrue: [ prevTimes := self previousArgument asNumber + self ui display theText asNumber ].
			(self nextOperation = '-')
				ifTrue: [ prevTimes := self previousArgument asNumber - self ui display theText asNumber ].
			(self nextOperation = '*')
				ifTrue: [ prevTimes := self previousArgument asNumber * self ui display theText asNumber ].
			(self nextOperation = '/')
				ifTrue: [ prevTimes := self previousArgument asNumber // self ui display theText asNumber ].
			
			self ui display theText: prevTimes asString.
			self
				previousArgument: prevTimes asString;
				nextOperation: '*' ].
	(aString = '-')
		ifTrue: [
			prevDivide := self ui display theText asNumber.
			(self nextOperation = '+')
				ifTrue: [ prevDivide := self previousArgument asNumber + self ui display theText asNumber ].
			(self nextOperation = '-')
				ifTrue: [ prevDivide := self previousArgument asNumber - self ui display theText asNumber ].
			(self nextOperation = '*')
				ifTrue: [ prevDivide := self previousArgument asNumber * self ui display theText asNumber ].
			(self nextOperation = '/')
				ifTrue: [ prevDivide := self previousArgument asNumber // self ui display theText asNumber ].
			
			self ui display theText: prevDivide asString.
			self
				previousArgument: prevDivide asString;
				nextOperation: '/' ].
	(aString = '=')
		ifTrue: [
			result := self ui display theText asNumber.
			(self nextOperation = '+')
				ifTrue: [ result := self previousArgument asNumber + self ui display theText asNumber ].
			(self nextOperation = '-')
				ifTrue: [ result := self previousArgument asNumber - self ui display theText asNumber ].
			(self nextOperation = '*')
				ifTrue: [ result := self previousArgument asNumber * self ui display theText asNumber ].
			(self nextOperation = '/')
				ifTrue: [ result := self previousArgument asNumber // self ui display theText asNumber ].
				
			self ui display theText: result asString.
			self
				previousArgument: result asString;
				nextOperation: '' ]! !

!CSADemoCalculator methodsFor: 'events' stamp: 'f.z 1/18/2012 17:35:15.299'!
plusPressed
	self buttonPressed: '+'! !

!CSADemoCalculator methodsFor: 'accessing' stamp: 'f.z 1/18/2012 17:58:36.87'!
previousArgument
	^ previousArgument! !

!CSADemoCalculator methodsFor: 'accessing' stamp: 'f.z 1/18/2012 17:58:36.907'!
previousArgument: aString
	previousArgument := aString
! !

!CSADemoCalculator methodsFor: 'as yet unclassified' stamp: 'f.z 1/18/2012 18:38:32.092'!
recursiveMethod
	self recursiveMethod! !

!CSADemoCalculator methodsFor: 'as yet unclassified' stamp: 'f.z 1/18/2012 18:39:27.57'!
sameTrueFalse
	1 = 1
		ifTrue: [ 1 ]
		ifFalse: [ 1 ]! !

!CSADemoCalculator methodsFor: 'events' stamp: 'f.z 1/18/2012 17:35:18.738'!
sevenPressed
	self buttonPressed: '7'! !

!CSADemoCalculator methodsFor: 'events' stamp: 'f.z 1/18/2012 17:35:22.465'!
sixPressed
	self buttonPressed: '6'! !

!CSADemoCalculator methodsFor: 'as yet unclassified' stamp: 'f.z 1/18/2012 18:38:49.491'!
threeElementPoint
	^ 1 @ 2 @ 3! !

!CSADemoCalculator methodsFor: 'events' stamp: 'f.z 1/18/2012 17:35:27.402'!
threePressed
	self buttonPressed: '3'! !

!CSADemoCalculator methodsFor: 'events' stamp: 'f.z 1/18/2012 17:35:33.41'!
timesPressed
	self buttonPressed: '*'! !

!CSADemoCalculator methodsFor: 'events' stamp: 'f.z 1/18/2012 17:35:36.826'!
twoPressed
	self buttonPressed: '2'! !

!CSADemoCalculator methodsFor: 'accessing' stamp: 'f.z 1/18/2012 17:25:15.285'!
ui
	^ ui! !

!CSADemoCalculator methodsFor: 'accessing' stamp: 'f.z 1/18/2012 17:25:15.318'!
ui: aDemoCalculatorUI
	ui := aDemoCalculatorUI
! !

!CSADemoCalculator methodsFor: 'events' stamp: 'f.z 1/18/2012 17:50:06.652'!
zeroPressed
	self buttonPressed: '0'! !

Morph subclass: #CSATable
	instanceVariableNames: 'metricColumns'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-UI'!

!CSATable class methodsFor: 'magic numbers' stamp: 'f.z 1/9/2012 16:04:26.52'!
cellInset
	^ 3! !

!CSATable class methodsFor: 'magic numbers' stamp: 'f.z 1/9/2012 16:04:18.121'!
layoutProperties
	^ (TableLayoutProperties new)
		cellPositioning: #topLeft;
		cellInset: self cellInset;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		listCentering: #topLeft;
		listDirection: #leftToRight;
		yourself          ! !

!CSATable methodsFor: 'column management' stamp: 'ck 1/17/2012 21:51:30.514'!
addColumnFor: aMetric
	self metricColumns at: aMetric class put: (self createColumnFor: aMetric).
	self addMorph: (self metricColumns at: aMetric class)! !

!CSATable methodsFor: 'column management' stamp: 'ck 1/17/2012 22:16:02.63'!
createColumnFor: aMetric
	^ CSAMetricDisplay withMetric: aMetric! !

!CSATable methodsFor: 'initialization' stamp: 'f.z 1/18/2012 18:43:57.731'!
initialize
	super initialize.
	self
		color: Color white;
		metricColumns: Dictionary new;
		layoutPolicy: TableLayout new;
		layoutProperties: self class layoutProperties! !

!CSATable methodsFor: 'accessing' stamp: 'f.z 1/9/2012 15:56:25.458'!
metricColumns
	^ metricColumns! !

!CSATable methodsFor: 'accessing' stamp: 'f.z 1/9/2012 15:56:25.487'!
metricColumns: aDictionary
	metricColumns := aDictionary
! !

!CSATable methodsFor: 'column management' stamp: 'f.z 1/18/2012 15:58:02.42'!
removeColumnFor: aMetricClass
	| column |
	aMetricClass allInstancesDo: [ :metric | metric removeActionsWithReceiver: self ].
	column := self metricColumns at: aMetricClass ifAbsent: [ nil ].
	column ifNil: [ ^ self ].
	self removeMorph: column.
	self metricColumns removeKey: aMetricClass  ! !

!CSATable methodsFor: 'column management' stamp: 'ck 1/17/2012 21:51:44.024'!
tryToRemoveColumnFor: aMetric
	| column |
	column := self metricColumns removeKey: [ aMetric ] ifAbsent: [ ^ self ].
	column dismiss.
	self removeMorph: column  ! !

TestCase subclass: #CSAEmptyClassSourceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Test'!

!CSAEmptyClassSourceTest methodsFor: 'event handling tests' stamp: 'f.z 1/12/2012 11:48:28.517'!
testDoDefaultHandlingFor
	| source |
	source := CSAEmptyClassSource new.
	self assert: [ (source doDefaultHandlingFor: nil) isNil ].
	self assert:
		[ (source doDefaultHandlingFor: (CSAClassAddedEvent for: self class)) isNil ].
	self assert:
		[ (source doDefaultHandlingFor: (CSAClassRemovedEvent for: self class)) isNil ].! !

TestCase subclass: #CSASingleClassSourceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Test'!

!CSASingleClassSourceTest methodsFor: 'as yet unclassified' stamp: 'f.z 1/12/2012 11:49:15.781'!
testGetClasses
	| classes |
	classes := (CSASingleClassSource for: String) allClasses.
	self assert: [ classes size == 2 ].
	self assert: [ classes includes: String ].
	self assert: [ classes includes: String class ]! !

BorderedMorph subclass: #CSAHistoryChart
	instanceVariableNames: 'history lineWidth max min displayedEntries lineColors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-UI'!

!CSAHistoryChart class methodsFor: 'as yet unclassified' stamp: 'ck 1/16/2012 23:53:02.93'!
canvasPadding
	^ 2! !

!CSAHistoryChart class methodsFor: 'as yet unclassified' stamp: 'ck 1/16/2012 23:51:05.662'!
defaultLineColors
	^ { Color red darker. 
		Color green muchDarker. 
		Color blue muchLighter. 
		Color gray muchLighter}! !

!CSAHistoryChart class methodsFor: 'as yet unclassified' stamp: 'ck 1/17/2012 22:27:23.896'!
minimalWidth 
	^ 75! !

!CSAHistoryChart methodsFor: 'user interface' stamp: 'ck 1/17/2012 00:30:48.458'!
addGraphSegmentsFrom: startValueCollection to: endValueCollection as: segmentNumber
	| factor |
	factor := self scalingFactor.
	(1 to: startValueCollection size) do: 
		[:j ||startValue endValue|
			startValue := ((startValueCollection at: j) - self min) * factor.
			endValue := ((endValueCollection at: j ) - self min) * factor.
			self 
				addLineFrom: startValue 
				to: endValue 
				segment: segmentNumber 
				color: (self lineColors at: j) ].! !

!CSAHistoryChart methodsFor: 'user interface' stamp: 'ck 1/17/2012 00:11:41.478'!
addLineFrom: first to: second segment: i color: aColor
	| position pointOffset |
	pointOffset := self canvasWidth / self displayedEntries.
	position := (i - 1) * pointOffset  + self canvasLeft.
	self addMorph: 
			(LineMorph 
				from: (position) @ (self canvasBottom - first)
				to: (position + pointOffset) @ (self canvasBottom - second)
				color: aColor  
				width: self lineWidth  ).! !

!CSAHistoryChart methodsFor: 'user interface' stamp: 'ck 1/16/2012 23:53:43.278'!
canvasBottom
	^ self bottom - self class canvasPadding! !

!CSAHistoryChart methodsFor: 'user interface' stamp: 'ck 1/16/2012 23:53:29.912'!
canvasHeight
	^ self height - (2 * self class canvasPadding)! !

!CSAHistoryChart methodsFor: 'user interface' stamp: 'ck 1/16/2012 23:55:02.804'!
canvasLeft
	^ self left + self class canvasPadding ! !

!CSAHistoryChart methodsFor: 'user interface' stamp: 'ck 1/17/2012 21:55:10.198'!
canvasRight
	^ self right - self class canvasPadding! !

!CSAHistoryChart methodsFor: 'user interface' stamp: 'ck 1/17/2012 00:48:00.258'!
canvasTop
	^ self top + self class canvasPadding ! !

!CSAHistoryChart methodsFor: 'user interface' stamp: 'ck 1/16/2012 23:53:35.302'!
canvasWidth
	^ self width - (2 * self class canvasPadding)! !

!CSAHistoryChart methodsFor: 'user interface' stamp: 'ck 1/16/2012 23:45:51.552'!
clear
	self 
		removeAllMorphs;
		resetMinMax

	! !

!CSAHistoryChart methodsFor: 'initialization' stamp: 'ck 1/16/2012 23:50:22.654'!
defaultBorderWidth
	^ 0! !

!CSAHistoryChart methodsFor: 'initialization' stamp: 'ck 1/17/2012 21:49:13.68'!
defaultBounds
	^ 0@0 corner: 200@100! !

!CSAHistoryChart methodsFor: 'initialization' stamp: 'ck 1/11/2012 17:20:48.005'!
defaultColor
	^ Color white! !

!CSAHistoryChart methodsFor: 'accessing' stamp: 'ck 1/13/2012 20:09:44.844'!
displayedEntries
	^ displayedEntries! !

!CSAHistoryChart methodsFor: 'accessing' stamp: 'ck 1/13/2012 20:09:44.818'!
displayedEntries: anInteger
	displayedEntries := anInteger ! !

!CSAHistoryChart methodsFor: 'accessing' stamp: 'ck 1/11/2012 19:42:23.868'!
entries
	^ self history entries  ! !

!CSAHistoryChart methodsFor: 'user interface' stamp: 'ck 1/17/2012 22:28:04.854'!
expandWidth: anInteger
	self width: (anInteger max: self class minimalWidth)
! !

!CSAHistoryChart methodsFor: 'accessing' stamp: 'ck 1/11/2012 19:41:35.81'!
history
	^ history! !

!CSAHistoryChart methodsFor: 'accessing' stamp: 'ck 1/11/2012 19:49:39.746'!
history: aResultHistory
	history := aResultHistory ! !

!CSAHistoryChart methodsFor: 'initialization' stamp: 'f.z 1/18/2012 18:51:37.331'!
initialize 
	super initialize.
	self 
		useRoundedCorners;
		borderColor: Color black;
		borderWidth: 1;
		displayedEntries: 30;
		lineWidth: 2;
		lineColors: self class defaultLineColors! !

!CSAHistoryChart methodsFor: 'accessing' stamp: 'ck 1/16/2012 23:43:49.588'!
lineColors
	^ lineColors! !

!CSAHistoryChart methodsFor: 'accessing' stamp: 'ck 1/16/2012 23:43:49.61'!
lineColors: aCollectionOfColors
	lineColors := aCollectionOfColors! !

!CSAHistoryChart methodsFor: 'accessing' stamp: 'ck 1/11/2012 19:50:57.104'!
lineWidth
	^ lineWidth! !

!CSAHistoryChart methodsFor: 'accessing' stamp: 'ck 1/11/2012 19:50:57.122'!
lineWidth: anObject
	lineWidth := anObject! !

!CSAHistoryChart methodsFor: 'accessing' stamp: 'ck 1/12/2012 13:40:12.796'!
max
	max 
		ifNil: [ 
			max := (self entries collect: [:entry | entry valueCollection max]) max].
	^ max! !

!CSAHistoryChart methodsFor: 'accessing' stamp: 'ck 1/12/2012 13:40:49.386'!
min
	min 
		ifNil: [ min := (self entries collect: [:entry | entry valueCollection min]) min].
	^ min! !

!CSAHistoryChart methodsFor: 'user interface' stamp: 'ck 1/17/2012 21:44:26.652'!
render
	self entries size > 2 
		ifTrue:
			[ self 
				renderLabels;
				lineColors: self entries first graphColors;
				renderGraphs ]! !

!CSAHistoryChart methodsFor: 'user interface' stamp: 'ck 1/17/2012 00:39:11.954'!
renderGraphs
	| end start |
	end := self entries size.
	start := 1 max: (self entries size - displayedEntries).
	(start to: end - 1) do:
		[:i | 	self 
				addGraphSegmentsFrom:  (self entries at: i) valueCollection
				to: (self entries at: i + 1) valueCollection
				as: i - start + 1]! !

!CSAHistoryChart methodsFor: 'user interface' stamp: 'ck 1/17/2012 21:47:38.612'!
renderLabels
	"rendering of labels for min and max"
	 | label |
	label := (StringMorph contents: self max asString)
			color: Color gray;
			yourself.
	label position: ((self canvasRight  - label width) @ self canvasTop ).
	self addMorphBack: label.
	label := (StringMorph contents: self min asString)
			color: Color gray;
			yourself.
	label position: (self canvasLeft @ (self canvasBottom - label height) ).
	self addMorphBack: label
		
! !

!CSAHistoryChart methodsFor: 'user interface' stamp: 'ck 1/16/2012 23:46:09.196'!
resetMinMax
	min := nil.
	max := nil

	! !

!CSAHistoryChart methodsFor: 'accessing' stamp: 'ck 1/17/2012 00:05:39.97'!
scalingFactor
	| min max |
	min := self min.
	max := self max.
	^ (min = max)
		ifTrue: [0]
		ifFalse: [self canvasHeight / (max - min)]! !

!CSAHistoryChart methodsFor: 'user interface' stamp: 'ck 1/17/2012 21:52:15.198'!
visualize: aCSAResultHistory
	self 
		history: aCSAResultHistory;
		clear;
		render! !

BorderedMorph subclass: #CSAMetricDisplay
	instanceVariableNames: 'titleMorph textMorph graphMorph metric'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-UI'!

!CSAMetricDisplay class methodsFor: 'constants' stamp: 'sk 12/21/2011 21:15:18.868'!
extent
	^ 150 @ 100! !

!CSAMetricDisplay class methodsFor: 'instance creation' stamp: 'ck 1/17/2012 21:40:46.684'!
withMetric: aMetric
	^ (self new)
		setMetric: aMetric;
		yourself ! !

!CSAMetricDisplay methodsFor: 'initialize-release' stamp: 'f.z 1/18/2012 18:47:17.027'!
createWidgets
	self
		titleMorph: TextMorph new;
		graphMorph: CSAHistoryChart new;
		textMorph: TextMorph new;
		addMorphBack: self titleMorph;
		addMorphBack: self graphMorph;
		addMorphBack: self textMorph! !

!CSAMetricDisplay methodsFor: 'initialize-release' stamp: 'ck 1/17/2012 21:22:38.166'!
defaultBorderColor
	^ Color gray darker! !

!CSAMetricDisplay methodsFor: 'initialize-release' stamp: 'ck 1/17/2012 21:22:44.822'!
defaultColor
	^ Color transparent! !

!CSAMetricDisplay methodsFor: 'initialize-release' stamp: 'ck 1/17/2012 21:29:33.042'!
dismiss
	self metric removeActionsWithReceiver: self  ! !

!CSAMetricDisplay methodsFor: 'initialize-release' stamp: 'ck 1/17/2012 21:27:12.062'!
graphMorph
	^ graphMorph! !

!CSAMetricDisplay methodsFor: 'initialize-release' stamp: 'ck 1/17/2012 21:27:05.252'!
graphMorph: aCSAGraphMorph
	graphMorph := aCSAGraphMorph ! !

!CSAMetricDisplay methodsFor: 'initialize-release' stamp: 'sk 12/22/2011 15:03:56.74'!
initialize
	super initialize.
	self
		initializeLayout;
		createWidgets    ! !

!CSAMetricDisplay methodsFor: 'initialize-release' stamp: 'sk 12/22/2011 15:59:00.487'!
initializeLayout
	self
		layoutPolicy: TableLayout new; 
		layoutProperties:
			(TableLayoutProperties new
				hResizing: #shrinkWrap;
				vResizing: #shrinkWrap;
				layoutInset: 2;
				yourself)! !

!CSAMetricDisplay methodsFor: 'initialize-release' stamp: 'ck 1/17/2012 21:27:32.756'!
metric
	^ metric! !

!CSAMetricDisplay methodsFor: 'initialize-release' stamp: 'ck 1/17/2012 21:27:56.336'!
metric: aCSAMetrc
	metric := aCSAMetrc ! !

!CSAMetricDisplay methodsFor: 'initialize-release' stamp: 'f.z 1/18/2012 18:30:20.084'!
setMetric: aCSAMetric
	self metric: aCSAMetric.
	self titleMorph contents: aCSAMetric longTitle.  
	self update.  
	self metric when: #valueChanged send: #update to: self
	! !

!CSAMetricDisplay methodsFor: 'initialize-release' stamp: 'ck 1/17/2012 21:23:14.246'!
textMorph
	^ textMorph! !

!CSAMetricDisplay methodsFor: 'initialize-release' stamp: 'ck 1/17/2012 21:23:23.018'!
textMorph: aTextMorph
	textMorph := aTextMorph
! !

!CSAMetricDisplay methodsFor: 'accessing' stamp: 'ck 1/17/2012 22:29:13.788'!
titleMorph
	^ titleMorph! !

!CSAMetricDisplay methodsFor: 'accessing' stamp: 'ck 1/17/2012 22:29:13.828'!
titleMorph: aStringMorph
	titleMorph := aStringMorph! !

!CSAMetricDisplay methodsFor: 'initialize-release' stamp: 'ck 1/17/2012 22:31:52.776'!
update
	self textMorph contents: self metric columnContents asString.
	self graphMorph expandWidth: self textMorph width.  
	self graphMorph visualize: self metric history! !

!CSAMetricDisplay methodsFor: 'initialize-release' stamp: 'sk 12/22/2011 15:00:15.746'!
wantsRoundedCorners
	^ true! !

MenuItemMorph subclass: #CSAMenuItem
	instanceVariableNames: 'checked'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-UI'!

!CSAMenuItem methodsFor: 'accessing' stamp: 'f.z 1/12/2012 12:22:40.227'!
checked
	^ checked! !

!CSAMenuItem methodsFor: 'accessing' stamp: 'f.z 1/18/2012 15:11:33.124'!
checked: aBoolean
	checked := aBoolean.
	self updateMarker
! !

!CSAMenuItem methodsFor: 'accessing' stamp: 'f.z 1/12/2012 12:31:33.797'!
contents: aString withMarkers: aBoolean inverse: inverse
	super contents: aString withMarkers: aBoolean inverse: inverse.
	self updateMarker! !

!CSAMenuItem methodsFor: 'initialization' stamp: 'f.z 1/18/2012 15:41:00.268'!
initialize
	super initialize.
	self checked: false! !

!CSAMenuItem methodsFor: 'accessing' stamp: 'f.z 1/12/2012 12:24:32.188'!
markerImage
	^ self checked
		ifTrue: [ self onImage ]
		ifFalse: [ self offImage ]! !

!CSAMenuItem methodsFor: 'events' stamp: 'f.z 1/18/2012 15:11:47.54'!
mouseUp: anEvent
	super mouseUp: anEvent.
	self checked: self checked not! !

!CSAMenuItem methodsFor: 'updating' stamp: 'f.z 1/12/2012 12:25:04.917'!
updateMarker
	| marker |
	marker := ImageMorph new image: self markerImage.
	marker position: self left @ (self top + 2).
	self
		removeAllMorphs;
		addMorphFront: marker! !

SystemWindow subclass: #CSACoDriver
	instanceVariableNames: 'dispatcher menuBar metrics scrollPane table metricHistories'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-UI'!

!CSACoDriver class methodsFor: 'magic numbers' stamp: 'f.z 1/12/2012 11:25:51.603'!
baseLabel
	^ 'CoDriver'! !

!CSACoDriver class methodsFor: 'magic numbers' stamp: 'f.z 1/9/2012 18:05:25.577'!
initialLabel
	^ self baseLabel, ' <<no class source>>'! !

!CSACoDriver class methodsFor: 'instance creation' stamp: 'f.z 1/9/2012 18:04:47.593'!
start
	^ (self labelled: self initialLabel)
		openInWorld;
		yourself! !

!CSACoDriver class methodsFor: 'instance creation' stamp: 'ck 1/9/2012 21:24:28.82'!
startWatching: aWildcardString
	^ (self labelled: self initialLabel)
		classSourceFrom: aWildcardString;  
		openInWorld;
		yourself! !

!CSACoDriver methodsFor: 'initialization' stamp: 'f.z 1/9/2012 12:48:44.17'!
addMenuEntries
	self menuBar 
		add: 'File' subMenu: self createFileMenu;
		add: 'Columns' subMenu: self createColumnsMenu! !

!CSACoDriver methodsFor: 'updating' stamp: 'f.z 1/18/2012 15:42:35.052'!
addMetric: aMetricClass
	| newMetric |
	(self metrics anySatisfy: [ :metric | metric class = aMetricClass ])
		ifTrue: [ ^ self ].
	newMetric := self dispatcher addMetricWhenMissing: aMetricClass.
	self metrics add: newMetric.
	self table addColumnFor: newMetric! !

!CSACoDriver methodsFor: 'setup' stamp: 'f.z 1/12/2012 11:21:51.189'!
classSourceFrom: aWildcardString
	aWildcardString ifNil: [ ^ self ].
	self
		setLabel: self class baseLabel, ' for ', aWildcardString;
		setupDispatcherWith: (CSACategoryClassSource for: aWildcardString)! !

!CSACoDriver methodsFor: 'initialization' stamp: 'f.z 1/18/2012 15:28:08.172'!
createColumnsMenu
	| menu |
	menu := CSAMenu for: self.
	self displayableMetrics do: 
		[ :metric | menu addMetric: metric selector: #toggleColumnFor: ].
	^ menu! !

!CSACoDriver methodsFor: 'initialization' stamp: 'f.z 1/9/2012 12:52:33.522'!
createFileMenu
	^ (DockingBarMenuMorph new)
		add: 'Set Class Source' target: self selector: #promptForClassSource;
		addLine;
		add: 'Close' target: self selector: #closeBoxHit;
		yourself! !

!CSACoDriver methodsFor: 'initialization' stamp: 'f.z 1/9/2012 18:58:45.887'!
createMetricTable
	self
		table: CSATable new;
		scrollPane: ScrollPane new.
	self scrollPane scroller addMorph: self table.
	^ self scrollPane! !

!CSACoDriver methodsFor: 'open/close' stamp: 'f.z 1/9/2012 13:15:08.457'!
delete
	super delete.
	self dispatcher dismiss! !

!CSACoDriver methodsFor: 'accessing' stamp: 'f.z 1/9/2012 12:57:00.969'!
dispatcher
	^ dispatcher! !

!CSACoDriver methodsFor: 'accessing' stamp: 'f.z 1/9/2012 12:57:00.986'!
dispatcher: anEventDispatcher
	dispatcher := anEventDispatcher
! !

!CSACoDriver methodsFor: 'accessing' stamp: 'f.z 1/11/2012 21:25:03.083'!
displayableMetrics
	"Answers all Subclasses of CSAMetric that do not have additional subclasses. "
	^ (CSAMetric allSubclasses select: [ :subClass | subClass allSubclasses isEmpty ])
		sort: [ :first :second | first longTitle <= second longTitle ]! !

!CSACoDriver methodsFor: 'initialization' stamp: 'f.z 1/9/2012 15:32:10.928'!
initialize
	super initialize.
	self 
		initializeMembers;
		setupMenuBar;
		setupMetricTable! !

!CSACoDriver methodsFor: 'initialization' stamp: 'f.z 1/18/2012 16:08:23.785'!
initializeMembers
	self 
		dispatcher: (CSAEventDispatcher for: CSAEmptyClassSource new);
		metrics: OrderedCollection new;
		menuBar: DockingBarMorph new;
		table: CSATable new! !

!CSACoDriver methodsFor: 'accessing' stamp: 'f.z 1/9/2012 12:21:17.202'!
menuBar
	^ menuBar! !

!CSACoDriver methodsFor: 'accessing' stamp: 'f.z 1/9/2012 12:21:17.219'!
menuBar: aDockingBarMorph
	menuBar := aDockingBarMorph
! !

!CSACoDriver methodsFor: 'layout' stamp: 'f.z 1/9/2012 12:23:04.306'!
menuBarFrame
	^ LayoutFrame 
		fractions: (0@0 corner: 1@0)
		offsets: (0@0 corner: 0@20)! !

!CSACoDriver methodsFor: 'accessing' stamp: 'f.z 1/9/2012 13:06:51.201'!
metrics
	^ metrics! !

!CSACoDriver methodsFor: 'accessing' stamp: 'f.z 1/9/2012 13:06:51.213'!
metrics: aCollection
	metrics := aCollection
! !

!CSACoDriver methodsFor: 'setup' stamp: 'f.z 1/9/2012 12:55:59.498'!
promptForClassSource
	self classSourceFrom: (SwaInputDialog getTextWithTitle: 'Package Filter' label: '')! !

!CSACoDriver methodsFor: 'updating' stamp: 'f.z 1/9/2012 19:15:32.264'!
refreshLayout
	self scrollPane
		extent: self table extent;
		hideOrShowScrollBars! !

!CSACoDriver methodsFor: 'updating' stamp: 'f.z 1/18/2012 16:00:44.97'!
removeAllMetrics
	self metrics copy do: [ :metric | self removeMetric: metric class ]! !

!CSACoDriver methodsFor: 'updating' stamp: 'f.z 1/18/2012 15:43:46.084'!
removeMetric: aMetricClass
	(self metrics noneSatisfy: [ :metric | metric class = aMetricClass ])
		ifTrue: [ ^ self ].
	self metrics: (self metrics reject: [ :metric | metric class = aMetricClass ]).
	self dispatcher removeMetric: aMetricClass.
	self table removeColumnFor: aMetricClass! !

!CSACoDriver methodsFor: 'accessing' stamp: 'f.z 1/9/2012 18:31:56.225'!
scrollPane
	^ scrollPane! !

!CSACoDriver methodsFor: 'accessing' stamp: 'f.z 1/9/2012 18:31:56.259'!
scrollPane: aScrollPane
	scrollPane := aScrollPane
! !

!CSACoDriver methodsFor: 'setup' stamp: 'f.z 1/12/2012 11:22:27.829'!
setupDispatcherWith: aClassSource
	self dispatcher classSource: aClassSource! !

!CSACoDriver methodsFor: 'initialization' stamp: 'f.z 1/9/2012 15:31:56.4'!
setupMenuBar
	self
		addMorph: self menuBar fullFrame: self menuBarFrame;
		addMenuEntries! !

!CSACoDriver methodsFor: 'initialization' stamp: 'f.z 1/18/2012 18:43:29.811'!
setupMetricTable
	self addMorph: self createMetricTable fullFrame: self tableFrame! !

!CSACoDriver methodsFor: 'accessing' stamp: 'f.z 1/9/2012 15:30:26.385'!
table
	^ table! !

!CSACoDriver methodsFor: 'accessing' stamp: 'f.z 1/9/2012 15:30:26.407'!
table: aTable
	table := aTable
! !

!CSACoDriver methodsFor: 'layout' stamp: 'f.z 1/9/2012 15:28:28.322'!
tableFrame
	^ LayoutFrame 
		fractions: (0@0 corner: 1@1)
		offsets: (0@20 corner: 0@0)! !

!CSACoDriver methodsFor: 'updating' stamp: 'ck 1/9/2012 21:00:15.62'!
toggleColumnFor: aMetricClass
	(self metrics anySatisfy: [ :metric | metric class = aMetricClass ])
		ifTrue: [ self removeMetric: aMetricClass ]
		ifFalse: [ self addMetric: aMetricClass ].
	self refreshLayout! !

ParseNodeVisitor subclass: #CSACallCollector
	instanceVariableNames: 'selfCalls superCalls receivers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Util'!

!CSACallCollector class methodsFor: 'collecting' stamp: 'sk 1/16/2012 19:11:32.043'!
collectSelfAndSuperCallsFrom: aCompiledMethod
	| collector |
	collector := self new.
	collector collectFrom: aCompiledMethod.
	^ collector selfCalls copy union: collector superCalls! !

!CSACallCollector class methodsFor: 'collecting' stamp: 'sk 1/16/2012 19:04:54.239'!
collectSelfCallsFrom: aCompiledMethod
	^ (self new 
		collectFrom: aCompiledMethod;
		yourself) selfCalls copy
		! !

!CSACallCollector class methodsFor: 'collecting' stamp: 'sk 1/16/2012 19:00:33.833'!
collectSuperCallsFrom: aCompiledMethod
	^ (self new collectFrom: aCompiledMethod) superCalls copy
		! !

!CSACallCollector methodsFor: 'initialize-release' stamp: 'sk 1/16/2012 18:56:16.395'!
clear
	self
		selfCalls: Set new;
		superCalls: Set new;
		receivers: Stack new! !

!CSACallCollector methodsFor: 'collecting' stamp: 'sk 1/16/2012 19:05:21.059'!
collectFrom: aCompiledMethod
	self visitMethodNode: aCompiledMethod decompile! !

!CSACallCollector methodsFor: 'initialize-release' stamp: 'sk 1/16/2012 18:53:15.085'!
initialize
	super initialize.
	self clear! !

!CSACallCollector methodsFor: 'inspecting' stamp: 'sk 1/16/2012 18:54:34.858'!
isSelfNode: aNode
	^ aNode isVariableNode and: [aNode name = 'self']! !

!CSACallCollector methodsFor: 'inspecting' stamp: 'sk 1/16/2012 18:56:34.836'!
isSuperNode: aNode
	^ aNode isVariableNode and: [aNode name = 'super']! !

!CSACallCollector methodsFor: 'accessing' stamp: 'sk 1/16/2012 17:47:01.506'!
receivers
	^ receivers! !

!CSACallCollector methodsFor: 'accessing' stamp: 'sk 1/16/2012 17:47:01.518'!
receivers: aStack
	receivers := aStack
! !

!CSACallCollector methodsFor: 'accessing' stamp: 'sk 1/16/2012 17:36:32.503'!
selfCalls
	^ selfCalls! !

!CSACallCollector methodsFor: 'accessing' stamp: 'sk 1/16/2012 17:36:32.517'!
selfCalls: aSet
	selfCalls := aSet
! !

!CSACallCollector methodsFor: 'accessing' stamp: 'sk 1/16/2012 18:56:13.976'!
superCalls
	^ superCalls! !

!CSACallCollector methodsFor: 'accessing' stamp: 'sk 1/16/2012 18:56:13.997'!
superCalls: aSet
	superCalls := aSet
! !

!CSACallCollector methodsFor: 'visiting' stamp: 'sk 1/16/2012 18:50:50.774'!
visitCascadeNode: aCascadeNode
	self receivers push: aCascadeNode receiver.
	super visitCascadeNode: aCascadeNode.
	self receivers pop! !

!CSACallCollector methodsFor: 'visiting' stamp: 'sk 1/16/2012 18:57:23.252'!
visitMessageNode: aMessageNode
	(self isSelfNode: aMessageNode receiver) 
		ifTrue: [self selfCalls add: aMessageNode selector key].
	(self isSuperNode: aMessageNode receiver)
		ifTrue: [self superCalls add: aMessageNode selector key].  
	super visitMessageNode: aMessageNode.! !

!CSACallCollector methodsFor: 'visiting' stamp: 'sk 1/16/2012 18:57:50.269'!
visitMessageNodeInCascade: aMessageNode
	(self isSelfNode: self receivers top)
		ifTrue: [self selfCalls add: aMessageNode selector key].  
	(self isSuperNode: self receivers top)
		ifTrue: [self superCalls add: aMessageNode selector key].  
	super visitMessageNodeInCascade: aMessageNode! !

ParseNodeVisitor subclass: #CSAMessageChainingVisitor
	instanceVariableNames: 'max'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Util'!

!CSAMessageChainingVisitor class methodsFor: 'chaining depth' stamp: 'sk 1/17/2012 18:01:06.098'!
chainingDepthOf: aCompiledMethod
	^ self new
		visitMethodNode: aCompiledMethod methodNode;
		max! !

!CSAMessageChainingVisitor methodsFor: 'accessing' stamp: 'sk 1/17/2012 17:40:44.252'!
chainReceivers
	^ chainReceivers! !

!CSAMessageChainingVisitor methodsFor: 'accessing' stamp: 'sk 1/17/2012 17:40:44.962'!
chainReceivers: aStack
	chainReceivers := aStack
! !

!CSAMessageChainingVisitor methodsFor: 'chaining depth' stamp: 'sk 1/17/2012 22:07:03.053'!
determineDepthOf: aParseNode
	"self halt."
	(self hasReceiver: aParseNode) ifFalse: [ ^ 0 ].
	^  (self determineDepthOf: aParseNode receiver) + 1! !

!CSAMessageChainingVisitor methodsFor: 'chaining depth' stamp: 'sk 1/17/2012 22:07:46.978'!
hasReceiver: aParseNode
	^ aParseNode isNil not
		and: [ aParseNode respondsTo: #receiver ] ! !

!CSAMessageChainingVisitor methodsFor: 'initialize-release' stamp: 'sk 1/17/2012 18:06:34.924'!
initialize
	super initialize.
	self
		max: 0;
		chainReceivers: Stack new
	! !

!CSAMessageChainingVisitor methodsFor: 'accessing' stamp: 'sk 1/17/2012 17:36:04.102'!
max
	^ max! !

!CSAMessageChainingVisitor methodsFor: 'accessing' stamp: 'sk 1/17/2012 17:36:04.108'!
max: anInteger
	max := anInteger
! !

!CSAMessageChainingVisitor methodsFor: 'visiting' stamp: 'sk 1/17/2012 18:17:20.801'!
updateMax: anInteger
	self max: (anInteger max: self max)! !

!CSAMessageChainingVisitor methodsFor: 'visiting' stamp: 'sk 1/17/2012 22:04:13.495'!
visitCascadeNode: aCascadeNode
	self updateMax: (self determineDepthOf: aCascadeNode).  
	super visitCascadeNode: aCascadeNode! !

!CSAMessageChainingVisitor methodsFor: 'visiting' stamp: 'sk 1/17/2012 22:04:09.262'!
visitMessageNode: aMessageNode
	self updateMax: (self determineDepthOf: aMessageNode).  
	super visitMessageNode: aMessageNode.  ! !

ParseNodeVisitor subclass: #CSANestingBlockVisitor
	instanceVariableNames: 'current max'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Util'!

!CSANestingBlockVisitor methodsFor: 'accessing' stamp: 'ck 1/16/2012 16:58:03.83'!
current
	^ current! !

!CSANestingBlockVisitor methodsFor: 'accessing' stamp: 'ck 1/16/2012 16:58:03.872'!
current: anInteger
	current := anInteger
! !

!CSANestingBlockVisitor methodsFor: 'as yet unclassified' stamp: 'sk 1/17/2012 23:17:28.584'!
initialize
	super initialize.
	self 
		current: 0;
		max: 0! !

!CSANestingBlockVisitor methodsFor: 'accessing' stamp: 'ck 1/16/2012 16:58:03.902'!
max
	^ max! !

!CSANestingBlockVisitor methodsFor: 'accessing' stamp: 'ck 1/16/2012 16:58:03.934'!
max: anInteger
	max := anInteger
! !

!CSANestingBlockVisitor methodsFor: 'as yet unclassified' stamp: 'ck 1/16/2012 17:21:02.588'!
visitBlockNode: aBlockNode
	self current: self current + 1.
	self max: (self current max: self max).
	super visitBlockNode: aBlockNode.
	self current: self current - 1! !

Object subclass: #CSAClassSource
	uses: TCSAEventHandler @ {#adjust:->#handle:}
	instanceVariableNames: 'classes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA'!

CSAClassSource class
	uses: TCSAEventHandler classTrait
	instanceVariableNames: ''!

CSAClassSource subclass: #CSACategoryClassSource
	instanceVariableNames: 'wildcard'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA'!

!CSACategoryClassSource class methodsFor: 'instance creation' stamp: 'sk 12/5/2011 12:03:00.362'!
for: aString
	^ self new
		wildcard: aString;
		yourself  ! !

!CSACategoryClassSource methodsFor: 'accessing' stamp: 'sk 12/17/2011 19:20:16.006'!
contains: aClass
	^ self containsCategory: aClass theNonMetaClass category  ! !

!CSACategoryClassSource methodsFor: 'accessing' stamp: 'sk 12/22/2011 22:00:58.66'!
containsCategory: aSymbol
	^ aSymbol
		ifNil: [ false ]
		ifNotNil: [ self wildcard match: aSymbol ]  ! !

!CSACategoryClassSource methodsFor: 'class events' stamp: 'sk 12/17/2011 19:31:21.333'!
recategorizedClass: aCSAClassRecategorizedEvent
	| isContained wasContained |
	isContained := self containsCategory: aCSAClassRecategorizedEvent newCategory.
	wasContained := self containsCategory: aCSAClassRecategorizedEvent oldCategory.
	(isContained & wasContained) ifTrue:
		[ ^ aCSAClassRecategorizedEvent ] .
	(isContained & wasContained not) ifTrue:
		[ ^ CSAClassAddedEvent for: aCSAClassRecategorizedEvent movedClass].
	(isContained not & wasContained) ifTrue:   
		[ ^ CSAClassRemovedEvent for: aCSAClassRecategorizedEvent movedClass].
	^ nil! !

!CSACategoryClassSource methodsFor: 'class events' stamp: 'sk 1/6/2012 22:07:41.401'!
renamedClass: aCSAClassRecategorizedEvent
	^ (self contains: aCSAClassRecategorizedEvent renamedClass)
		ifTrue: [ aCSAClassRecategorizedEvent ]
		ifFalse: [ nil ]    ! !

!CSACategoryClassSource methodsFor: 'accessing' stamp: 'sk 12/5/2011 11:59:27.41'!
wildcard
	^ wildcard! !

!CSACategoryClassSource methodsFor: 'accessing' stamp: 'sk 12/5/2011 11:59:27.438'!
wildcard: aString
	wildcard := aString
! !

!CSAClassSource methodsFor: 'class events' stamp: 'sk 12/17/2011 19:27:44.316'!
addedClass: aCSAClassAddedEvent
	^ (self contains: aCSAClassAddedEvent newClass)
		ifTrue: [ aCSAClassAddedEvent ]
		ifFalse: [ nil ]    ! !

!CSAClassSource methodsFor: 'method events' stamp: 'sk 12/17/2011 19:28:30.432'!
addedMethod: aCSAMethodAddedEvent
	^ (self contains: aCSAMethodAddedEvent method methodClass)
		ifTrue: [ aCSAMethodAddedEvent ]
		ifFalse: [ nil ]    ! !

!CSAClassSource methodsFor: 'accessing' stamp: 'f.z 1/5/2012 12:47:41.023'!
allClasses
	^ self classes flatCollect: [ :nonMetaClass | self allClassesFor: nonMetaClass ]! !

!CSAClassSource methodsFor: 'accessing' stamp: 'f.z 1/5/2012 12:48:31.007'!
allClassesFor: aNonMetaClass
	^ OrderedCollection with: aNonMetaClass with: aNonMetaClass class! !

!CSAClassSource methodsFor: 'accessing' stamp: 'f.z 1/5/2012 12:52:30.929'!
classes
	^ (Smalltalk allClasses select: [ :class | self contains: class ]) asOrderedCollection! !

!CSAClassSource methodsFor: 'class events' stamp: 'sk 1/6/2012 23:22:49.118'!
commentedClass: aCSAClassCommentedEvent
	^ (self contains: aCSAClassCommentedEvent commentedClass)
		ifTrue: [ aCSAClassCommentedEvent ]
		ifFalse: [ nil ]    ! !

!CSAClassSource methodsFor: 'accessing' stamp: 'sk 12/6/2011 01:46:20.115'!
contains: aClass
"Tells whether this class source contains the given class."
	self subclassResponsibility! !

!CSAClassSource methodsFor: 'general handling' stamp: 'sk 1/6/2012 23:22:01.116'!
doDefaultHandlingFor: aCSAEvent
	^ nil! !

!CSAClassSource methodsFor: 'class events' stamp: 'sk 1/6/2012 23:27:08.12'!
modifiedClass: aCSAClassModifiedEvent
	^ (self contains: aCSAClassModifiedEvent newClass)
		ifTrue: [ aCSAClassModifiedEvent ]
		ifFalse: [ nil ]! !

!CSAClassSource methodsFor: 'method events' stamp: 'sk 12/17/2011 19:28:10.818'!
modifiedMethod: aCSAMethodChangedEvent
	^ (self contains: aCSAMethodChangedEvent method methodClass)
		ifTrue: [ aCSAMethodChangedEvent ]
		ifFalse: [ nil ]    ! !

!CSAClassSource methodsFor: 'method events' stamp: 'sk 1/6/2012 23:24:08.725'!
recategorizedMethod: aCSAMethodRecategorizedEvent
	^ (self contains: aCSAMethodRecategorizedEvent method methodClass)
		ifTrue: [ aCSAMethodRecategorizedEvent ]
		ifFalse: [ nil ]! !

!CSAClassSource methodsFor: 'class events' stamp: 'sk 12/17/2011 19:27:52.812'!
removedClass: aCSAClassRemovedEvent
	^ (self contains: aCSAClassRemovedEvent removedClass)
		ifTrue: [ aCSAClassRemovedEvent ]
		ifFalse: [ nil ]    ! !

!CSAClassSource methodsFor: 'method events' stamp: 'sk 12/17/2011 19:28:20.197'!
removedMethod: aCSAMethodRemovedEvent
	^ (self contains: aCSAMethodRemovedEvent method methodClass)
		ifTrue: [ aCSAMethodRemovedEvent ]
		ifFalse: [ nil ]    ! !

CSAClassSource subclass: #CSAEmptyClassSource
	uses: TCSAEventHandler @ {#adjust:->#handle:}
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA'!

CSAEmptyClassSource class
	uses: TCSAEventHandler classTrait
	instanceVariableNames: ''!

!CSAEmptyClassSource methodsFor: 'accessing' stamp: 'f.z 1/9/2012 13:03:18.354'!
contains: aClass
	^ false! !

!CSAEmptyClassSource methodsFor: 'general handling' stamp: 'f.z 1/12/2012 11:42:03.524'!
doDefaultHandlingFor: aCSAEvent
	^ nil! !

CSAClassSource subclass: #CSASingleClassSource
	instanceVariableNames: 'containedClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA'!

!CSASingleClassSource class methodsFor: 'instance creation' stamp: 'sk 12/4/2011 23:23:46.152'!
for: aClass
	^ self new
		containedClass: aClass;
		yourself  ! !

!CSASingleClassSource methodsFor: 'accessing' stamp: 'sk 12/4/2011 22:42:31.441'!
containedClass
	^ containedClass! !

!CSASingleClassSource methodsFor: 'accessing' stamp: 'sk 12/4/2011 22:42:52.644'!
containedClass: aClass
	containedClass := aClass.! !

!CSASingleClassSource methodsFor: 'accessing' stamp: 'f.z 1/2/2012 10:21:42.556'!
contains: aClass
	^ aClass = containedClass! !

CSAClassSource subclass: #CSAWildcardClassSource
	instanceVariableNames: 'wildcard'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA'!

!CSAWildcardClassSource class methodsFor: 'instance creation' stamp: 'sk 12/5/2011 00:50:39.949'!
for: aString
	^ (self new)
		wildcard: aString;
		yourself   ! !

!CSAWildcardClassSource methodsFor: 'matching' stamp: 'sk 12/5/2011 13:09:38.033'!
contains: aClass
	^ self wildcard match: aClass asString! !

!CSAWildcardClassSource methodsFor: 'accessing' stamp: 'sk 12/5/2011 00:18:57.184'!
wildcard
	^ wildcard! !

!CSAWildcardClassSource methodsFor: 'accessing' stamp: 'sk 12/5/2011 00:18:57.207'!
wildcard: aString
	wildcard := aString 
! !

Object subclass: #CSACounter
	instanceVariableNames: 'dictionary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Util'!

!CSACounter methodsFor: 'counting' stamp: 'sk 1/17/2012 20:41:40.972'!
- aCSACounter
	| allItems result |
	result := CSACounter new.
	allItems := Set new.
	allItems addAll: self items.
	allItems addAll: aCSACounter items.
	allItems do:
		[ :item | | difference |
		difference := (self at: item) - (aCSACounter at: item).
		difference isZero ifFalse: [ result at: item set: difference ] ].
	^ result! !

!CSACounter methodsFor: 'counting' stamp: 'sk 1/17/2012 19:02:03.499'!
at: anObject
	^ self dictionary at: anObject ifAbsent: [ 0 ]! !

!CSACounter methodsFor: 'counting' stamp: 'sk 1/17/2012 19:05:15.273'!
at: anObject set: aNumber
	self dictionary at: anObject put: aNumber! !

!CSACounter methodsFor: 'counting' stamp: 'sk 1/17/2012 19:10:34.79'!
count: anObject
	self increase: anObject by: 1! !

!CSACounter methodsFor: 'counting' stamp: 'sk 1/17/2012 19:10:46.142'!
countAll: aCollection
	aCollection do: [ :each | self count: each ]! !

!CSACounter methodsFor: 'counting' stamp: 'sk 1/17/2012 19:01:12.199'!
decrease: anObject by: aNumber
	self increase: anObject by: aNumber negated  ! !

!CSACounter methodsFor: 'counting' stamp: 'sk 1/17/2012 19:29:44.011'!
decreaseAll: aCSACounter
	aCSACounter itemsAndCountsDo: 
		[ :item :count | self increase: item by: count ]! !

!CSACounter methodsFor: 'accessing' stamp: 'sk 1/17/2012 18:59:41.275'!
dictionary
	^ dictionary! !

!CSACounter methodsFor: 'accessing' stamp: 'sk 1/17/2012 18:59:41.289'!
dictionary: aDictionary
	dictionary := aDictionary
! !

!CSACounter methodsFor: 'counting' stamp: 'sk 1/17/2012 19:41:41.061'!
discount: anObject
	self decrease: anObject by: 1! !

!CSACounter methodsFor: 'counting' stamp: 'sk 1/17/2012 19:41:50.705'!
discountAll: aCollection
	aCollection do: [ :each | self discount: each ]! !

!CSACounter methodsFor: 'counting' stamp: 'sk 1/17/2012 19:18:39.466'!
increase: anObject by: aNumber
	self dictionary at: anObject put: (self at: anObject) + aNumber! !

!CSACounter methodsFor: 'counting' stamp: 'sk 1/17/2012 19:29:38.732'!
increaseAll: aCSACounter
	aCSACounter itemsAndCountsDo: 
		[ :item :count | self increase: item by: count ]! !

!CSACounter methodsFor: 'initialize-release' stamp: 'sk 1/17/2012 18:59:57.398'!
initialize
	super initialize.
	self dictionary: Dictionary new      ! !

!CSACounter methodsFor: 'iterating' stamp: 'sk 1/17/2012 19:04:01.583'!
items
	^ self dictionary keys! !

!CSACounter methodsFor: 'iterating' stamp: 'sk 1/17/2012 19:04:20.323'!
itemsAndCountsDo: aBlock
	^ self dictionary keysAndValuesDo: aBlock  ! !

!CSACounter methodsFor: 'counting' stamp: 'sk 1/17/2012 19:54:48.838'!
negate
	| negatedDictionary |
	negatedDictionary := Dictionary new.
	^ self 
		itemsAndCountsDo: [ :item :count | negatedDictionary at: item put: count negated ];
		dictionary: negatedDictionary;
		yourself! !

!CSACounter methodsFor: 'counting' stamp: 'sk 1/17/2012 20:04:53.605'!
negated
	| negatedCounter |
	negatedCounter := CSACounter new.
	self itemsAndCountsDo: [ :item :count | negatedCounter at: item set: count negated ].
	^ negatedCounter! !

Object subclass: #CSAEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Events'!

!CSAEvent commentStamp: 'sk 1/6/2012 19:21:57.405' prior: 0!
I represent any state-change of the system, such as removed methods or renamed classes.
My subclasses are responsible for the concrete changes.
I use double-dispatch: call accept: on me and I will send you a message corresponding to my state-change.
!

CSAEvent subclass: #CSAClassAddedEvent
	instanceVariableNames: 'newClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Events'!

!CSAClassAddedEvent commentStamp: 'sk 1/6/2012 19:47:01.669' prior: 0!
I represent the state change where a class has been added to the system.!

!CSAClassAddedEvent class methodsFor: 'instance creation' stamp: 'sk 12/17/2011 17:55:44.591'!
for: aClass
	^ self new
		newClass: aClass;
		yourself 
	! !

!CSAClassAddedEvent class methodsFor: 'instance creation' stamp: 'sk 12/17/2011 19:24:44.96'!
forSystemEvent: anAddedEvent
	^ self for: anAddedEvent item
	! !

!CSAClassAddedEvent methodsFor: 'visitor' stamp: 'sk 12/17/2011 19:29:30.024'!
accept: aTCSAEventHandler
	^ aTCSAEventHandler addedClass: self! !

!CSAClassAddedEvent methodsFor: 'accessing' stamp: 'sk 12/16/2011 15:25:53.415'!
newClass
	^ newClass! !

!CSAClassAddedEvent methodsFor: 'accessing' stamp: 'sk 12/16/2011 15:25:53.436'!
newClass: aClass
	newClass := aClass
! !

!CSAClassAddedEvent methodsFor: 'printing' stamp: 'sk 1/6/2012 23:11:57.023'!
printEventInformationOn: aStream
	aStream nextPutAll: self newClass asString! !

CSAEvent subclass: #CSAClassCommentedEvent
	instanceVariableNames: 'commentedClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Events'!

!CSAClassCommentedEvent class methodsFor: 'instance creation' stamp: 'sk 1/6/2012 19:42:01.898'!
forSystemEvent: aCommentedEvent
	^ self new
		commentedClass: aCommentedEvent item;
		yourself  
	! !

!CSAClassCommentedEvent methodsFor: 'visitor' stamp: 'sk 1/6/2012 19:51:04.25'!
accept: aTCSAEventHandler
	^ aTCSAEventHandler commentedClass: self! !

!CSAClassCommentedEvent methodsFor: 'accessing' stamp: 'sk 1/6/2012 19:44:45.87'!
commentedClass
	^ commentedClass! !

!CSAClassCommentedEvent methodsFor: 'accessing' stamp: 'sk 1/6/2012 19:44:45.92'!
commentedClass: aClass
	commentedClass := aClass
! !

!CSAClassCommentedEvent methodsFor: 'printing' stamp: 'sk 1/6/2012 19:54:39.403'!
printEventInformationOn: aStream
	aStream nextPutAll: self commentedClass asString! !

CSAEvent subclass: #CSAClassModifiedEvent
	instanceVariableNames: 'newClass oldClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Events'!

!CSAClassModifiedEvent class methodsFor: 'instance creation' stamp: 'sk 12/17/2011 16:00:02.219'!
forSystemEvent: anEvent
	^ self new
		oldClass: anEvent oldItem;
		newClass: anEvent item;
		yourself        ! !

!CSAClassModifiedEvent methodsFor: 'visitor' stamp: 'sk 12/17/2011 15:58:59.26'!
accept: aTCSAEventHandler
	^ aTCSAEventHandler modifiedClass: self! !

!CSAClassModifiedEvent methodsFor: 'accessing' stamp: 'sk 12/17/2011 15:57:28.295'!
newClass
	^ newClass! !

!CSAClassModifiedEvent methodsFor: 'accessing' stamp: 'sk 12/17/2011 15:57:28.376'!
newClass: aClass
	newClass := aClass
! !

!CSAClassModifiedEvent methodsFor: 'accessing' stamp: 'sk 12/17/2011 15:57:28.378'!
oldClass
	^ oldClass! !

!CSAClassModifiedEvent methodsFor: 'accessing' stamp: 'sk 12/17/2011 15:57:28.395'!
oldClass: aClass
	oldClass := aClass
! !

!CSAClassModifiedEvent methodsFor: 'printing' stamp: 'ck 1/5/2012 18:08:49.316'!
printEventInformationOn: aStream
	aStream nextPutAll: self oldClass name, ' -> ', self newClass name! !

CSAEvent subclass: #CSAClassRecategorizedEvent
	instanceVariableNames: 'movedClass oldCategory newCategory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Events'!

!CSAClassRecategorizedEvent commentStamp: 'sk 1/6/2012 19:55:29.701' prior: 0!
I represent the state change where a class has been recategorized.!

!CSAClassRecategorizedEvent class methodsFor: 'instance creation' stamp: 'sk 12/21/2011 22:37:55.545'!
forSystemEvent: aRecategorizedEvent
	^ self new
		oldCategory: aRecategorizedEvent oldCategory;
		newCategory: aRecategorizedEvent itemCategory;
		movedClass: aRecategorizedEvent item;
		yourself  ! !

!CSAClassRecategorizedEvent methodsFor: 'accessing' stamp: 'sk 12/17/2011 16:09:50.735'!
accept: aTCSEventHandler
	^ aTCSEventHandler recategorizedClass: self   ! !

!CSAClassRecategorizedEvent methodsFor: 'accessing' stamp: 'sk 12/17/2011 16:07:50.962'!
movedClass
	^ movedClass! !

!CSAClassRecategorizedEvent methodsFor: 'accessing' stamp: 'sk 12/17/2011 16:07:50.976'!
movedClass: aClass
	movedClass := aClass
! !

!CSAClassRecategorizedEvent methodsFor: 'accessing' stamp: 'sk 12/17/2011 16:07:50.997'!
newCategory
	^ newCategory! !

!CSAClassRecategorizedEvent methodsFor: 'accessing' stamp: 'sk 12/17/2011 16:07:51.002'!
newCategory: aSymbol
	newCategory := aSymbol
! !

!CSAClassRecategorizedEvent methodsFor: 'accessing' stamp: 'sk 12/17/2011 16:07:50.983'!
oldCategory
	^ oldCategory! !

!CSAClassRecategorizedEvent methodsFor: 'accessing' stamp: 'sk 12/17/2011 16:07:50.99'!
oldCategory: aSymbol
	oldCategory := aSymbol
! !

!CSAClassRecategorizedEvent methodsFor: 'printing' stamp: 'sk 1/6/2012 21:43:00.213'!
printEventInformationOn: aStream
	aStream nextPutAll: self movedClass asString, ': ', self oldCategory asString, ' -> ', self newCategory asString! !

CSAEvent subclass: #CSAClassRemovedEvent
	instanceVariableNames: 'removedClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Events'!

!CSAClassRemovedEvent class methodsFor: 'instance creation' stamp: 'sk 12/17/2011 17:53:19.271'!
for: aClass
	^ self new
		removedClass: aClass;
		yourself ! !

!CSAClassRemovedEvent class methodsFor: 'instance creation' stamp: 'sk 12/17/2011 19:41:19.118'!
forSystemEvent: aRemovedEvent
	^ self for: aRemovedEvent item! !

!CSAClassRemovedEvent methodsFor: 'visitor' stamp: 'sk 12/17/2011 19:22:22.471'!
accept: aTCSAEventHandler
	^ aTCSAEventHandler removedClass: self    ! !

!CSAClassRemovedEvent methodsFor: 'printing' stamp: 'sk 1/6/2012 21:43:13.712'!
printEventInformationOn: aStream
	aStream nextPutAll: self removedClass asString! !

!CSAClassRemovedEvent methodsFor: 'accessing' stamp: 'sk 12/16/2011 16:18:14.12'!
removedClass
	^ removedClass! !

!CSAClassRemovedEvent methodsFor: 'accessing' stamp: 'sk 12/16/2011 16:18:14.172'!
removedClass: anObject
	removedClass := anObject! !

CSAEvent subclass: #CSAClassRenamedEvent
	instanceVariableNames: 'renamedClass oldName newName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Events'!

!CSAClassRenamedEvent class methodsFor: 'instance creation' stamp: 'sk 12/17/2011 16:39:37.578'!
forSystemEvent: aRenamedEvent
	^ self new
		oldName: aRenamedEvent oldName;
		newName: aRenamedEvent newName;
		renamedClass: aRenamedEvent item;
		yourself             ! !

!CSAClassRenamedEvent methodsFor: 'visitor' stamp: 'sk 12/17/2011 16:38:20.047'!
accept: aTCSAEventHandler
	^ aTCSAEventHandler renamedClass: self    ! !

!CSAClassRenamedEvent methodsFor: 'accessing' stamp: 'sk 12/17/2011 16:34:11.969'!
newName
	^ newName! !

!CSAClassRenamedEvent methodsFor: 'accessing' stamp: 'sk 12/17/2011 16:34:11.981'!
newName: aSymbol
	newName := aSymbol
! !

!CSAClassRenamedEvent methodsFor: 'accessing' stamp: 'sk 12/17/2011 16:34:11.939'!
oldName
	^ oldName! !

!CSAClassRenamedEvent methodsFor: 'accessing' stamp: 'sk 12/17/2011 16:34:11.954'!
oldName: aSymbol
	oldName := aSymbol
! !

!CSAClassRenamedEvent methodsFor: 'printing' stamp: 'f.z 1/2/2012 11:15:20.955'!
printEventInformationOn: aStream
	aStream nextPutAll: self oldName, ' -> ', self newName! !

!CSAClassRenamedEvent methodsFor: 'accessing' stamp: 'sk 12/17/2011 16:34:11.863'!
renamedClass
	^ renamedClass! !

!CSAClassRenamedEvent methodsFor: 'accessing' stamp: 'sk 12/17/2011 16:34:11.918'!
renamedClass: aClass
	renamedClass := aClass
! !

!CSAEvent class methodsFor: 'as yet unclassified' stamp: 'ck 1/18/2012 00:01:55.386'!
forSystemEvent: aCommentedEvent
	self subclassResponsibility 
	! !

!CSAEvent methodsFor: 'visitor' stamp: 'sk 12/16/2011 21:39:33.58'!
accept: aTCSAEventHandler
	self subclassResponsibility! !

!CSAEvent methodsFor: 'printing' stamp: 'f.z 1/2/2012 11:10:25.336'!
printEventInformationOn: aStream
	self subclassResponsibility! !

!CSAEvent methodsFor: 'printing' stamp: 'f.z 1/2/2012 11:14:29.179'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: '('.
	self printEventInformationOn: aStream.
	aStream nextPutAll: ')'  ! !

CSAEvent subclass: #CSAMethodEvent
	instanceVariableNames: 'method protocol'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Events'!

CSAMethodEvent subclass: #CSAMethodAddedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Events'!

!CSAMethodAddedEvent methodsFor: 'visitor' stamp: 'sk 12/16/2011 23:36:42.932'!
accept: aTCSAEventHandler
	^ aTCSAEventHandler addedMethod: self! !

!CSAMethodEvent class methodsFor: 'instance creation' stamp: 'sk 12/17/2011 00:52:10.698'!
forSystemEvent: anAddedEvent
	^ self new
		method: anAddedEvent item;
		protocol: anAddedEvent itemProtocol;    
		yourself 
	! !

!CSAMethodEvent methodsFor: 'accessing' stamp: 'sk 12/16/2011 23:27:41.556'!
method
	^ method! !

!CSAMethodEvent methodsFor: 'accessing' stamp: 'sk 12/16/2011 23:27:41.607'!
method: aCompiledMethod
	method := aCompiledMethod
! !

!CSAMethodEvent methodsFor: 'accessing' stamp: 'sk 1/17/2012 20:00:02.171'!
methodClass
	^ self method methodClass! !

!CSAMethodEvent methodsFor: 'printing' stamp: 'f.z 1/2/2012 11:15:34.602'!
printEventInformationOn: aStream
	aStream nextPutAll: self method reference, ' in ', self protocol! !

!CSAMethodEvent methodsFor: 'accessing' stamp: 'sk 12/16/2011 23:27:41.618'!
protocol
	^ protocol! !

!CSAMethodEvent methodsFor: 'accessing' stamp: 'sk 12/16/2011 23:27:41.625'!
protocol: aSymbol
	protocol := aSymbol
! !

CSAMethodEvent subclass: #CSAMethodModifiedEvent
	instanceVariableNames: 'oldMethod'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Events'!

!CSAMethodModifiedEvent class methodsFor: 'as yet unclassified' stamp: 'sk 12/17/2011 00:06:10.01'!
forSystemEvent: aMethodModifiedMethod
	^ (super forSystemEvent: aMethodModifiedMethod)
		oldMethod: aMethodModifiedMethod oldItem;
		yourself
	! !

!CSAMethodModifiedEvent methodsFor: 'visitor' stamp: 'sk 12/17/2011 00:03:29.369'!
accept: aTCSAEventHandler
	^ aTCSAEventHandler modifiedMethod: self    ! !

!CSAMethodModifiedEvent methodsFor: 'accessing' stamp: 'sk 12/16/2011 23:43:49.029'!
oldMethod
	^ oldMethod! !

!CSAMethodModifiedEvent methodsFor: 'accessing' stamp: 'sk 12/16/2011 23:43:49.04'!
oldMethod: aCompiledMethod
	oldMethod := aCompiledMethod
! !

CSAMethodEvent subclass: #CSAMethodRecategorizedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Events'!

!CSAMethodRecategorizedEvent methodsFor: 'visitor' stamp: 'sk 1/6/2012 20:14:11.031'!
accept: aTCSAEventHandler
	^ aTCSAEventHandler recategorizedMethod: self    ! !

CSAMethodEvent subclass: #CSAMethodRemovedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Events'!

!CSAMethodRemovedEvent methodsFor: 'visitor' stamp: 'sk 12/16/2011 23:42:42.109'!
accept: aTCSEventHandler
	^ aTCSEventHandler removedMethod: self  ! !

Object subclass: #CSAEventAction
	instanceVariableNames: 'eventKind itemKind methodSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA'!

!CSAEventAction class methodsFor: 'instance creation' stamp: 'f.z 1/2/2012 09:42:54.697'!
when: anItemKindSymbol changes: anEventKindSymbol send: aMethodSelector
	^ self new
		itemKind: anItemKindSymbol;
		eventKind: anEventKindSymbol;
		methodSelector: aMethodSelector;
		yourself      ! !

!CSAEventAction methodsFor: 'accessing' stamp: 'f.z 1/2/2012 09:40:23.881'!
eventKind
	^ eventKind! !

!CSAEventAction methodsFor: 'accessing' stamp: 'f.z 1/2/2012 09:40:23.924'!
eventKind: aSymbol
	eventKind := aSymbol
! !

!CSAEventAction methodsFor: 'accessing' stamp: 'f.z 1/2/2012 09:40:23.959'!
itemKind
	^ itemKind! !

!CSAEventAction methodsFor: 'accessing' stamp: 'f.z 1/2/2012 10:15:30.972'!
itemKind: aSymbol
	itemKind := aSymbol
! !

!CSAEventAction methodsFor: 'accessing' stamp: 'f.z 1/2/2012 09:40:24.007'!
methodSelector
	^ methodSelector! !

!CSAEventAction methodsFor: 'accessing' stamp: 'f.z 1/2/2012 09:40:24.03'!
methodSelector: aSymbol
	methodSelector := aSymbol
! !

!CSAEventAction methodsFor: 'notifying' stamp: 'f.z 1/2/2012 10:09:56.109'!
sendNotificationsTo: anEventDispatcher
	SystemChangeNotifier uniqueInstance
		notify: anEventDispatcher
		ofSystemChangesOfItem: self itemKind
		change: self eventKind
		using: self methodSelector! !

!CSAEventAction methodsFor: 'notifying' stamp: 'f.z 1/2/2012 10:17:21.678'!
stopNotifying: anEventDispatcher
	SystemChangeNotifier uniqueInstance noMoreNotificationsFor: anEventDispatcher  ! !

Object subclass: #CSAEventDispatcher
	instanceVariableNames: 'metrics classSource'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA'!

!CSAEventDispatcher commentStamp: 'sk 1/6/2012 19:37:47.006' prior: 0!
I register myself to the system event hook and dispatch events to my metrics.
I have a class source which can alter these events.!

!CSAEventDispatcher class methodsFor: 'actions' stamp: 'f.z 1/2/2012 09:47:48.446'!
actions
	^ self methodActions
		addAll: self classActions;
		yourself! !

!CSAEventDispatcher class methodsFor: 'actions' stamp: 'sk 1/17/2012 23:49:09.016'!
classActions
	^ OrderedCollection new
		add: self classAddedAction;
		add: self classModifiedAction;
		add: self classRemovedAction;
		add: self classRenamedAction;
		add: self classRecategorizedAction;
		add: self classCommentedAction;
		yourself! !

!CSAEventDispatcher class methodsFor: 'actions' stamp: 'f.z 1/2/2012 09:59:03.249'!
classAddedAction
	^ CSAEventAction
		when: AbstractEvent classKind
		changes: AddedEvent changeKind
		send: #classAddedEvent:! !

!CSAEventDispatcher class methodsFor: 'actions' stamp: 'sk 1/6/2012 19:38:25.295'!
classCommentedAction
	^ CSAEventAction
		when: AbstractEvent classKind
		changes: CommentedEvent changeKind
		send: #classCommentedEvent:! !

!CSAEventDispatcher class methodsFor: 'actions' stamp: 'f.z 1/2/2012 09:58:39.473'!
classModifiedAction
	^ CSAEventAction
		when: AbstractEvent classKind
		changes: ModifiedEvent changeKind
		send: #classModifiedEvent:! !

!CSAEventDispatcher class methodsFor: 'actions' stamp: 'f.z 1/2/2012 10:00:09.35'!
classRecategorizedAction
	^ CSAEventAction
		when: AbstractEvent classKind
		changes: RecategorizedEvent changeKind
		send: #classRecategorizedEvent:! !

!CSAEventDispatcher class methodsFor: 'actions' stamp: 'f.z 1/2/2012 09:57:58.261'!
classRemovedAction
	^ CSAEventAction
		when: AbstractEvent classKind
		changes: RemovedEvent changeKind
		send: #classRemovedEvent:! !

!CSAEventDispatcher class methodsFor: 'actions' stamp: 'f.z 1/2/2012 09:59:38.618'!
classRenamedAction
	^ CSAEventAction
		when: AbstractEvent classKind
		changes: RenamedEvent changeKind
		send: #classRenamedEvent:! !

!CSAEventDispatcher class methodsFor: 'instance creation' stamp: 'f.z 1/11/2012 21:39:49.032'!
for: aCSAClassSource
	^ self new
		classSource: aCSAClassSource;
		yourself! !

!CSAEventDispatcher class methodsFor: 'actions' stamp: 'sk 1/6/2012 20:12:29.142'!
methodActions
	^ OrderedCollection new
		add: self methodModifiedAction;
		add: self methodRemovedAction;
		add: self methodAddedAction;
		add: self methodRecategorizedAction;
		yourself! !

!CSAEventDispatcher class methodsFor: 'actions' stamp: 'f.z 1/2/2012 09:55:26.68'!
methodAddedAction
	^ CSAEventAction
		when: AbstractEvent methodKind
		changes: AddedEvent changeKind
		send: #methodAddedEvent:! !

!CSAEventDispatcher class methodsFor: 'actions' stamp: 'f.z 1/2/2012 09:54:01.378'!
methodModifiedAction
	^ CSAEventAction 
		when: AbstractEvent methodKind
		changes: ModifiedEvent changeKind
		send: #methodModifiedEvent:! !

!CSAEventDispatcher class methodsFor: 'actions' stamp: 'sk 1/6/2012 20:19:10.894'!
methodRecategorizedAction
	^ CSAEventAction 
		when: AbstractEvent methodKind
		changes: RecategorizedEvent changeKind
		send: #methodRecategorizedEvent:! !

!CSAEventDispatcher class methodsFor: 'actions' stamp: 'f.z 1/2/2012 09:54:53.083'!
methodRemovedAction
	^ CSAEventAction
		when: AbstractEvent methodKind
		changes: RemovedEvent changeKind
		send: #methodRemovedEvent:! !

!CSAEventDispatcher class methodsFor: 'instance handling' stamp: 'f.z 1/11/2012 21:39:26.584'!
removeAllInstances
	self allInstancesDo: [ :dispatcher | dispatcher dismiss ]! !

!CSAEventDispatcher methodsFor: 'metrics' stamp: 'ck 1/11/2012 18:45:49.698'!
addMetric: aCSAMetricClass
	| metric |
	metric := aCSAMetricClass 
			for: self classSource 
			withSourceMetrics:  (self addRequiredMetricsFor: aCSAMetricClass).
	^ self metrics at: aCSAMetricClass 	put: metric
		
		! !

!CSAEventDispatcher methodsFor: 'metrics' stamp: 'ck 1/9/2012 20:54:53.976'!
addMetricWhenMissing: aCSAMetricClass
	^ self metrics 
		at: aCSAMetricClass
		ifAbsent: 
			[self addMetric: aCSAMetricClass]! !

!CSAEventDispatcher methodsFor: 'metrics' stamp: 'ck 1/9/2012 20:55:15.638'!
addRequiredMetricsFor: aCSAMetricClass
	| requiredMetrics |
	requiredMetrics := Dictionary new.
	aCSAMetricClass requiredMetrics do:
		[ :metricClass |
		requiredMetrics
			at: metricClass
			put: (self addMetricWhenMissing: metricClass) ].
	^ requiredMetrics! !

!CSAEventDispatcher methodsFor: 'dispatching' stamp: 'sk 12/17/2011 16:43:00.849'!
classAddedEvent: anEvent
	self dispatch: (CSAClassAddedEvent forSystemEvent: anEvent)  ! !

!CSAEventDispatcher methodsFor: 'dispatching' stamp: 'sk 1/6/2012 19:39:13.913'!
classCommentedEvent: anEvent
	self dispatch: (CSAClassCommentedEvent forSystemEvent: anEvent)  ! !

!CSAEventDispatcher methodsFor: 'dispatching' stamp: 'sk 12/17/2011 16:29:08.037'!
classModifiedEvent: anEvent
	self dispatch: (CSAClassModifiedEvent forSystemEvent: anEvent)  ! !

!CSAEventDispatcher methodsFor: 'dispatching' stamp: 'sk 12/17/2011 16:29:41.697'!
classRecategorizedEvent: anEvent
	self dispatch: (CSAClassRecategorizedEvent forSystemEvent: anEvent)  ! !

!CSAEventDispatcher methodsFor: 'dispatching' stamp: 'sk 12/17/2011 15:55:02.96'!
classRemovedEvent: aRemovedEvent
	self dispatch: (CSAClassRemovedEvent forSystemEvent: aRemovedEvent)  ! !

!CSAEventDispatcher methodsFor: 'dispatching' stamp: 'sk 12/17/2011 16:42:14.56'!
classRenamedEvent: anEvent
	self dispatch: (CSAClassRenamedEvent forSystemEvent: anEvent)  ! !

!CSAEventDispatcher methodsFor: 'accessing' stamp: 'sk 12/16/2011 16:33:52.754'!
classSource
	^ classSource! !

!CSAEventDispatcher methodsFor: 'accessing' stamp: 'f.z 1/12/2012 11:23:25.14'!
classSource: aCSAClassSource
	classSource := aCSAClassSource.
	self initializeExistingMetrics! !

!CSAEventDispatcher methodsFor: 'initialize' stamp: 'sk 12/21/2011 21:29:26.21'!
dismiss
	self unregisterAsObserver.
	self metrics do:
		[ :metric | metric dismiss ]! !

!CSAEventDispatcher methodsFor: 'dispatching' stamp: 'sk 1/8/2012 01:09:13.118'!
dispatch: aCSAEvent
	(self classSource adjust: aCSAEvent) ifNotNilDo: 
		[ :event | 
		Transcript cr; show: 'dispatching ', aCSAEvent, ' -> ', event; cr.
		self metrics do: [ :metric | metric handle: event ] ]  
! !

!CSAEventDispatcher methodsFor: 'initialize' stamp: 'sk 12/16/2011 16:34:48.302'!
initialize
	super initialize.
	^ self
		initializeState;
		registerAsObserver;
		yourself ! !

!CSAEventDispatcher methodsFor: 'initialize' stamp: 'f.z 1/12/2012 11:25:29.589'!
initializeExistingMetrics
	self metrics valuesDo: 
		[ :metric | metric classSource: self classSource ]! !

!CSAEventDispatcher methodsFor: 'initialize' stamp: 'ck 1/11/2012 18:45:32.454'!
initializeState
	self metrics: Dictionary new.! !

!CSAEventDispatcher methodsFor: 'dispatching' stamp: 'sk 12/17/2011 15:53:44.475'!
methodAddedEvent: anAddedEvent
	self dispatch: (CSAMethodAddedEvent forSystemEvent: anAddedEvent)  ! !

!CSAEventDispatcher methodsFor: 'dispatching' stamp: 'sk 12/17/2011 15:37:34.821'!
methodModifiedEvent: aModifiedEvent
	self dispatch: (CSAMethodModifiedEvent forSystemEvent: aModifiedEvent)  ! !

!CSAEventDispatcher methodsFor: 'dispatching' stamp: 'sk 1/6/2012 20:15:59.594'!
methodRecategorizedEvent: aRecategorizedEvent
	self dispatch: (CSAMethodRecategorizedEvent forSystemEvent: aRecategorizedEvent)  ! !

!CSAEventDispatcher methodsFor: 'dispatching' stamp: 'sk 12/17/2011 15:54:41.877'!
methodRemovedEvent: aRemovedEvent
	self dispatch: (CSAMethodRemovedEvent forSystemEvent: aRemovedEvent)  ! !

!CSAEventDispatcher methodsFor: 'accessing' stamp: 'sk 12/16/2011 16:33:52.714'!
metrics
	^ metrics! !

!CSAEventDispatcher methodsFor: 'accessing' stamp: 'sk 12/16/2011 16:33:52.735'!
metrics: aCSAMetric
	metrics := aCSAMetric
! !

!CSAEventDispatcher methodsFor: 'initialize' stamp: 'ck 1/18/2012 19:04:26.56'!
refresh
	self metrics do:
		[ :metric | metric classSource: self classSource ]! !

!CSAEventDispatcher methodsFor: 'observing' stamp: 'f.z 1/2/2012 10:10:30.186'!
registerAsObserver 
	self class actions do:
		[ :action | action sendNotificationsTo: self ]! !

!CSAEventDispatcher methodsFor: 'metrics' stamp: 'sk 12/22/2011 21:05:34.594'!
removeChildMetricsOf: aCSAMetric
	self metrics keysAndValuesDo:
		 [ :class :metric | (metric sourceMetrics includes: aCSAMetric)
			ifTrue: [ self removeMetric: class ] ]  ! !

!CSAEventDispatcher methodsFor: 'metrics' stamp: 'ck 1/11/2012 18:45:41.158'!
removeMetric: aCSAMetricClass
	| metric |
	metric := self metrics at: aCSAMetricClass ifAbsent: [ ^ self ].
	self removeChildMetricsOf: metric.
	metric dismiss.
	self metrics removeKey: aCSAMetricClass! !

!CSAEventDispatcher methodsFor: 'observing' stamp: 'f.z 1/2/2012 10:11:56.039'!
unregisterAsObserver
	self class actions do:
		[ :action | action stopNotifying: self ]! !

Object subclass: #CSAMetric
	uses: TCSAEventHandler
	instanceVariableNames: 'classSource sourceMetrics history'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

CSAMetric class
	uses: TCSAEventHandler classTrait
	instanceVariableNames: ''!

CSAMetric subclass: #CSAClassCollectionMetric
	instanceVariableNames: 'classes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

CSAClassCollectionMetric subclass: #CSAClassBasedRBRuleMetric
	instanceVariableNames: 'rule'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics-3rdParty'!

!CSAClassBasedRBRuleMetric methodsFor: 'as yet unclassified' stamp: 'ck 1/9/2012 11:38:41.85'!
accepts: anObject
	self subclassResponsibility ! !

!CSAClassBasedRBRuleMetric methodsFor: 'as yet unclassified' stamp: 'ck 1/9/2012 11:22:10.686'!
initializeEnvironment: anEnvironment with: anObject
	self subclassResponsibility ! !

!CSAClassBasedRBRuleMetric methodsFor: 'as yet unclassified' stamp: 'ck 1/9/2012 11:05:38.71'!
initializeState 
	super initializeState.
	rule := self rule! !

!CSAClassBasedRBRuleMetric methodsFor: 'as yet unclassified' stamp: 'ck 1/9/2012 11:05:49.958'!
rule
	self subclassResponsibility ! !

!CSAClassBasedRBRuleMetric methodsFor: 'as yet unclassified' stamp: 'ck 1/9/2012 11:51:54.424'!
shallContain: anObject
	^ (self accepts: anObject) and: [  
	(rule runOnEnvironment: (self initializeEnvironment: (rule resultClass new) with: anObject))
		isEmpty not]! !

CSAClassBasedRBRuleMetric subclass: #CSAInconsistentMethodClassificationSmell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics-3rdParty'!

!CSAInconsistentMethodClassificationSmell class methodsFor: 'as yet unclassified' stamp: 'ck 1/11/2012 17:57:31.251'!
columnTitle 
	^ 'Inconsistent protocol'! !

!CSAInconsistentMethodClassificationSmell class methodsFor: 'accessing' stamp: 'f.z 1/11/2012 16:51:39.655'!
longTitle
	^ 'Smell: Inconsistent method classification'! !

!CSAInconsistentMethodClassificationSmell class methodsFor: 'accessing' stamp: 'f.z 1/11/2012 16:52:28.899'!
shortTitle
	^ 'Inconsistent method classification'! !

!CSAInconsistentMethodClassificationSmell methodsFor: 'as yet unclassified' stamp: 'ck 1/11/2012 17:53:40.721'!
accepts: anObject
	^ anObject isCompiledMethod not! !

!CSAInconsistentMethodClassificationSmell methodsFor: 'as yet unclassified' stamp: 'ck 1/11/2012 17:55:49.623'!
initializeEnvironment: anEnvironment with: aClass
	^ anEnvironment 
		addClass: aClass 
		into: (aClass name);
	 	yourself ! !

!CSAInconsistentMethodClassificationSmell methodsFor: 'as yet unclassified' stamp: 'ck 1/8/2012 12:26:53.511'!
rule
	 ^ RBInconsistentMethodClassificationRule new! !

!CSAClassCollectionMetric methodsFor: 'class events' stamp: 'sk 1/6/2012 21:22:58.814'!
addedClass: aCSAClassAddedEvent
	self
		testAndAdd: aCSAClassAddedEvent newClass theNonMetaClass;
		testAndAdd: aCSAClassAddedEvent newClass theMetaClass  ! !

!CSAClassCollectionMetric methodsFor: 'method events' stamp: 'sk 1/6/2012 18:57:15.546'!
addedMethod: aCSAMethodAddedEvent
	self testAndAdd: aCSAMethodAddedEvent method methodClass! !

!CSAClassCollectionMetric methodsFor: 'accessing' stamp: 'sk 1/6/2012 18:47:44.742'!
classes
	^ classes! !

!CSAClassCollectionMetric methodsFor: 'accessing' stamp: 'sk 1/6/2012 18:47:44.753'!
classes: aSet
	classes := aSet
! !

!CSAClassCollectionMetric methodsFor: 'accessing' stamp: 'ck 1/11/2012 18:16:40.262'!
columnContents
	^ CSACollectionResult 
		for: self
		values: (self classes) 
		limitTo: 5! !

!CSAClassCollectionMetric methodsFor: 'class events' stamp: 'sk 1/6/2012 23:05:07.588'!
commentedClass: aCSAClassCommentedEvent
	self updateClass: aCSAClassCommentedEvent commentedClass  ! !

!CSAClassCollectionMetric methodsFor: 'initialize-release' stamp: 'sk 1/6/2012 18:54:17.185'!
initializeFrom: aCSAClassSource
	  aCSAClassSource allClasses do:
		[ :class | self testAndAdd: class ]  ! !

!CSAClassCollectionMetric methodsFor: 'initialize-release' stamp: 'sk 1/6/2012 22:57:18.339'!
initializeState
	super initializeState.
	self classes: IdentitySet new! !

!CSAClassCollectionMetric methodsFor: 'class events' stamp: 'sk 1/6/2012 22:58:24.148'!
modifiedClass: aCSAClassModifiedClassEvent
	self
		remove: aCSAClassModifiedClassEvent newClass; "Attention: newClass == the old class"
		testAndAdd: aCSAClassModifiedClassEvent newClass! !

!CSAClassCollectionMetric methodsFor: 'method events' stamp: 'sk 1/6/2012 18:58:33.931'!
modifiedMethod: aCSAMethodModifiedEvent
	self
		remove: aCSAMethodModifiedEvent oldMethod methodClass;
		testAndAdd: aCSAMethodModifiedEvent method methodClass    ! !

!CSAClassCollectionMetric methodsFor: 'class events' stamp: 'sk 1/6/2012 23:06:01.052'!
recategorizedClass: aCSAClassRecategorizedClassEvent
	self updateClass: aCSAClassRecategorizedClassEvent movedClass    ! !

!CSAClassCollectionMetric methodsFor: 'metric computation' stamp: 'sk 1/6/2012 18:55:02.898'!
remove: aClass
	self classes
		remove: aClass
		ifAbsent: [] ! !

!CSAClassCollectionMetric methodsFor: 'class events' stamp: 'sk 1/6/2012 21:22:10.827'!
removedClass: aCSAClassRemovedEvent
	self
		remove: aCSAClassRemovedEvent removedClass theNonMetaClass;
		remove: aCSAClassRemovedEvent removedClass theMetaClass! !

!CSAClassCollectionMetric methodsFor: 'method events' stamp: 'sk 1/6/2012 19:00:48.92'!
removedMethod: aCSAMethodRemovedEvent
	self testAndRemove: aCSAMethodRemovedEvent method methodClass  ! !

!CSAClassCollectionMetric methodsFor: 'class events' stamp: 'sk 1/6/2012 23:07:46.604'!
renamedClass: aCSAClassRenamedClassEvent
	self updateClass: aCSAClassRenamedClassEvent renamedClass  ! !

!CSAClassCollectionMetric methodsFor: 'metric computation' stamp: 'sk 1/6/2012 19:30:36.004'!
shallContain: aClass
	self subclassResponsibility! !

!CSAClassCollectionMetric methodsFor: 'metric computation' stamp: 'ck 1/18/2012 19:05:10.966'!
testAndAdd: aClass
	(self shallContain: aClass) ifTrue: [ self classes add: aClass ]! !

!CSAClassCollectionMetric methodsFor: 'method events' stamp: 'ck 1/18/2012 19:05:14.214'!
testAndRemove: aClass
	(self shallContain: aClass) ifFalse: [ self remove: aClass ]! !

!CSAClassCollectionMetric methodsFor: 'metric computation' stamp: 'sk 1/6/2012 23:04:47.565'!
updateClass: aClass
	self
		remove: aClass;
		testAndAdd: aClass    ! !

CSAClassCollectionMetric subclass: #CSAGlobalStateMetric
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSAGlobalStateMetric class methodsFor: 'accessing' stamp: 'f.z 1/11/2012 16:53:54.424'!
longTitle
	^ 'Global state'! !

!CSAGlobalStateMetric class methodsFor: 'accessing' stamp: 'f.z 1/11/2012 16:54:00.569'!
shortTitle
	^ 'Global state'! !

!CSAGlobalStateMetric methodsFor: 'metric computation' stamp: 'sk 1/6/2012 21:14:51.638'!
classVariablesOf: aClass
	^ OrderedCollection new
		addAll: aClass class instVarNames;
		addAll: aClass classVarNames;
		yourself! !

!CSAGlobalStateMetric methodsFor: 'class events' stamp: 'sk 1/6/2012 23:13:50.201'!
modifiedClass: aCSAClassModifiedClassEvent
	"We only store the non-meta class but also need to keep track of meta class changes.."
	self updateClass: aCSAClassModifiedClassEvent newClass theNonMetaClass    ! !

!CSAGlobalStateMetric methodsFor: 'metric computation' stamp: 'sk 1/6/2012 23:00:29.093'!
shallContain: aClass
	^ aClass isMeta not and: 
		[ (self classVariablesOf: aClass) isEmpty not or: [ self class instVarNames isEmpty not ] ]! !

CSAClassCollectionMetric subclass: #CSAUncommentedClassesMetric
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSAUncommentedClassesMetric class methodsFor: 'accessing' stamp: 'f.z 1/11/2012 21:00:34.645'!
longTitle
	^ 'Uncommented classes'! !

!CSAUncommentedClassesMetric class methodsFor: 'accessing' stamp: 'f.z 1/11/2012 21:00:39.404'!
shortTitle
	^ 'Uncommented classes'! !

!CSAUncommentedClassesMetric methodsFor: 'metric computation' stamp: 'sk 1/6/2012 23:14:11.998'!
shallContain: aClass
	^ aClass isMeta not and: [ aClass comment isText not ]! !

CSAClassCollectionMetric subclass: #CSAUnnecessaryAbstrationSmell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSAUnnecessaryAbstrationSmell class methodsFor: 'accessing' stamp: 'sk 1/17/2012 23:23:22.178'!
longTitle
	^ 'Smell: Unnecessary abstraction'! !

!CSAUnnecessaryAbstrationSmell class methodsFor: 'accessing' stamp: 'sk 1/17/2012 23:22:31.008'!
shortTitle
	^ 'Unnecessary abstraction'! !

!CSAUnnecessaryAbstrationSmell methodsFor: 'class events' stamp: 'sk 1/18/2012 00:10:50.909'!
addOrKeep: aClass withChildCount: anInteger
	self classes remove: aClass ifAbsent: [].
	Transcript show: aClass asString, ' has ', aClass subclasses size, ' subclasses '; cr.
	((self hasInScope: aClass)  
		and: [ aClass subclasses size = anInteger ]) 
		ifTrue: [ self classes add: aClass ]! !

!CSAUnnecessaryAbstrationSmell methodsFor: 'class events' stamp: 'ck 1/18/2012 19:08:28.852'!
addedClass: aClassAddedEvent
	self
		addOrKeep: aClassAddedEvent newClass withChildCount: 1;
		addOrKeep: aClassAddedEvent newClass superclass withChildCount: 1! !

!CSAUnnecessaryAbstrationSmell methodsFor: 'class events' stamp: 'sk 1/18/2012 00:08:04.936'!
hasInScope: aClass
	^ aClass isMeta not 
		and: [ self classSource contains: aClass ]! !

!CSAUnnecessaryAbstrationSmell methodsFor: 'class events' stamp: 'ck 1/18/2012 19:08:56.832'!
modifiedClass: aCSAClassModifiedEvent
	| oldSuperclass newSuperclass |
	oldSuperclass := aCSAClassModifiedEvent oldClass theNonMetaClass superclass.
	newSuperclass := aCSAClassModifiedEvent newClass theNonMetaClass superclass.
	oldSuperclass ~= newSuperclass ifTrue:
		[ self
			addOrKeep: oldSuperclass withChildCount: 2; " - oldSuperclass"
			addOrKeep: newSuperclass withChildCount: 1]
	! !

!CSAUnnecessaryAbstrationSmell methodsFor: 'class events' stamp: 'ck 1/18/2012 19:09:00.584'!
removedClass: aCSAClassRemovedEvent
	self
		remove: aCSAClassRemovedEvent removedClass;
		addOrKeep: aCSAClassRemovedEvent removedClass superclass withChildCount: 2! !

!CSAUnnecessaryAbstrationSmell methodsFor: 'class events' stamp: 'sk 1/18/2012 00:07:17.067'!
shallContain: aClass
	^ (self hasInScope: aClass) and: [ aClass subclasses size = 1]  ! !

CSAMetric subclass: #CSALinesOfCodeMetric
	instanceVariableNames: 'calculationLinesOfCode linesOfCode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSALinesOfCodeMetric class methodsFor: 'accessing' stamp: 'f.z 1/11/2012 16:55:24.313'!
longTitle
	^ 'Lines of code'! !

!CSALinesOfCodeMetric class methodsFor: 'accessing' stamp: 'f.z 1/11/2012 16:49:23.897'!
shortTitle
	^ 'LOC'! !

!CSALinesOfCodeMetric methodsFor: 'class events' stamp: 'ck 1/17/2012 22:11:04.638'!
addedClass: aCSAClassAddedEvent
	self 
		countClass: aCSAClassAddedEvent newClass;
		updateLinesOfCode ! !

!CSALinesOfCodeMetric methodsFor: 'method events' stamp: 'ck 1/17/2012 22:10:55.392'!
addedMethod: aCSAMethodAddedEvent
	self 
		countMethod: aCSAMethodAddedEvent method;
		updateLinesOfCode ! !

!CSALinesOfCodeMetric methodsFor: 'accessing' stamp: 'ck 1/17/2012 22:08:35.766'!
calculationLinesOfCode
	^ calculationLinesOfCode! !

!CSALinesOfCodeMetric methodsFor: 'accessing' stamp: 'ck 1/17/2012 22:08:35.8'!
calculationLinesOfCode: anInteger
	calculationLinesOfCode := anInteger
! !

!CSALinesOfCodeMetric methodsFor: 'accessing' stamp: 'ck 1/11/2012 19:25:22.588'!
columnContents
	^ CSANumericResult 
		for: self 
		value: self linesOfCode
! !

!CSALinesOfCodeMetric methodsFor: 'observing' stamp: 'sk 12/22/2011 14:00:13.744'!
countClass: aClass
	aClass methodDict valuesDo: [ :method | self countMethod:  method ]! !

!CSALinesOfCodeMetric methodsFor: 'observing' stamp: 'ck 1/17/2012 22:09:07.93'!
countMethod: aCompiledMethod
	self calculationLinesOfCode: self calculationLinesOfCode + aCompiledMethod linesOfCode    ! !

!CSALinesOfCodeMetric methodsFor: 'initialize' stamp: 'ck 1/17/2012 00:33:58.496'!
initialize
	super initialize.  ! !

!CSALinesOfCodeMetric methodsFor: 'initialize' stamp: 'ck 1/17/2012 22:11:43.278'!
initializeFrom: aClassSource
	self calculationLinesOfCode:
		(aClassSource allClasses 
			inject: 0 into: [ :sum :class | sum + class linesOfCode]).
	self updateLinesOfCode ! !

!CSALinesOfCodeMetric methodsFor: 'accessing' stamp: 'f.z 12/5/2011 16:06:43.078'!
linesOfCode
	^ linesOfCode! !

!CSALinesOfCodeMetric methodsFor: 'accessing' stamp: 'ck 1/17/2012 22:08:09.466'!
linesOfCode: anInteger
	linesOfCode := anInteger.
! !

!CSALinesOfCodeMetric methodsFor: 'method events' stamp: 'ck 1/17/2012 22:12:54.076'!
modifiedMethod: aCSAMethodModifiedEvent
	self
		uncountMethod: aCSAMethodModifiedEvent oldMethod;     
		countMethod: aCSAMethodModifiedEvent method;
		updateLinesOfCode ! !

!CSALinesOfCodeMetric methodsFor: 'class events' stamp: 'ck 1/17/2012 22:10:43.554'!
removedClass: aCSAClassRemovedEvent
	self 
		uncountClass: aCSAClassRemovedEvent removedClass;
		updateLinesOfCode! !

!CSALinesOfCodeMetric methodsFor: 'method events' stamp: 'ck 1/17/2012 22:10:38.544'!
removedMethod: aCSAMethodRemovedEvent
	self	
		uncountMethod: aCSAMethodRemovedEvent method;
		updateLinesOfCode! !

!CSALinesOfCodeMetric methodsFor: 'observing' stamp: 'sk 12/22/2011 14:00:01.2'!
uncountClass: aClass
	aClass methodDict valuesDo: [ :method | self uncountMethod:  method ]! !

!CSALinesOfCodeMetric methodsFor: 'observing' stamp: 'ck 1/17/2012 22:09:34.632'!
uncountMethod: aCompiledMethod
	self calculationLinesOfCode: self calculationLinesOfCode - aCompiledMethod linesOfCode! !

!CSALinesOfCodeMetric methodsFor: 'accessing' stamp: 'ck 1/18/2012 19:06:04.072'!
updateLinesOfCode
	self linesOfCode: self calculationLinesOfCode! !

CSAMetric subclass: #CSAMethodCollectionMetric
	instanceVariableNames: 'methods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

CSAMethodCollectionMetric subclass: #CSABrainMethodSmell
	uses: TCSAAccessors
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

CSABrainMethodSmell class
	uses: TCSAAccessors classTrait
	instanceVariableNames: ''!

!CSABrainMethodSmell class methodsFor: 'as yet unclassified' stamp: 'ck 1/16/2012 18:17:28.094'!
longTitle 
	^ 'Brain methods'! !

!CSABrainMethodSmell class methodsFor: 'as yet unclassified' stamp: 'ck 1/16/2012 17:57:18.894'!
requiredMetrics
	^ {CSAMethodCycloMetric. CSAMethodNestingMetric}! !

!CSABrainMethodSmell class methodsFor: 'as yet unclassified' stamp: 'ck 1/16/2012 18:17:15.084'!
shortTitle 
	^ 'Brain methods'! !

!CSABrainMethodSmell class methodsFor: 'as yet unclassified' stamp: 'ck 1/16/2012 19:31:45.404'!
thresholds: aSymbol
	|thresholds |
	thresholds := (Dictionary new)
		at:  #highNesting put: 5;
		at:  #highCyclo put: 4;
		at: #tooHighDataAccess put: 6;
		yourself.
	^ thresholds at: aSymbol ! !

!CSABrainMethodSmell methodsFor: 'as yet unclassified' stamp: 'f.z 1/18/2012 16:25:02.331'!
accessorCountForClassOf: aCompiledMethod
	^ (self accessorsForClassOf: aCompiledMethod) size! !

!CSABrainMethodSmell methodsFor: 'as yet unclassified' stamp: 'ck 1/16/2012 18:55:00'!
methodCycloOf: aCompiledMethod
	^ (self sourceMetrics at: CSAMethodCycloMetric) at: aCompiledMethod! !

!CSABrainMethodSmell methodsFor: 'as yet unclassified' stamp: 'ck 1/16/2012 18:54:45.43'!
methodNestingOf: aCompiledMethod
	^ (self sourceMetrics at: CSAMethodNestingMetric) at: aCompiledMethod ! !

!CSABrainMethodSmell methodsFor: 'as yet unclassified' stamp: 'ck 1/16/2012 21:39:56.776'!
numberOfAccessedDataOf: aCompiledMethod
	| instanceVariables usedVariables usedAccessors accessors |
	instanceVariables := self variablesForClassOf: aCompiledMethod.
	usedVariables := instanceVariables select: 
		[:field | aCompiledMethod writesField: (instanceVariables indexOf: field) ].
	accessors := self accessorsForClassOf: aCompiledMethod.
	usedAccessors := aCompiledMethod literals intersection: accessors.
	^ (IdentitySet newFrom: usedAccessors) addAll: usedVariables; size  
! !

!CSABrainMethodSmell methodsFor: 'as yet unclassified' stamp: 'f.z 1/18/2012 16:25:12.412'!
seemsToBeBrainMethod: aCompiledMethod
	^ (self methodNestingOf: aCompiledMethod) > (self class thresholds: #highNesting)
		and: [ (self methodCycloOf: aCompiledMethod) > (self class thresholds: #highCyclo) ]
		and: [ (self accessorCountForClassOf: aCompiledMethod) > (self class thresholds: #tooHighDataAccess) ]! !

!CSABrainMethodSmell methodsFor: 'metric computation' stamp: 'ck 1/16/2012 18:38:56.32'!
shallContain: aCompiledMethod
	^ self seemsToBeBrainMethod: aCompiledMethod! !

CSAMethodCollectionMetric subclass: #CSAManyArgumentsSmell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSAManyArgumentsSmell class methodsFor: 'constants' stamp: 'sk 1/18/2012 00:40:54.698'!
longTitle
	^ 'Smell: Many arguments'! !

!CSAManyArgumentsSmell class methodsFor: 'constants' stamp: 'sk 1/18/2012 00:39:09.16'!
manyArguments
	^ 4! !

!CSAManyArgumentsSmell class methodsFor: 'constants' stamp: 'sk 1/18/2012 00:41:04.797'!
shortTitle 
	^ 'Many arguments'! !

!CSAManyArgumentsSmell methodsFor: 'metric computation' stamp: 'sk 1/18/2012 00:39:41.832'!
shallContain: aCompiledMethod
	^ aCompiledMethod numArgs >= self class manyArguments  ! !

CSAMethodCollectionMetric subclass: #CSAMetaProgrammingMetric
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics-3rdParty'!

!CSAMetaProgrammingMetric class methodsFor: 'as yet unclassified' stamp: 'ck 1/11/2012 17:47:08.833'!
columnTitle 
	^ 'Uses metaprogramming'! !

!CSAMetaProgrammingMetric class methodsFor: 'accessing' stamp: 'f.z 1/11/2012 16:56:19.534'!
longTitle
	^ 'Methods that use metaprogramming'! !

!CSAMetaProgrammingMetric class methodsFor: 'accessing' stamp: 'f.z 1/11/2012 16:56:27.126'!
shortTitle
	^ 'meta methods'! !

!CSAMetaProgrammingMetric methodsFor: 'metric computation' stamp: 'sk 1/6/2012 19:32:45.82'!
shallContain: aCompiledMethod
	^ (SLSwaMetricsPlugIn new methodUsesMetaprogramming:     
		(SLMethodTestObject newFrom: aCompiledMethod)) isPositive! !

CSAMethodCollectionMetric subclass: #CSAMethodBasedRBRuleMetric
	instanceVariableNames: 'rule'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics-3rdParty'!

CSAMethodBasedRBRuleMetric subclass: #CSAAssignmentWithoutEffectMetric
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics-3rdParty'!

!CSAAssignmentWithoutEffectMetric class methodsFor: 'as yet unclassified' stamp: 'ck 1/11/2012 17:57:53.441'!
columnTitle 
	^ 'Assignments without effect'! !

!CSAAssignmentWithoutEffectMetric class methodsFor: 'accessing' stamp: 'f.z 1/11/2012 16:57:27.85'!
longTitle
	^ 'Assignments without effect'! !

!CSAAssignmentWithoutEffectMetric class methodsFor: 'accessing' stamp: 'f.z 1/11/2012 16:58:05.132'!
shortTitle
	^ 'uneffective assignments'! !

!CSAAssignmentWithoutEffectMetric methodsFor: 'initialize-release' stamp: 'sk 1/7/2012 21:07:52.728'!
rule
	^ RBAssignmentWithoutEffectRule new! !

CSAMethodBasedRBRuleMetric subclass: #CSADebuggingCodeSmell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics-3rdParty'!

!CSADebuggingCodeSmell class methodsFor: 'as yet unclassified' stamp: 'ck 1/11/2012 17:58:26.085'!
columnTitle 
	^ 'Debugging code left'! !

!CSADebuggingCodeSmell class methodsFor: 'as yet unclassified' stamp: 'f.z 1/11/2012 16:58:43.829'!
longTitle
	^ 'Smell: Debugging'! !

!CSADebuggingCodeSmell class methodsFor: 'as yet unclassified' stamp: 'f.z 1/11/2012 16:58:38.915'!
shortTitle
	^ 'Debugging'! !

!CSADebuggingCodeSmell methodsFor: 'initialize-release' stamp: 'sk 1/8/2012 00:23:12.436'!
rule
	^ RBCodeCruftLeftInMethodsRule new! !

CSAMethodBasedRBRuleMetric subclass: #CSAEmptyExceptionHandlerSmell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics-3rdParty'!

!CSAEmptyExceptionHandlerSmell class methodsFor: 'as yet unclassified' stamp: 'ck 1/11/2012 17:59:32.667'!
columnTitle 
	^ 'Empty exceptions'! !

!CSAEmptyExceptionHandlerSmell class methodsFor: 'accessing' stamp: 'f.z 1/11/2012 16:59:01.903'!
longTitle
	^ 'Smell: Empty exception handler'! !

!CSAEmptyExceptionHandlerSmell class methodsFor: 'accessing' stamp: 'f.z 1/11/2012 16:59:28.272'!
shortTitle
	^ 'empty handler'! !

!CSAEmptyExceptionHandlerSmell methodsFor: 'initialize-release' stamp: 'sk 1/8/2012 00:20:20.567'!
rule
	^ RBEmptyExceptionHandlerRule new! !

CSAMethodBasedRBRuleMetric subclass: #CSAIncompleteConditionalReturnSmell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics-3rdParty'!

!CSAIncompleteConditionalReturnSmell class methodsFor: 'as yet unclassified' stamp: 'ck 1/11/2012 18:00:17.425'!
columnTitle 
	^ 'Incomplete conditional returns'! !

!CSAIncompleteConditionalReturnSmell class methodsFor: 'accessing' stamp: 'f.z 1/11/2012 17:00:01.507'!
longTitle
	^ 'Smell: Incomplete conditional return'! !

!CSAIncompleteConditionalReturnSmell class methodsFor: 'accessing' stamp: 'f.z 1/11/2012 17:00:28.448'!
shortTitle
	^ 'incomplete cond. return'! !

!CSAIncompleteConditionalReturnSmell methodsFor: 'initialize-release' stamp: 'sk 1/7/2012 23:18:06.458'!
rule
	^ RBReturnsIfTrueRule new! !

CSAMethodBasedRBRuleMetric subclass: #CSAJustSendsSuperSmell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics-3rdParty'!

!CSAJustSendsSuperSmell class methodsFor: 'as yet unclassified' stamp: 'ck 1/11/2012 18:09:50.778'!
columnTitle 
	^ 'Just sends super'! !

!CSAJustSendsSuperSmell class methodsFor: 'accessing' stamp: 'f.z 1/11/2012 17:05:59.846'!
longTitle
	^ 'Smell: Only sends super'! !

!CSAJustSendsSuperSmell class methodsFor: 'accessing' stamp: 'f.z 1/11/2012 17:06:21.596'!
shortTitle
	^ 'only sends super'! !

!CSAJustSendsSuperSmell methodsFor: 'as yet unclassified' stamp: 'ck 1/8/2012 12:23:13.102'!
rule
	^ RBJustSendsSuperRule new! !

CSAMethodBasedRBRuleMetric subclass: #CSALawOfDemeterSmell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics-3rdParty'!

!CSALawOfDemeterSmell class methodsFor: 'as yet unclassified' stamp: 'ck 1/11/2012 18:00:37.071'!
columnTitle 
	^ 'Law of demeter'! !

!CSALawOfDemeterSmell class methodsFor: 'accessing' stamp: 'f.z 1/11/2012 17:06:41.344'!
longTitle
	^ 'Smell: Law of Demeter'! !

!CSALawOfDemeterSmell class methodsFor: 'accessing' stamp: 'f.z 1/11/2012 17:06:54.52'!
shortTitle
	^ 'LoD'! !

!CSALawOfDemeterSmell methodsFor: 'initialize-release' stamp: 'sk 1/7/2012 23:23:50.717'!
rule
	^ RBLawOfDemeterRule new! !

!CSAMethodBasedRBRuleMetric methodsFor: 'initialize-release' stamp: 'sk 1/7/2012 21:07:10.182'!
initializeState 
	super initializeState.
	rule := self rule! !

!CSAMethodBasedRBRuleMetric methodsFor: 'initialize-release' stamp: 'sk 1/7/2012 21:07:16.323'!
rule
	self subclassResponsibility! !

!CSAMethodBasedRBRuleMetric methodsFor: 'metric computation' stamp: 'ck 1/9/2012 15:32:06.866'!
shallContain: aCompiledMethod
	^ (rule runOnEnvironment:
		(SelectorEnvironment new
			addClass: aCompiledMethod methodClass
			selector: aCompiledMethod selector;
			yourself))
		isEmpty not
! !

CSAMethodBasedRBRuleMetric subclass: #CSAMissedShortcutMethodsSmell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics-3rdParty'!

!CSAMissedShortcutMethodsSmell class methodsFor: 'as yet unclassified' stamp: 'ck 1/11/2012 18:00:59.233'!
columnTitle 
	^ 'Messing shotcut methods'! !

!CSAMissedShortcutMethodsSmell class methodsFor: 'accessing' stamp: 'f.z 1/11/2012 17:20:41.158'!
longTitle
	^ 'Smell: Missed shortcut methods'! !

!CSAMissedShortcutMethodsSmell class methodsFor: 'accessing' stamp: 'f.z 1/11/2012 17:20:55.958'!
shortTitle
	^ 'Missed shortcuts'! !

!CSAMissedShortcutMethodsSmell methodsFor: 'initialize-release' stamp: 'sk 1/8/2012 00:18:40.66'!
rule
	^ RBConsistencyCheckRule new! !

CSAMethodBasedRBRuleMetric subclass: #CSAMissingYourselfSmell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics-3rdParty'!

!CSAMissingYourselfSmell class methodsFor: 'as yet unclassified' stamp: 'ck 1/11/2012 18:01:20.305'!
columnTitle 
	^ 'Missing yourself'! !

!CSAMissingYourselfSmell class methodsFor: 'accessing' stamp: 'f.z 1/11/2012 17:21:22.469'!
longTitle
	^ 'Smell: Missing yourself'! !

!CSAMissingYourselfSmell class methodsFor: 'accessing' stamp: 'f.z 1/11/2012 17:21:31.589'!
shortTitle
	^ 'no yourself'! !

!CSAMissingYourselfSmell methodsFor: 'initialize-release' stamp: 'sk 1/7/2012 23:10:29.435'!
rule
	^ RBMissingYourselfRule new! !

CSAMethodBasedRBRuleMetric subclass: #CSAMistakablePrecedenceSmell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics-3rdParty'!

!CSAMistakablePrecedenceSmell class methodsFor: 'as yet unclassified' stamp: 'ck 1/11/2012 18:01:56.615'!
columnTitle 
	^ 'Mistakable precedence'! !

!CSAMistakablePrecedenceSmell class methodsFor: 'accessing' stamp: 'f.z 1/11/2012 17:21:55.319'!
longTitle
	^ 'Smell: Mistakable precedence'! !

!CSAMistakablePrecedenceSmell class methodsFor: 'accessing' stamp: 'f.z 1/11/2012 17:22:11.68'!
shortTitle
	^ 'Mistakable precedence'! !

!CSAMistakablePrecedenceSmell methodsFor: 'initialize-release' stamp: 'sk 1/7/2012 23:14:33.338'!
rule
	^ RBPrecedenceRule new! !

CSAMethodBasedRBRuleMetric subclass: #CSAModifyingIteratedCollectionSmell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics-3rdParty'!

!CSAModifyingIteratedCollectionSmell class methodsFor: 'as yet unclassified' stamp: 'ck 1/11/2012 18:02:22.993'!
columnTitle 
	^ 'Modifing collection during iteration'! !

!CSAModifyingIteratedCollectionSmell class methodsFor: 'accessing' stamp: 'f.z 1/11/2012 17:22:50.112'!
longTitle
	^ 'Smell: Modifying iterated collection'! !

!CSAModifyingIteratedCollectionSmell class methodsFor: 'accessing' stamp: 'f.z 1/11/2012 17:23:10.503'!
shortTitle
	^ 'modifying iterating'! !

!CSAModifyingIteratedCollectionSmell methodsFor: 'initialize-release' stamp: 'sk 1/7/2012 23:06:02.879'!
rule
	^ RBModifiesCollectionRule new! !

CSAMethodBasedRBRuleMetric subclass: #CSAPlatformDependentUserInteractionSmell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics-3rdParty'!

!CSAPlatformDependentUserInteractionSmell class methodsFor: 'as yet unclassified' stamp: 'ck 1/11/2012 18:03:02.923'!
columnTitle 
	^ 'Platform dependend UI code'! !

!CSAPlatformDependentUserInteractionSmell class methodsFor: 'accessing' stamp: 'f.z 1/11/2012 17:24:20.962'!
longTitle
	^ 'Smell: Platform dependent user interaction'! !

!CSAPlatformDependentUserInteractionSmell class methodsFor: 'accessing' stamp: 'f.z 1/11/2012 17:24:48.667'!
shortTitle
	^ 'Platform dependent ui'! !

!CSAPlatformDependentUserInteractionSmell methodsFor: 'initialize-release' stamp: 'sk 1/7/2012 23:08:35.616'!
rule
	^ RBPlatformDependentUserInteractionRule new! !

CSAMethodBasedRBRuleMetric subclass: #CSASameTrueAndFalseCodeSmell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics-3rdParty'!

!CSASameTrueAndFalseCodeSmell class methodsFor: 'accessing' stamp: 'f.z 1/11/2012 17:27:17.124'!
longTitle
	^ 'Smell: Same true and false code'! !

!CSASameTrueAndFalseCodeSmell class methodsFor: 'accessing' stamp: 'f.z 1/11/2012 17:27:27.102'!
shortTitle
	^ 'Same true, false'! !

!CSASameTrueAndFalseCodeSmell methodsFor: 'initialize-release' stamp: 'sk 1/8/2012 00:14:15.917'!
rule
	^ RBEndTrueFalseRule new! !

CSAMethodBasedRBRuleMetric subclass: #CSAThreeElementPointSmell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics-3rdParty'!

!CSAThreeElementPointSmell class methodsFor: 'as yet unclassified' stamp: 'ck 1/11/2012 18:04:32.211'!
columnTitle 
	^ 'Three element point rule'! !

!CSAThreeElementPointSmell class methodsFor: 'accessing' stamp: 'f.z 1/11/2012 17:30:25.774'!
longTitle
	^ 'Smell: Three element point'! !

!CSAThreeElementPointSmell class methodsFor: 'accessing' stamp: 'f.z 1/11/2012 17:30:34.942'!
shortTitle
	^ '3Point'! !

!CSAThreeElementPointSmell methodsFor: 'initialize-release' stamp: 'sk 1/7/2012 22:30:30.235'!
rule
	^ RBThreeElementPointRule new! !

CSAMethodBasedRBRuleMetric subclass: #CSAUnconditionalRecursionSmell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics-3rdParty'!

!CSAUnconditionalRecursionSmell class methodsFor: 'as yet unclassified' stamp: 'ck 1/11/2012 18:04:42.445'!
columnTitle 
	^ 'Uncoditional recursion'! !

!CSAUnconditionalRecursionSmell class methodsFor: 'accessing' stamp: 'f.z 1/11/2012 17:30:57.442'!
longTitle
	^ 'Smell: Unconditional recursion'! !

!CSAUnconditionalRecursionSmell class methodsFor: 'accessing' stamp: 'f.z 1/11/2012 17:31:10.307'!
shortTitle
	^ 'Uncond. recursion'! !

!CSAUnconditionalRecursionSmell methodsFor: 'initialize-release' stamp: 'sk 1/7/2012 22:21:50.733'!
rule
	^ RBUnconditionalRecursionRule new! !

CSAMethodBasedRBRuleMetric subclass: #CSAUnnecessarySizeCheckSmell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics-3rdParty'!

!CSAUnnecessarySizeCheckSmell class methodsFor: 'as yet unclassified' stamp: 'ck 1/11/2012 18:05:23.167'!
columnTitle 
	^ 'Unnecessary size checks'! !

!CSAUnnecessarySizeCheckSmell class methodsFor: 'accessing' stamp: 'f.z 1/11/2012 17:32:01.467'!
longTitle
	^ 'Smell: Unnecessary size check'! !

!CSAUnnecessarySizeCheckSmell class methodsFor: 'accessing' stamp: 'f.z 1/11/2012 17:32:25.048'!
shortTitle
	^ 'unnecessry size check'! !

!CSAUnnecessarySizeCheckSmell methodsFor: 'initialize-release' stamp: 'sk 1/7/2012 22:39:14.344'!
rule
	^ RBSizeCheckRule new! !

CSAMethodBasedRBRuleMetric subclass: #CSAUnusedEqualResultSmell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics-3rdParty'!

!CSAUnusedEqualResultSmell class methodsFor: 'as yet unclassified' stamp: 'ck 1/11/2012 18:05:45.971'!
columnTitle 
	^ 'Unused equals result'! !

!CSAUnusedEqualResultSmell class methodsFor: 'accessing' stamp: 'f.z 1/11/2012 17:32:44.57'!
longTitle
	^ 'Smell: Unused equal result'! !

!CSAUnusedEqualResultSmell class methodsFor: 'accessing' stamp: 'f.z 1/11/2012 17:32:57.934'!
shortTitle
	^ 'Unused equal'! !

!CSAUnusedEqualResultSmell methodsFor: 'initialize-release' stamp: 'sk 1/8/2012 00:16:43.555'!
rule
	^ RBEqualNotUsedRule new! !

CSAMethodBasedRBRuleMetric subclass: #CSAUnusedVariablesSmell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics-3rdParty'!

!CSAUnusedVariablesSmell class methodsFor: 'as yet unclassified' stamp: 'ck 1/11/2012 18:05:57.705'!
columnTitle 
	^ 'Unused variables'! !

!CSAUnusedVariablesSmell class methodsFor: 'accessing' stamp: 'f.z 1/11/2012 17:33:20.444'!
longTitle
	^ 'Smell: Unused variables'! !

!CSAUnusedVariablesSmell class methodsFor: 'accessing' stamp: 'f.z 1/11/2012 17:33:31.778'!
shortTitle
	^ 'Unused vars'! !

!CSAUnusedVariablesSmell methodsFor: 'initialize-release' stamp: 'sk 1/7/2012 23:20:23.554'!
rule
	^ RBOnlyReadOrWrittenTemporaryRule new! !

!CSAMethodCollectionMetric methodsFor: 'class events' stamp: 'sk 1/6/2012 21:33:13.025'!
addedClass: aCSAClassAddedEvent
	self testAndAddAllMethodsOf: aCSAClassAddedEvent newClass  ! !

!CSAMethodCollectionMetric methodsFor: 'method events' stamp: 'sk 1/6/2012 17:53:01.405'!
addedMethod: aCSAMethodAddedEvent
	self testAndAdd: aCSAMethodAddedEvent method  ! !

!CSAMethodCollectionMetric methodsFor: 'metric computation' stamp: 'sk 1/8/2012 01:12:03.061'!
buildStableRepresentationOf: aCompiledMethod
	^ aCompiledMethod methodClass -> aCompiledMethod selector! !

!CSAMethodCollectionMetric methodsFor: 'accessing' stamp: 'ck 1/11/2012 18:16:36.528'!
columnContents
	^ CSACollectionResult 
		for: self
		values: (self methods) 
		limitTo: 5! !

!CSAMethodCollectionMetric methodsFor: 'initialize-release' stamp: 'sk 1/6/2012 17:51:06.367'!
initializeFrom: aCSAClassSource
	  aCSAClassSource allClasses do:
		[ :class | class methodDict valuesDo: 
			[ :method | self testAndAdd: method ] ]! !

!CSAMethodCollectionMetric methodsFor: 'initialize-release' stamp: 'sk 1/6/2012 18:33:48.603'!
initializeState
	super initializeState.
	self methods: Set new! !

!CSAMethodCollectionMetric methodsFor: 'accessing' stamp: 'sk 1/6/2012 18:28:59.955'!
methods
	^ methods! !

!CSAMethodCollectionMetric methodsFor: 'accessing' stamp: 'sk 1/6/2012 18:28:45.744'!
methods: aSet
	methods := aSet
! !

!CSAMethodCollectionMetric methodsFor: 'method events' stamp: 'sk 1/6/2012 17:55:49.712'!
modifiedMethod: aCSAMethodModifiedEvent
	self
		remove: aCSAMethodModifiedEvent oldMethod;
		testAndAdd: aCSAMethodModifiedEvent method    ! !

!CSAMethodCollectionMetric methodsFor: 'method events' stamp: 'sk 1/6/2012 20:21:03.676'!
recategorizedMethod: aCSAMethodRecategorizedEvent
	self 
		remove: aCSAMethodRecategorizedEvent method;
		testAndAdd: aCSAMethodRecategorizedEvent method  ! !

!CSAMethodCollectionMetric methodsFor: 'metric computation' stamp: 'ck 1/18/2012 19:06:50.944'!
remove: aCompiledMethod
	self methods
		remove: (self buildStableRepresentationOf: aCompiledMethod)
		ifAbsent: [ ^ self ]! !

!CSAMethodCollectionMetric methodsFor: 'metric computation' stamp: 'sk 1/6/2012 21:35:16.879'!
removeAllMethodsOf: aClass
	self
		removeAllOf: aClass theNonMetaClass methodDict;
		removeAllOf: aClass theMetaClass methodDict! !

!CSAMethodCollectionMetric methodsFor: 'metric computation' stamp: 'sk 1/6/2012 21:34:23.301'!
removeAllOf: aMethodDictionary
	aMethodDictionary valuesDo: [ :method | self remove: method ]  ! !

!CSAMethodCollectionMetric methodsFor: 'class events' stamp: 'sk 1/6/2012 21:37:59.658'!
removedClass: aCSAClassRemovedEvent
	self removeAllMethodsOf: aCSAClassRemovedEvent removedClass  ! !

!CSAMethodCollectionMetric methodsFor: 'method events' stamp: 'f.z 1/9/2012 17:15:56.267'!
removedMethod: aCSAMethodRemovedEvent
	self remove: aCSAMethodRemovedEvent method! !

!CSAMethodCollectionMetric methodsFor: 'class events' stamp: 'ck 1/18/2012 19:07:02.688'!
renamedClass: aClassRenamedEvent
! !

!CSAMethodCollectionMetric methodsFor: 'metric computation' stamp: 'sk 1/6/2012 19:32:18.155'!
shallContain: aCompiledMethod
	self subclassResponsibility! !

!CSAMethodCollectionMetric methodsFor: 'metric computation' stamp: 'ck 1/18/2012 19:01:25.62'!
testAndAdd: aCompiledMethod
	| debug |
	(self shallContain: aCompiledMethod) ifFalse: [ ^self ].
	debug := self buildStableRepresentationOf: aCompiledMethod.
	self methods add: (debug).! !

!CSAMethodCollectionMetric methodsFor: 'metric computation' stamp: 'sk 1/6/2012 21:35:35.557'!
testAndAddAllMethodsOf: aClass
	self
		testAndAddAllOf: aClass theNonMetaClass methodDict;
		testAndAddAllOf: aClass theMetaClass methodDict! !

!CSAMethodCollectionMetric methodsFor: 'metric computation' stamp: 'sk 1/6/2012 21:31:32.573'!
testAndAddAllOf: aMethodDictionary
	aMethodDictionary valuesDo: [ :method | self testAndAdd: method ].! !

CSAMethodCollectionMetric subclass: #CSANoSuperSendSmell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSANoSuperSendSmell class methodsFor: 'constants' stamp: 'sk 1/17/2012 23:00:59.767'!
longTitle
	^ 'Usually sends to super'! !

!CSANoSuperSendSmell class methodsFor: 'constants' stamp: 'sk 1/17/2012 23:01:20.601'!
shortTitle
	^ 'No super send'! !

!CSANoSuperSendSmell class methodsFor: 'constants' stamp: 'sk 1/17/2012 23:00:34.562'!
superSendSelectors
	^ #(initialize step postCopy)! !

!CSANoSuperSendSmell methodsFor: 'metric computation' stamp: 'sk 1/17/2012 22:45:30.776'!
shallContain: aCompiledMethod
	^ (self shouldSendToSuper: aCompiledMethod) and: [ aCompiledMethod sendsToSuper not ]  ! !

!CSANoSuperSendSmell methodsFor: 'metric computation' stamp: 'sk 1/17/2012 22:45:29.031'!
shouldSendToSuper: aCompiledMethod
	^ self class superSendSelectors includes: aCompiledMethod selector! !

CSAMethodCollectionMetric subclass: #CSATooLongLinesMetric
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics-3rdParty'!

!CSATooLongLinesMetric class methodsFor: 'as yet unclassified' stamp: 'ck 1/11/2012 17:47:47.907'!
columnTitle 
	^ 'Too long lines'! !

!CSATooLongLinesMetric class methodsFor: 'accessing' stamp: 'f.z 1/11/2012 17:33:50.733'!
longTitle
	^ 'Too long lines'! !

!CSATooLongLinesMetric class methodsFor: 'accessing' stamp: 'f.z 1/11/2012 17:33:57.278'!
shortTitle
	^ 'Long lines'! !

!CSATooLongLinesMetric methodsFor: 'metric computation' stamp: 'sk 1/6/2012 19:32:59.104'!
shallContain: aCompiledMethod
	^ (SLSwaMetricsPlugIn new methodHasFormattingProblems:   
		(SLMethodTestObject newFrom: aCompiledMethod)) isPositive! !

CSAMethodCollectionMetric subclass: #CSAUnclassifiedMethodsMetric
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSAUnclassifiedMethodsMetric class methodsFor: 'accessing' stamp: 'ck 1/11/2012 17:48:57.015'!
columnTitle
	^ 'Unclassified methods'! !

!CSAUnclassifiedMethodsMetric class methodsFor: 'accessing' stamp: 'f.z 1/11/2012 17:34:16.928'!
longTitle
	^ 'Unclassified methods'! !

!CSAUnclassifiedMethodsMetric class methodsFor: 'accessing' stamp: 'f.z 1/11/2012 17:34:33.194'!
shortTitle
	^ 'Unclass. method'! !

!CSAUnclassifiedMethodsMetric methodsFor: 'as yet unclassified' stamp: 'sk 1/6/2012 20:09:27.572'!
shallContain: aCompiledMethod
	^ (aCompiledMethod methodClass organization categoryOfElement: 
		aCompiledMethod selector) = Categorizer default  ! !

!CSAMetric class methodsFor: 'instance creation' stamp: 'sk 12/22/2011 18:40:09.996'!
for: aCSAClassSource
	^ self for: aCSAClassSource withSourceMetrics: Dictionary new! !

!CSAMetric class methodsFor: 'instance creation' stamp: 'f.z 1/9/2012 16:34:06.937'!
for: aCSAClassSource withSourceMetrics: aDictionary
	"We could do a sanity check at this point"
	^ self new
		sourceMetrics: aDictionary;  
		classSource: aCSAClassSource;
		yourself! !

!CSAMetric class methodsFor: 'accessing' stamp: 'f.z 1/11/2012 16:49:33.893'!
longTitle
	self subclassResponsibility ! !

!CSAMetric class methodsFor: 'dependencies' stamp: 'sk 12/22/2011 19:17:02.093'!
requiredMetrics
	^ {}! !

!CSAMetric class methodsFor: 'accessing' stamp: 'f.z 1/11/2012 16:49:23.846'!
shortTitle
	self subclassResponsibility ! !

!CSAMetric methodsFor: 'accessing' stamp: 'sk 12/22/2011 18:30:18.809'!
classSource
	^ classSource! !

!CSAMetric methodsFor: 'accessing' stamp: 'ck 1/18/2012 19:09:26.89'!
classSource: aCSAClassSource
	classSource := aCSAClassSource.
	self initializeFrom: classSource.
	self triggerChange 
! !

!CSAMetric methodsFor: 'accessing' stamp: 'f.z 1/9/2012 16:43:56.393'!
columnContents
	self subclassResponsibility! !

!CSAMetric methodsFor: 'initialize-release' stamp: 'f.z 1/9/2012 16:33:15.721'!
dismiss
	^ self! !

!CSAMetric methodsFor: 'general handling' stamp: 'sk 12/22/2011 11:43:00.049'!
doDefaultHandlingFor: aCSAEvent
"Default handling is ignoring an event."! !

!CSAMetric methodsFor: 'general handling' stamp: 'ck 1/18/2012 19:02:00.72'!
handle: aCSAEvent
	aCSAEvent accept: self.
	self triggerChange! !

!CSAMetric methodsFor: 'accessing' stamp: 'ck 1/13/2012 20:22:20.94'!
history
	^ history! !

!CSAMetric methodsFor: 'accessing' stamp: 'ck 1/13/2012 20:22:20.989'!
history: aMetricHistory
	history := aMetricHistory
! !

!CSAMetric methodsFor: 'initialize-release' stamp: 'f.z 1/9/2012 17:39:21.593'!
initialize
	super initialize.
	^ self
		initializeState;
		yourself! !

!CSAMetric methodsFor: 'initialize-release' stamp: 'f.z 12/5/2011 16:16:03.751'!
initializeFrom: aClassSource
	self subclassResponsibility  ! !

!CSAMetric methodsFor: 'initialize-release' stamp: 'ck 1/13/2012 20:28:13.222'!
initializeState 
	self sourceMetrics: Dictionary new.
	self history: (CSAResultHistory for: self)! !

!CSAMetric methodsFor: 'accessing' stamp: 'f.z 1/18/2012 18:31:16.691'!
longTitle
	^ self class longTitle! !

!CSAMetric methodsFor: 'accessing' stamp: 'f.z 1/11/2012 21:22:40.33'!
shortTitle
	^ self class shortTitle! !

!CSAMetric methodsFor: 'accessing' stamp: 'sk 12/22/2011 18:33:04.461'!
sourceMetrics
	^ sourceMetrics! !

!CSAMetric methodsFor: 'accessing' stamp: 'sk 12/22/2011 18:33:05.295'!
sourceMetrics: aDictionary
	sourceMetrics := aDictionary! !

!CSAMetric methodsFor: 'updating' stamp: 'ck 1/13/2012 20:24:18.34'!
triggerChange
	self history store: self columnContents.  
	self triggerEvent: #valueChanged with: self! !

CSAMetric subclass: #CSANumberOfClassesMetric
	instanceVariableNames: 'classCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSANumberOfClassesMetric class methodsFor: 'accessing' stamp: 'f.z 1/11/2012 17:35:13.755'!
longTitle
	^ 'Number of classes'! !

!CSANumberOfClassesMetric class methodsFor: 'accessing' stamp: 'f.z 1/11/2012 16:49:23.712'!
shortTitle
	^ 'NOC'! !

!CSANumberOfClassesMetric methodsFor: 'class events' stamp: 'sk 12/22/2011 13:14:40.178'!
addedClass: aCSAClassAddedEvent
	self classCount: self classCount + 1! !

!CSANumberOfClassesMetric methodsFor: 'accessing' stamp: 'sk 12/22/2011 13:13:07.772'!
classCount
	^ classCount! !

!CSANumberOfClassesMetric methodsFor: 'accessing' stamp: 'ck 1/18/2012 19:07:50.682'!
classCount: anInteger
	classCount := anInteger
! !

!CSANumberOfClassesMetric methodsFor: 'accessing' stamp: 'ck 1/12/2012 11:54:45.572'!
columnContents
	^ CSANumericResult 
		for: self 
		value: self classCount 
! !

!CSANumberOfClassesMetric methodsFor: 'initialize-release' stamp: 'sk 12/22/2011 13:12:51.452'!
initialize
	super initialize.
	self classCount: 0.! !

!CSANumberOfClassesMetric methodsFor: 'initialize-release' stamp: 'sk 1/12/2012 00:12:21.764'!
initializeFrom: aCSAClassSource
	self classCount: (aCSAClassSource allClasses size / 2) "don' count meta classes" ! !

!CSANumberOfClassesMetric methodsFor: 'class events' stamp: 'sk 1/12/2012 00:12:58.539'!
removedClass: aCSAClassRemovedEvent
	self classCount: self classCount - 1! !

CSAMetric subclass: #CSANumberOfMethodsMetric
	instanceVariableNames: 'methodCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSANumberOfMethodsMetric class methodsFor: 'accessing' stamp: 'f.z 1/11/2012 17:35:27.869'!
longTitle
	^ 'Number of methods'! !

!CSANumberOfMethodsMetric class methodsFor: 'accessing' stamp: 'f.z 1/11/2012 16:49:23.936'!
shortTitle
	^ 'NOM'! !

!CSANumberOfMethodsMetric methodsFor: 'class events' stamp: 'sk 12/22/2011 19:05:35.416'!
addedClass: aCSAClassAddedEvent
	self increaseMethodCountBy: aCSAClassAddedEvent newClass methodDict size  ! !

!CSANumberOfMethodsMetric methodsFor: 'method events' stamp: 'sk 12/22/2011 14:44:36.972'!
addedMethod: aCSAMethodAddedEvent
	self increaseMethodCountBy: 1! !

!CSANumberOfMethodsMetric methodsFor: 'accessing' stamp: 'ck 1/12/2012 11:54:39.524'!
columnContents
	^ CSANumericResult
		for: self 
		value: self methodCount 
! !

!CSANumberOfMethodsMetric methodsFor: 'accessing' stamp: 'sk 12/22/2011 14:43:05.571'!
decreaseMethodCountBy: anInteger
	self increaseMethodCountBy: anInteger negated  ! !

!CSANumberOfMethodsMetric methodsFor: 'accessing' stamp: 'sk 12/22/2011 14:41:18.518'!
increaseMethodCountBy: anInteger
	self methodCount: self methodCount + anInteger! !

!CSANumberOfMethodsMetric methodsFor: 'initialize-release' stamp: 'sk 12/22/2011 14:35:17.6'!
initialize
	super initialize.
	self methodCount: 0.! !

!CSANumberOfMethodsMetric methodsFor: 'initialize-release' stamp: 'f.z 1/5/2012 12:46:24.128'!
initializeFrom: aCSAClassSource
	self methodCount:
		(aCSAClassSource allClasses
			inject: 0
			into: [ :sum :class | sum + class methodDict size ]  )! !

!CSANumberOfMethodsMetric methodsFor: 'accessing' stamp: 'sk 12/22/2011 14:33:59.378'!
methodCount
	^ methodCount! !

!CSANumberOfMethodsMetric methodsFor: 'accessing' stamp: 'ck 1/18/2012 19:07:53.89'!
methodCount: anInteger
	methodCount := anInteger
! !

!CSANumberOfMethodsMetric methodsFor: 'class events' stamp: 'sk 12/22/2011 21:59:20.527'!
removedClass: aCSARemovedClassEvent
	self decreaseMethodCountBy: aCSARemovedClassEvent removedClass methodDict size  ! !

!CSANumberOfMethodsMetric methodsFor: 'method events' stamp: 'sk 12/22/2011 21:57:20.898'!
removedMethod: aCSAMethodRemovedEvent
	self decreaseMethodCountBy: 1! !

CSAMetric subclass: #CSAPerThingMetric
	instanceVariableNames: 'entries sum'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

CSAPerThingMetric subclass: #CSAPerClassMetric
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

CSAPerClassMetric subclass: #CSAAbstractMethodCount
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSAAbstractMethodCount methodsFor: 'class events' stamp: 'ck 1/18/2012 19:04:50.07'!
addedClass: aCSAClassAddedEvent
	self update: aCSAClassAddedEvent newClass! !

!CSAAbstractMethodCount methodsFor: 'method events' stamp: 'ck 1/18/2012 19:04:53.95'!
addedMethod: aCSAMethodAddedEvent
	self update: aCSAMethodAddedEvent method methodClass! !

!CSAAbstractMethodCount methodsFor: 'metric computation' stamp: 'sk 1/11/2012 19:24:51.794'!
count: aClass
	self subclassResponsibility! !

!CSAAbstractMethodCount methodsFor: 'metric computation' stamp: 'sk 1/11/2012 19:24:03.195'!
decrease: aClass by: aNumber
	self increase: aClass by: aNumber negated! !

!CSAAbstractMethodCount methodsFor: 'metric computation' stamp: 'sk 1/11/2012 19:24:06.076'!
increase: aClass by: aNumber
	self
		at: aClass
		put: (self at: aClass) + aNumber! !

!CSAAbstractMethodCount methodsFor: 'initialize-release' stamp: 'sk 1/11/2012 19:24:12.646'!
initializeFrom: aClassSource
	aClassSource allClasses do: [ :class | self count: class ]! !

!CSAAbstractMethodCount methodsFor: 'class events' stamp: 'ck 1/18/2012 19:04:56.934'!
removedClass: aCSAClassRemovedEvent
	self removeAt: aCSAClassRemovedEvent removedClass! !

!CSAAbstractMethodCount methodsFor: 'method events' stamp: 'ck 1/18/2012 19:05:00.112'!
removedMethod: aCSAMethodRemovedEvent
	self update: aCSAMethodRemovedEvent method methodClass! !

!CSAAbstractMethodCount methodsFor: 'metric computation' stamp: 'ck 1/18/2012 19:05:06.31'!
update: aClass
	self	
		removeAt: aClass;
		count: aClass! !

CSAAbstractMethodCount subclass: #CSAMethodCount
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSAMethodCount class methodsFor: 'accessing' stamp: 'f.z 1/12/2012 11:32:22.731'!
longTitle
	^ 'Methods per class'! !

!CSAMethodCount class methodsFor: 'accessing' stamp: 'f.z 1/12/2012 11:32:29.348'!
shortTitle
	^ 'MPC'! !

!CSAMethodCount methodsFor: 'metric computation' stamp: 'sk 1/11/2012 19:51:20.625'!
count: aClass
	self at: aClass theNonMetaClass put:
		aClass theNonMetaClass methodDict size
		+ aClass theMetaClass methodDict size! !

CSAAbstractMethodCount subclass: #CSAWeightedMethodCount
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSAWeightedMethodCount class methodsFor: 'accessing' stamp: 'sk 1/11/2012 16:08:43.242'!
columnTitle
	^ 'Weighted method count'! !

!CSAWeightedMethodCount class methodsFor: 'accessing' stamp: 'f.z 1/11/2012 17:36:44.53'!
longTitle
	^ 'Weight of methods'! !

!CSAWeightedMethodCount class methodsFor: 'dependencies' stamp: 'sk 1/11/2012 16:08:23.397'!
requiredMetrics
	^ {CSAMethodCycloMetric}! !

!CSAWeightedMethodCount class methodsFor: 'accessing' stamp: 'f.z 1/11/2012 17:36:52.471'!
shortTitle
	^ 'Method weight'! !

!CSAWeightedMethodCount methodsFor: 'metric computation' stamp: 'sk 1/11/2012 19:59:26.272'!
count: aClass
	self at: aClass theNonMetaClass put:
		(self sumUpMethodWeightsOf: aClass theNonMetaClass)
		+ (self sumUpMethodWeightsOf: aClass theMetaClass)! !

!CSAWeightedMethodCount methodsFor: 'source metrics' stamp: 'sk 1/11/2012 16:34:48.248'!
methodCycloMetric
	^ self sourceMetrics at: CSAMethodCycloMetric ! !

!CSAWeightedMethodCount methodsFor: 'method events' stamp: 'ck 1/18/2012 19:09:03.584'!
modifiedMethod: aCSAMethodModifiedEvent
	self update: aCSAMethodModifiedEvent method methodClass! !

!CSAWeightedMethodCount methodsFor: 'metric computation' stamp: 'sk 1/11/2012 19:58:38.522'!
sumUpMethodWeightsOf: aClass
	^ aClass methodDict inject: 0 into: 
		[ :sum :method |
		sum + (self methodCycloMetric at: method) ]! !

CSAPerClassMetric subclass: #CSAInheritanceDepthMetric
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSAInheritanceDepthMetric class methodsFor: 'accessing' stamp: 'f.z 1/11/2012 17:36:18.835'!
longTitle
	^ 'Inheritance depth'! !

!CSAInheritanceDepthMetric class methodsFor: 'accessing' stamp: 'f.z 1/11/2012 17:36:10.239'!
shortTitle
	^ 'Inherit. depth'! !

!CSAInheritanceDepthMetric methodsFor: 'class events' stamp: 'sk 1/10/2012 23:30:10.768'!
addedClass: aCSAClassAddedEvent
	self countClass: aCSAClassAddedEvent newClass! !

!CSAInheritanceDepthMetric methodsFor: 'metric computation' stamp: 'ck 1/17/2012 22:51:21.49'!
countClass: aClass
	| depth |
	depth := self determineInheritenceDepth: aClass.
	self updateDepthOf: aClass to: depth.
	^ depth! !

!CSAInheritanceDepthMetric methodsFor: 'metric computation' stamp: 'sk 12/17/2011 20:38:43.765'!
determineInheritenceDepth: aClass
	| depth curClass |
	depth := 0.
	curClass := aClass.
	[ curClass ~= Object ] whileTrue: 
		[ (curClass == nil) ifTrue: [ ^ -1 ].  
		curClass := curClass superclass.
		depth := depth + 1 ].
	^ depth   ! !

!CSAInheritanceDepthMetric methodsFor: 'initialize-release' stamp: 'f.z 1/5/2012 12:54:34.273'!
initializeFrom: aCSAClassSource
	aCSAClassSource classes do: [ :class | self countClass: class ]  
! !

!CSAInheritanceDepthMetric methodsFor: 'class events' stamp: 'sk 12/21/2011 23:20:10.961'!
modifiedClass: aClassModifiedEvent
	self updateDepthOf: (aClassModifiedEvent newClass)  ! !

!CSAInheritanceDepthMetric methodsFor: 'class events' stamp: 'sk 12/17/2011 20:14:53.424'!
removedClass: aCSAClassRemovedEvent
	self uncountClass: aCSAClassRemovedEvent removedClass  ! !

!CSAInheritanceDepthMetric methodsFor: 'metric computation' stamp: 'ck 1/18/2012 19:05:38.188'!
uncountClass: aClass
	^ self removeAt: aClass name! !

!CSAInheritanceDepthMetric methodsFor: 'metric computation' stamp: 'sk 12/21/2011 23:19:46.565'!
updateDepthOf: aClass
	(self uncountClass: aClass) ~= (self countClass: aClass) ifTrue:
		[ aClass subclassesDo: 
			[ :subclass | 
			(self depthCounter keys contains: [ :key | key == subclass name ]) 
				ifTrue: [ self updateDepthOf: subclass ]  ]  ]! !

!CSAInheritanceDepthMetric methodsFor: 'metric computation' stamp: 'ck 1/18/2012 19:05:42.458'!
updateDepthOf: aClass to: aNumber
	self at: aClass put: aNumber! !

CSAPerClassMetric subclass: #CSALinesPerClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSALinesPerClass class methodsFor: 'accessing' stamp: 'f.z 1/11/2012 21:01:21.995'!
longTitle
	^ 'Lines of code per class'! !

!CSALinesPerClass class methodsFor: 'dependencies' stamp: 'sk 1/11/2012 16:36:45.992'!
requiredMetrics
	^ { CSALinesPerMethodMetric }! !

!CSALinesPerClass class methodsFor: 'accessing' stamp: 'f.z 1/11/2012 21:01:12.156'!
shortTitle
	^ 'LPC'! !

!CSALinesPerClass methodsFor: 'as yet unclassified' stamp: 'sk 1/11/2012 16:40:54.892'!
addedClass: aCSAClassAddedEvent
	self countClass: aCSAClassAddedEvent newClass  ! !

!CSALinesPerClass methodsFor: 'as yet unclassified' stamp: 'sk 1/11/2012 16:41:28.909'!
addedMethod: aCSAMethodAddedEvent
	self countClass: aCSAMethodAddedEvent method methodClass  ! !

!CSALinesPerClass methodsFor: 'as yet unclassified' stamp: 'ck 1/18/2012 19:06:12.384'!
countClass: aClass
	self at: aClass put:
		(aClass methodDict inject: 0 into:
			[ :sum :method | sum + (self linesPerMethodMetric at: method)])! !

!CSALinesPerClass methodsFor: 'as yet unclassified' stamp: 'sk 1/11/2012 16:46:03.65'!
initializeFrom: aCSAClassSource
	aCSAClassSource allClasses do: [ :class | self countClass: class ]! !

!CSALinesPerClass methodsFor: 'source metrics' stamp: 'sk 1/11/2012 16:37:28.246'!
linesPerMethodMetric
	^ self sourceMetrics at: CSALinesPerMethodMetric! !

!CSALinesPerClass methodsFor: 'as yet unclassified' stamp: 'sk 1/11/2012 16:55:15.428'!
modifiedMethod: aCSAMethodModifiedEvent
	self countClass: aCSAMethodModifiedEvent method methodClass  ! !

!CSALinesPerClass methodsFor: 'as yet unclassified' stamp: 'sk 1/11/2012 16:43:06.972'!
removedClass: aCSAClassRemovedEvent
	self removeAt: aCSAClassRemovedEvent removedClass! !

!CSALinesPerClass methodsFor: 'as yet unclassified' stamp: 'sk 1/11/2012 16:42:28.384'!
removedMethod: aCSAMethodRemovedEvent
	self countClass: aCSAMethodRemovedEvent method methodClass  ! !

CSAPerClassMetric subclass: #CSANumberOfChildren
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSANumberOfChildren class methodsFor: 'accessing' stamp: 'sk 1/11/2012 23:58:48.706'!
longTitle
	^ 'Number of immediate subclasses'! !

!CSANumberOfChildren class methodsFor: 'accessing' stamp: 'sk 1/11/2012 23:58:21.063'!
shortTitle
	^ 'Number of Children'! !

!CSANumberOfChildren methodsFor: 'class events' stamp: 'ck 1/18/2012 19:07:31.038'!
addedClass: aClassAddedEvent
	self updateCountFor: aClassAddedEvent newClass superclass.
	self updateCountFor: aClassAddedEvent newClass! !

!CSANumberOfChildren methodsFor: 'metric computation' stamp: 'sk 1/12/2012 00:00:07.273'!
countChildrenOf: aClass
	^ (aClass subclasses collect: [ :class | self classSource contains: aClass ]) size! !

!CSANumberOfChildren methodsFor: 'initialize-release' stamp: 'sk 1/11/2012 23:53:47.688'!
initializeFrom: aCSAClassSource
	aCSAClassSource allClasses do:
		[ :class | class isMeta ifFalse: [ self updateCountFor: class ] ]! !

!CSANumberOfChildren methodsFor: 'class events' stamp: 'ck 1/18/2012 19:07:40.21'!
modifiedClass: aCSAClassModifiedEvent
	| oldSuperclass newSuperclass |
	oldSuperclass := aCSAClassModifiedEvent oldClass theNonMetaClass superclass.
	newSuperclass :=  aCSAClassModifiedEvent newClass theNonMetaClass superclass.
	oldSuperclass ~= newSuperclass ifTrue: 
		[ self
			updateCountFor: oldSuperclass withBias: -1;
			updateCountFor: newSuperclass ]  
	! !

!CSANumberOfChildren methodsFor: 'class events' stamp: 'ck 1/18/2012 19:07:47.394'!
removedClass: aCSAClassRemovedEvent
	self
		removeAt: aCSAClassRemovedEvent removedClass;
		updateCountFor: aCSAClassRemovedEvent removedClass superclass withBias: -1! !

!CSANumberOfChildren methodsFor: 'metric computation' stamp: 'sk 1/18/2012 00:20:54.315'!
updateCountFor: aClass
	self updateCountFor: aClass withBias: 0  ! !

!CSANumberOfChildren methodsFor: 'metric computation' stamp: 'sk 1/18/2012 00:20:32.513'!
updateCountFor: aClass withBias: anInteger
	(self classSource contains: aClass)
		ifTrue: [ self at: aClass put: (self countChildrenOf: aClass) + anInteger ]! !

!CSAPerClassMetric class methodsFor: 'magic numbers' stamp: 'sk 1/10/2012 23:44:37.118'!
defaultValue
	^ 0! !

!CSAPerClassMetric methodsFor: 'entries' stamp: 'sk 1/11/2012 18:58:24.065'!
createEntryFor: aClass
	^ CSAPerClassEntry for: aClass with: self class defaultValue  ! !

!CSAPerClassMetric methodsFor: 'initialize-release' stamp: 'sk 1/10/2012 22:56:57.531'!
initializeState
	super initializeState.
	self entries: SortedCollection new! !

!CSAPerClassMetric methodsFor: 'class events' stamp: 'sk 1/10/2012 23:20:58.423'!
removedClass: aClassRemovedEvent
	self removeAt: aClassRemovedEvent removedClass! !

CSAPerThingMetric subclass: #CSAPerMethodMetric
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

CSAPerMethodMetric subclass: #CSACINTMetric
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSACINTMetric class methodsFor: 'accessing' stamp: 'sk 1/16/2012 17:16:54.927'!
longTitle 
	^ 'Coupling Intensity'! !

!CSACINTMetric class methodsFor: 'accessing' stamp: 'f.z 1/11/2012 16:49:23.79'!
shortTitle 
	^ 'CINT'! !

!CSACINTMetric methodsFor: 'as yet unclassified' stamp: 'sk 1/16/2012 16:54:51.718'!
collectCallsOf: aCompiledMethod
	| selectors |
	selectors := Set new.
	(ParseNodeEnumerator ofBlock:
		[:node | node isMessageNode ifTrue: [selectors add: node selector key]]) 
			visitMethodNode: aCompiledMethod decompile.
	^ selectors! !

!CSACINTMetric methodsFor: 'as yet unclassified' stamp: 'sk 1/16/2012 16:56:50.033'!
updateWith: aCompiledMethod
	self 
		at: aCompiledMethod 
		put: ((self collectCallsOf: aCompiledMethod)
			select: [:selector | aCompiledMethod methodClass canUnderstand: selector]) size! !

CSAPerMethodMetric subclass: #CSAHalstaedMetric
	uses: TCSAAccessors
	instanceVariableNames: 'processedMethod operators operations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

CSAHalstaedMetric class
	uses: TCSAAccessors classTrait
	instanceVariableNames: ''!

CSAHalstaedMetric subclass: #CSAHalstaedDifficultyMetric
	uses: TCSAAccessors
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

CSAHalstaedDifficultyMetric class
	uses: TCSAAccessors classTrait
	instanceVariableNames: ''!

!CSAHalstaedDifficultyMetric class methodsFor: 'as yet unclassified' stamp: 'ck 1/16/2012 21:59:44.33'!
longTitle 
	^ 'Halstaed difficulty'! !

!CSAHalstaedDifficultyMetric class methodsFor: 'as yet unclassified' stamp: 'ck 1/16/2012 21:59:40.808'!
shortTitle 
	^ 'Halstaed difficulty'! !

!CSAHalstaedDifficultyMetric methodsFor: 'as yet unclassified' stamp: 'ck 1/16/2012 22:59:29.606'!
calculate
	| distinctOperators operations distinctOperations |
	distinctOperators := self operators asIdentitySet size.
	operations := self operations.
	distinctOperations := operations asIdentitySet size.
	(distinctOperations = 0
			or: [distinctOperators = 0]
			or: [operations size = 0])
		ifTrue: [^ 0].
	^ self operators asIdentitySet size 
			/ (2 * self operations size 
			/ self operations asIdentitySet size)! !

CSAHalstaedMetric subclass: #CSAHalstaedEffortMetric
	uses: TCSAAccessors
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

CSAHalstaedEffortMetric class
	uses: TCSAAccessors classTrait
	instanceVariableNames: ''!

!CSAHalstaedEffortMetric class methodsFor: 'as yet unclassified' stamp: 'ck 1/16/2012 21:59:17.668'!
longTitle 
	^ 'Halstaed effort'! !

!CSAHalstaedEffortMetric class methodsFor: 'as yet unclassified' stamp: 'ck 1/16/2012 21:52:41.104'!
requiredMetrics 
	^ {CSAHalstaedDifficultyMetric}! !

!CSAHalstaedEffortMetric class methodsFor: 'as yet unclassified' stamp: 'ck 1/16/2012 21:59:13.054'!
shortTitle 
	^ 'Halstaed effort'! !

!CSAHalstaedEffortMetric methodsFor: 'as yet unclassified' stamp: 'ck 1/16/2012 21:57:12.944'!
calculate 
	^ self halstaedDifficulty   * self volume ! !

!CSAHalstaedEffortMetric methodsFor: 'as yet unclassified' stamp: 'ck 1/16/2012 22:07:07.3'!
halstaedDifficulty
	^ (self sourceMetrics at: CSAHalstaedDifficultyMetric ) 
		at: self processedMethod 
		! !

!CSAHalstaedEffortMetric methodsFor: 'as yet unclassified' stamp: 'ck 1/16/2012 21:57:03.288'!
halstaedDifficultyOf: aCompiledMethod
	^ (self sourceMetrics at: CSAMethodNestingMetric) at: aCompiledMethod ! !

!CSAHalstaedMetric methodsFor: 'as yet unclassified' stamp: 'ck 1/16/2012 21:51:37.736'!
calculate 
	self subclassResponsibility ! !

!CSAHalstaedMetric methodsFor: 'as yet unclassified' stamp: 'ck 1/16/2012 22:56:32.498'!
collectionOperations
	| operators |
	operators := self operators collect: [:each | each asSymbol ].
	self operations: 
		(self processedMethod literals 
			select: [:each | (operators includes: each) not])! !

!CSAHalstaedMetric methodsFor: 'as yet unclassified' stamp: 'ck 1/16/2012 22:55:36.008'!
collectionOperators
	| variables |
	variables := (self variablesForClassOf: self processedMethod) 
					collect: [:each | each asSymbol ].
	self operators: 
		((self accessorsForClassOf: self processedMethod) 
			union: variables)! !

!CSAHalstaedMetric methodsFor: 'accessing' stamp: 'ck 1/16/2012 21:36:02.296'!
operations
	^ operations! !

!CSAHalstaedMetric methodsFor: 'accessing' stamp: 'ck 1/16/2012 21:36:16.938'!
operations: aCollection
	operations := aCollection! !

!CSAHalstaedMetric methodsFor: 'accessing' stamp: 'ck 1/16/2012 21:36:02.276'!
operators
	^ operators! !

!CSAHalstaedMetric methodsFor: 'accessing' stamp: 'ck 1/16/2012 21:36:02.29'!
operators: aCollection
	operators := aCollection
! !

!CSAHalstaedMetric methodsFor: 'accessing' stamp: 'ck 1/16/2012 21:27:30.086'!
processedMethod
	^ processedMethod! !

!CSAHalstaedMetric methodsFor: 'accessing' stamp: 'ck 1/16/2012 21:27:30.104'!
processedMethod: aCompiledMethod
	processedMethod := aCompiledMethod
! !

!CSAHalstaedMetric methodsFor: 'as yet unclassified' stamp: 'ck 1/16/2012 21:45:47.592'!
programLength
	^ self operators size + self operations size! !

!CSAHalstaedMetric methodsFor: 'as yet unclassified' stamp: 'ck 1/16/2012 21:48:00.118'!
programVocabularySize
	^ self operators asIdentitySet size + self operations asIdentitySet size! !

!CSAHalstaedMetric methodsFor: 'as yet unclassified' stamp: 'ck 1/16/2012 23:01:39.986'!
updateWith: aCompiledMethod
	self operators: OrderedCollection new.
	self 
		processedMethod: aCompiledMethod;
		collectionOperators;
		collectionOperations;
		at: aCompiledMethod 
			put: (self calculate asFloat roundTo: 0.001  )! !

!CSAHalstaedMetric methodsFor: 'as yet unclassified' stamp: 'ck 1/16/2012 22:08:41.524'!
volume
	| sizeOfVocabulary |
	sizeOfVocabulary := self programVocabularySize.
	sizeOfVocabulary = 0
		ifTrue: [^ 0].
	^ self programLength * self programVocabularySize log / (2 log)! !

CSAPerMethodMetric subclass: #CSALawOfDemeterMetric
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSALawOfDemeterMetric class methodsFor: 'as yet unclassified' stamp: 'sk 1/17/2012 18:29:00.719'!
longTitle
	^ 'Law of Demeter'! !

!CSALawOfDemeterMetric class methodsFor: 'as yet unclassified' stamp: 'sk 1/17/2012 18:29:09.057'!
shortTitle 
	^ 'LoD'! !

!CSALawOfDemeterMetric methodsFor: 'class events' stamp: 'ck 1/18/2012 19:05:47.102'!
addedClass: aCSAClassAddedEvent
	self checkClass: aCSAClassAddedEvent newClass! !

!CSALawOfDemeterMetric methodsFor: 'method events' stamp: 'ck 1/18/2012 19:05:49.966'!
addedMethod: aCSAMethodAddedEvent
	self checkMethod: aCSAMethodAddedEvent method! !

!CSALawOfDemeterMetric methodsFor: 'metric computation' stamp: 'sk 1/17/2012 18:31:00.797'!
checkClass: aClass
	aClass methodDict do: [ :method | self checkMethod: method ]! !

!CSALawOfDemeterMetric methodsFor: 'metric computation' stamp: 'sk 1/17/2012 18:30:29.779'!
checkMethod: aCompiledMethod
	self at: aCompiledMethod put: (CSAMessageChainingVisitor chainingDepthOf: aCompiledMethod)! !

!CSALawOfDemeterMetric methodsFor: 'initialize-release' stamp: 'sk 1/17/2012 18:31:39.053'!
initializeFrom: aCSAClassSource
	aCSAClassSource allClasses do: [ :class | self checkClass: class ]! !

!CSALawOfDemeterMetric methodsFor: 'method events' stamp: 'ck 1/18/2012 19:05:52.766'!
modifiedMethod: aCSAMethodModifiedEvent
	self checkMethod: aCSAMethodModifiedEvent method! !

!CSALawOfDemeterMetric methodsFor: 'class events' stamp: 'ck 1/18/2012 19:05:56.51'!
removedClass: aCSAClassRemovedEvent
	aCSAClassRemovedEvent removedClass methodDict do:
		[ :method | self removeAt: method ]! !

!CSALawOfDemeterMetric methodsFor: 'method events' stamp: 'ck 1/18/2012 19:06:00.326'!
removedMethod: aCSAMethodRemovedEvent
	self removeAt: aCSAMethodRemovedEvent method! !

CSAPerMethodMetric subclass: #CSALinesPerMethodMetric
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSALinesPerMethodMetric class methodsFor: 'accessing' stamp: 'f.z 1/11/2012 21:01:52.2'!
longTitle
	^ 'Lines of code per method'! !

!CSALinesPerMethodMetric class methodsFor: 'accessing' stamp: 'f.z 1/11/2012 21:01:58.036'!
shortTitle
	^ 'LPM'! !

!CSALinesPerMethodMetric methodsFor: 'initialize-release' stamp: 'ck 1/18/2012 19:06:14.904'!
addedClass: aCSAClassAddedEvent
	self countClass: aCSAClassAddedEvent newClass! !

!CSALinesPerMethodMetric methodsFor: 'initialize-release' stamp: 'ck 1/18/2012 19:06:17.638'!
addedMethod: aCSAMethodAddedEvent
	self countMethod: aCSAMethodAddedEvent method! !

!CSALinesPerMethodMetric methodsFor: 'initialize-release' stamp: 'sk 1/11/2012 16:20:38.827'!
countClass: aClass
	aClass methodDict do: [ :method | self countMethod: method ]! !

!CSALinesPerMethodMetric methodsFor: 'metric computation' stamp: 'sk 1/17/2012 22:10:45.278'!
countMethod: aCompiledMethod
	self at: aCompiledMethod put: aCompiledMethod linesOfCode! !

!CSALinesPerMethodMetric methodsFor: 'initialize-release' stamp: 'sk 1/11/2012 16:21:02.408'!
initializeFrom: aCSAClassSource
	aCSAClassSource allClasses do: [ :class | self countClass: class ]! !

!CSALinesPerMethodMetric methodsFor: 'initialize-release' stamp: 'ck 1/18/2012 19:06:24.162'!
modifiedMethod: aCSAMethodModifiedEvent
	self countMethod: aCSAMethodModifiedEvent method! !

!CSALinesPerMethodMetric methodsFor: 'initialize-release' stamp: 'ck 1/18/2012 19:06:27.09'!
removedClass: aCSAClassRemovedEvent
	aCSAClassRemovedEvent removedClass methodDict do:
		[ :method | self removeAt: method ]! !

!CSALinesPerMethodMetric methodsFor: 'initialize-release' stamp: 'ck 1/18/2012 19:06:46.67'!
removedMethod: aCSAMethodRemovedEvent
	self removeAt: aCSAMethodRemovedEvent method! !

CSAPerMethodMetric subclass: #CSAMethodCycloMetric
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSAMethodCycloMetric class methodsFor: 'as yet unclassified' stamp: 'ck 1/16/2012 17:31:15.204'!
branchingSelectors
	"this list is not complete - this is only a set of common branching selectors"
	^  #(
			'ifTrue:' 'ifFalse:' 'ifTrue:ifFalse:' 'ifFalse:ifTrue:' 
			'ifNil:' 'ifNotNil:' 'ifNil:ifNotNil:' 'ifNotNil:ifNil:' 
			'ifEmpty:' 'ifNotEmpty:' 'ifEmpty:ifNotEmpty:' 'ifNotEmpty:ifEmpty:' 
			'ifNotNilDo:' 'ifNil:ifNotNilDo:' 
			'at:ifAbsent:' 'at:ifAbsentPut:' 'detect:ifNone:' 'on:do:' 'to:do:' 'do:separatedBy:' 'do:' 
			'and:' 'or:' 'xor:' 
			'whileTrue:' 'whileTrue' 'whileFalse' 'whileFalse:' 'timesRepeat:' 
			'collect:' 'select:' 'reject:' 'inject:into:' 'detect:' 'anySatisfy:' 'allSatisfy:' 
			'piecesCutWhere:'
		)! !

!CSAMethodCycloMetric class methodsFor: 'accessing' stamp: 'ck 1/16/2012 18:36:08.88'!
longTitle 
	^ 'Method cyclo'! !

!CSAMethodCycloMetric class methodsFor: 'accessing' stamp: 'ck 1/16/2012 16:34:43.06'!
shortTitle 
	^ 'Cyclo'! !

!CSAMethodCycloMetric methodsFor: 'as yet unclassified' stamp: 'ck 1/16/2012 16:34:07.046'!
calculateCyclo: aMethodNode
	| cyclo |
	cyclo := 1.
	(ParseNodeEnumerator 
		ofBlock: [:node | 
			(node isMessageNode and: 
				[ self class branchingSelectors includes: 
					node selector key])
				ifTrue: [	 cyclo := cyclo + 1]])
		visitMethodNode: aMethodNode.
	^ cyclo.
	! !

!CSAMethodCycloMetric methodsFor: 'as yet unclassified' stamp: 'ck 1/16/2012 16:33:23.458'!
updateWith: aCompiledMethod
	self 
		at: aCompiledMethod 
		put: (self calculateCyclo: aCompiledMethod decompile)! !

CSAPerMethodMetric subclass: #CSAMethodNestingMetric
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSAMethodNestingMetric class methodsFor: 'accessing' stamp: 'f.z 1/11/2012 17:38:18.924'!
longTitle
	^ 'Method nesting'! !

!CSAMethodNestingMetric class methodsFor: 'accessing' stamp: 'f.z 1/11/2012 17:38:08.803'!
shortTitle
	^ 'Nesting'! !

!CSAMethodNestingMetric methodsFor: 'as yet unclassified' stamp: 'ck 1/16/2012 17:19:47.74'!
calculateNesting: aMethodNode  
	| visitor |
	visitor := CSANestingBlockVisitor new.
	visitor visitMethodNode: aMethodNode.
	^ visitor max - 1"squeak implements methods as blocks - so we need to remove the method-block"! !

!CSAMethodNestingMetric methodsFor: 'as yet unclassified' stamp: 'ck 1/16/2012 17:20:16.668'!
updateWith: aCompiledMethod
	self 
		at: aCompiledMethod 
		put: (self calculateNesting: aCompiledMethod decompile)! !

CSAPerMethodMetric subclass: #CSAMethodTimesUsed
	instanceVariableNames: 'callsPerClass overallCalls'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSAMethodTimesUsed class methodsFor: 'as yet unclassified' stamp: 'sk 1/17/2012 19:17:37.59'!
longTitle
	^ 'Internal method use frequence'! !

!CSAMethodTimesUsed class methodsFor: 'as yet unclassified' stamp: 'sk 1/17/2012 19:17:55.426'!
shortTitle
	^ 'Times used'! !

!CSAMethodTimesUsed methodsFor: 'class events' stamp: 'ck 1/18/2012 19:07:06.762'!
addedClass: aClassAddedEvent
	self initializeCallsFor: aClassAddedEvent newClass.
	self applyIncrement: (self callsPerClass at: aClassAddedEvent newClass).
	self recomputeClass: aClassAddedEvent newClass! !

!CSAMethodTimesUsed methodsFor: 'method events' stamp: 'ck 1/18/2012 19:07:10.738'!
addedMethod: aMethodEvent
	| newCalls |
	newCalls := self countMessagesOf: aMethodEvent method.  
	self applyIncrement: newCalls.
	(self callsPerClass at: aMethodEvent methodClass) increaseAll: newCalls.
	self recomputeMethod: aMethodEvent method! !

!CSAMethodTimesUsed methodsFor: 'as yet unclassified' stamp: 'sk 1/17/2012 20:42:41.518'!
applyIncrement: aCSACounter
	self classSource allClasses do:
		[ :class | self applyIncrement: aCSACounter toClass: class ].
	self overallCalls increaseAll: aCSACounter! !

!CSAMethodTimesUsed methodsFor: 'as yet unclassified' stamp: 'sk 1/17/2012 20:30:03.142'!
applyIncrement: aCSACounter to: aMethod
	self increaseAt: aMethod by: (aCSACounter at: aMethod selector)! !

!CSAMethodTimesUsed methodsFor: 'as yet unclassified' stamp: 'sk 1/17/2012 20:29:37.898'!
applyIncrement: aCSACounter toClass: aClass
	aClass methodDict valuesDo:
		[ :method | self applyIncrement: aCSACounter to: method ]  ! !

!CSAMethodTimesUsed methodsFor: 'as yet unclassified' stamp: 'sk 1/17/2012 20:28:21.04'!
applyTotal: aCSACounter to: aMethod
	self at: aMethod put: (aCSACounter at: aMethod selector)  ! !

!CSAMethodTimesUsed methodsFor: 'accessing' stamp: 'sk 1/17/2012 19:34:02.428'!
callsPerClass
	^ callsPerClass! !

!CSAMethodTimesUsed methodsFor: 'accessing' stamp: 'sk 1/17/2012 19:34:47.454'!
callsPerClass: aDictionary
	callsPerClass := aDictionary
! !

!CSAMethodTimesUsed methodsFor: 'as yet unclassified' stamp: 'sk 1/17/2012 20:33:46.618'!
countMessagesOf: aMethod
	^ CSACounter new
		countAll: aMethod messages;
		yourself  ! !

!CSAMethodTimesUsed methodsFor: 'initialize-release' stamp: 'sk 1/17/2012 19:47:51.525'!
initialize
	super initialize.
	self callsPerClass: Dictionary new.
	self overallCalls: CSACounter new  ! !

!CSAMethodTimesUsed methodsFor: 'as yet unclassified' stamp: 'sk 1/17/2012 20:20:32.332'!
initializeCallsFor: aClass
	| calls |
	calls := CSACounter new.
	aClass methodDict valuesDo: [ :method | calls countAll: method messages ].
	self callsPerClass at: aClass put: calls! !

!CSAMethodTimesUsed methodsFor: 'initialize-release' stamp: 'sk 1/17/2012 20:23:41.52'!
initializeFrom: aClassSource
	aClassSource allClasses do: [:class | self initializeCallsFor: class ].
	self initializeOverallCalls.
	aClassSource allClasses do: [:class | self recomputeClass: class ]  

	! !

!CSAMethodTimesUsed methodsFor: 'as yet unclassified' stamp: 'sk 1/17/2012 20:23:13.855'!
initializeOverallCalls
	self overallCalls: CSACounter new.
	self callsPerClass valuesDo: [ :counter | self overallCalls increaseAll: counter ]! !

!CSAMethodTimesUsed methodsFor: 'method events' stamp: 'ck 1/18/2012 19:07:14.42'!
modifiedMethod: aMethodModifiedEvent  
	| oldCount newCount difference |
	oldCount := self countMessagesOf: aMethodModifiedEvent oldMethod.
	newCount := self countMessagesOf: aMethodModifiedEvent method.
	difference := newCount - oldCount.
	self applyIncrement: difference.
	(self callsPerClass at: aMethodModifiedEvent methodClass) increaseAll: difference! !

!CSAMethodTimesUsed methodsFor: 'accessing' stamp: 'sk 1/17/2012 19:47:25.91'!
overallCalls
	^ overallCalls! !

!CSAMethodTimesUsed methodsFor: 'accessing' stamp: 'sk 1/17/2012 19:47:25.93'!
overallCalls: aCSACounter
	overallCalls := aCSACounter
! !

!CSAMethodTimesUsed methodsFor: 'as yet unclassified' stamp: 'sk 1/17/2012 20:31:09.426'!
recomputeClass: aClass
	aClass methodDict valuesDo: [ :method | self recomputeMethod: method ]! !

!CSAMethodTimesUsed methodsFor: 'as yet unclassified' stamp: 'sk 1/17/2012 20:30:47.466'!
recomputeMethod: aMethod
	self applyTotal: self overallCalls to: aMethod! !

!CSAMethodTimesUsed methodsFor: 'class events' stamp: 'ck 1/18/2012 19:07:18.796'!
removedClass: aClassRemovedEvent
	self applyIncrement: (self callsPerClass at: aClassRemovedEvent removedClass) negated.
	self callsPerClass removeKey: aClassRemovedEvent removedClass.
	self removeAllOf: aClassRemovedEvent removedClass! !

!CSAMethodTimesUsed methodsFor: 'method events' stamp: 'ck 1/18/2012 19:07:21.948'!
removedMethod: aMethodRemovedEvent
	| removedCalls |
	removedCalls := self countMessagesOf: aMethodRemovedEvent method.  
	self applyIncrement: removedCalls negated.
	(self callsPerClass at: aMethodRemovedEvent methodClass) decreaseAll: removedCalls.
	self removeAt: aMethodRemovedEvent method! !

!CSAPerMethodMetric class methodsFor: 'magic numbers' stamp: 'sk 1/11/2012 00:00:24.78'!
defaultValue
	^ 0! !

!CSAPerMethodMetric methodsFor: 'class events' stamp: 'ck 1/18/2012 19:07:57.242'!
addedClass: aClassAddedEvent
	self
		introduceClass: aClassAddedEvent newClass theNonMetaClass;
		introduceClass: aClassAddedEvent newClass theMetaClass! !

!CSAPerMethodMetric methodsFor: 'method events' stamp: 'ck 1/18/2012 19:08:01.066'!
addedMethod: aMethodEvent  
	self updateWith: aMethodEvent method! !

!CSAPerMethodMetric methodsFor: 'entries' stamp: 'sk 1/11/2012 19:08:36.112'!
createEntryFor: aCompiledMethod
	^ CSAPerMethodEntry for: aCompiledMethod with: self class defaultValue  ! !

!CSAPerMethodMetric methodsFor: 'as yet unclassified' stamp: 'sk 1/17/2012 19:50:29.406'!
increaseAt: aCompiledMethod by: aNumber
	self
		at: aCompiledMethod 
		put: (self at: aCompiledMethod) + aNumber! !

!CSAPerMethodMetric methodsFor: 'initialize-release' stamp: 'f.z 1/5/2012 12:45:59.088'!
initializeFrom: aCSAClassSource  
	aCSAClassSource allClasses do: [ :class | self introduceClass: class ]  ! !

!CSAPerMethodMetric methodsFor: 'metric computation' stamp: 'ck 1/5/2012 18:27:54.152'!
introduceClass: aClass
	aClass methodsDo: [:method | self updateWith: method ]! !

!CSAPerMethodMetric methodsFor: 'method events' stamp: 'ck 1/18/2012 19:08:04.234'!
modifiedMethod: aMethodEvent  
	self updateWith: aMethodEvent method! !

!CSAPerMethodMetric methodsFor: 'as yet unclassified' stamp: 'sk 1/12/2012 12:01:34.09'!
removeAllOf: aClass
	aClass methodDict do: [ :method | self removeAt: method ]! !

!CSAPerMethodMetric methodsFor: 'class events' stamp: 'ck 1/18/2012 19:08:08.988'!
removedClass: aClassRemovedEvent
	self
		removeAllOf: aClassRemovedEvent removedClass theNonMetaClass;
		removeAllOf: aClassRemovedEvent removedClass theMetaClass! !

!CSAPerMethodMetric methodsFor: 'method events' stamp: 'ck 1/18/2012 19:08:13.248'!
removedMethod: aMethodEvent  
	self removeAt: aMethodEvent method! !

!CSAPerMethodMetric methodsFor: 'method events' stamp: 'ck 1/18/2012 19:08:23.842'!
renamedClass: aCSAClassRenamedEvent
	"Method representation will have changed"! !

!CSAPerMethodMetric methodsFor: 'metric computation' stamp: 'ck 12/31/2011 10:47:43.533'!
updateWith: aCompiledMethod
	self subclassResponsibility   ! !

CSAPerMethodMetric subclass: #CSATransitiveResponseForClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSATransitiveResponseForClass class methodsFor: 'as yet unclassified' stamp: 'sk 1/12/2012 17:23:09.377'!
longTitle
	^ 'Transitive response for class'! !

!CSATransitiveResponseForClass class methodsFor: 'as yet unclassified' stamp: 'sk 1/16/2012 20:08:31.499'!
shortTitle
	^ 'RFC'''! !

!CSATransitiveResponseForClass methodsFor: 'metric computation' stamp: 'sk 1/16/2012 19:54:38.224'!
countTransitiveInternalCallsOf: aCompiledMethod
	| visitedMethods |
	visitedMethods := Set new.
	self 
		followCallsOf: aCompiledMethod 
		on: aCompiledMethod methodClass 
		andStoreThemIn: visitedMethods.
	^ visitedMethods size! !

!CSATransitiveResponseForClass methodsFor: 'metric computation' stamp: 'sk 1/16/2012 20:00:57.369'!
followCallsOf: aCompiledMethod on: aClass andStoreThemIn: aCollectionOfCompiledMethods
	"Transcript show: 'Testing', aSelector asString, ' on ', aClass asString; cr."
	
	(aCompiledMethod isNil not 
		and: [(aCollectionOfCompiledMethods includes: aCompiledMethod) not ]) ifTrue:
		[| collector |
		aCollectionOfCompiledMethods add: aCompiledMethod.
		collector := CSACallCollector new.
		collector collectFrom: aCompiledMethod.
		collector selfCalls do: 
			[ :selector | self 
				followCallsOf: (aClass lookupSelector: selector)
				on: aClass
				andStoreThemIn: aCollectionOfCompiledMethods ].
		aClass superclass ifNotNilDo:
			[:superclass | collector superCalls do:
				[:selector | self
				followCallsOf: (superclass lookupSelector: selector) 
				on: aClass 
				andStoreThemIn: aCollectionOfCompiledMethods ] ] ]! !

!CSATransitiveResponseForClass methodsFor: 'metric computation' stamp: 'sk 1/12/2012 17:27:55.234'!
updateWith: aCSACompiledMethod
	self
		at: aCSACompiledMethod 
		put: (self countTransitiveInternalCallsOf: aCSACompiledMethod)! !

CSAPerMethodMetric subclass: #CSAUsedClassNamesMetric
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSAUsedClassNamesMetric class methodsFor: 'as yet unclassified' stamp: 'ck 1/11/2012 17:46:14.135'!
columnTitle 
	^ 'Directly accessed classes'! !

!CSAUsedClassNamesMetric class methodsFor: 'accessing' stamp: 'sk 1/16/2012 20:07:57.261'!
longTitle
	^ 'Used class names'! !

!CSAUsedClassNamesMetric class methodsFor: 'accessing' stamp: 'sk 1/16/2012 20:08:09.562'!
shortTitle
	^ 'UCN'! !

!CSAUsedClassNamesMetric methodsFor: 'metric computation' stamp: 'sk 1/9/2012 19:11:22.239'!
updateWith: aCompiledMethod
	| literals |
	literals := aCompiledMethod literals.
	self
		at: aCompiledMethod
		put: ((literals copyWithout: literals last) count: 
			[ :literal | literal isSymbol not and: 
				[ (literal value = aCompiledMethod methodClass) not ] ])! !

!CSAPerThingMetric class methodsFor: 'constants' stamp: 'sk 1/11/2012 18:41:29.385'!
defaultValue
	^ 0! !

!CSAPerThingMetric methodsFor: 'entries' stamp: 'sk 1/11/2012 18:41:21.186'!
at: anObject
	^ self at: anObject ifAbsent: [ self class defaultValue ]
		! !

!CSAPerThingMetric methodsFor: 'entries' stamp: 'sk 1/11/2012 19:48:21.074'!
at: anObject ifAbsent: aBlock
	^ (self entries select: [ :entry | entry isFor: anObject  ])
		ifEmpty: aBlock
		ifNotEmptyDo: [ :entries | entries first metricValue ] ! !

!CSAPerThingMetric methodsFor: 'entries' stamp: 'sk 1/11/2012 19:29:00.861'!
at: anObject put: aNumber
	self removeAt: anObject.
	self entries add: (self createEntryFor: anObject withValue: aNumber).
	self sum: self sum + aNumber! !

!CSAPerThingMetric methodsFor: 'metric values' stamp: 'f.z 1/12/2012 11:41:47.382'!
average
	self entries ifEmpty:
		[ ^ self class defaultValue ].
	^ self sum / self entries size! !

!CSAPerThingMetric methodsFor: 'user interface' stamp: 'ck 1/13/2012 20:37:34.498'!
columnContents 
	^ (CSAPerThingResult 
		for: self)
			highest: self highest;
			median: self median;
			average: (self average asFloat roundTo: 0.01);
			lowest: self lowest;
			yourself! !

!CSAPerThingMetric methodsFor: 'entries' stamp: 'sk 1/11/2012 18:45:56.68'!
createEntryFor: anObject
	self subclassResponsibility! !

!CSAPerThingMetric methodsFor: 'entries' stamp: 'sk 1/11/2012 18:51:17.626'!
createEntryFor: anObject withValue: aNumber
	^ (self createEntryFor: anObject)
		metricValue: aNumber;
		yourself     ! !

!CSAPerThingMetric methodsFor: 'accessing' stamp: 'sk 1/11/2012 18:35:43.824'!
entries
	^ entries! !

!CSAPerThingMetric methodsFor: 'accessing' stamp: 'sk 1/11/2012 18:35:49.531'!
entries: aSortedCollection
	entries := aSortedCollection
! !

!CSAPerThingMetric methodsFor: 'metric values' stamp: 'ck 1/13/2012 20:37:55.486'!
highest
	^ self entries 
		ifEmpty: [ CSAPerClassEntry new ]
		ifNotEmptyDo: [ :entries | entries last ]! !

!CSAPerThingMetric methodsFor: 'initialize-release' stamp: 'sk 1/11/2012 19:02:18.66'!
initializeState
	super initializeState.
	self entries: SortedCollection new.
	self sum: 0! !

!CSAPerThingMetric methodsFor: 'metric values' stamp: 'sk 1/11/2012 18:36:16.818'!
lowest
	^ self entries isEmpty 
		ifTrue: [CSAPerClassEntry new]
		ifFalse: [self entries first]! !

!CSAPerThingMetric methodsFor: 'metric values' stamp: 'sk 1/11/2012 18:36:38.971'!
median
	^ self entries isEmpty 
		ifTrue: [CSAPerClassEntry new]
		ifFalse: [self entries median]! !

!CSAPerThingMetric methodsFor: 'entries' stamp: 'ck 1/16/2012 18:34:49.092'!
removeAt: anObject
		(self entries select: [ :entry | entry isFor: anObject  ] )
			ifNotEmptyDo: 
				[ :entries | | entry |
				entry := entries first.
				self entries remove: entry.
				self sum: self sum - entry metricValue ]! !

!CSAPerThingMetric methodsFor: 'accessing' stamp: 'sk 1/11/2012 18:39:04.919'!
sum
	^ sum! !

!CSAPerThingMetric methodsFor: 'accessing' stamp: 'sk 1/11/2012 18:39:05.236'!
sum: aNumber
	sum := aNumber
! !

Object subclass: #CSAPerThingEntry
	instanceVariableNames: 'key metricValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

CSAPerThingEntry subclass: #CSAPerClassEntry
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSAPerClassEntry class methodsFor: 'instance creation' stamp: 'sk 1/11/2012 19:29:34.399'!
for: aClass with: aValue
	^ self new
		key: aClass;
		metricValue: aValue;
		yourself! !

!CSAPerClassEntry methodsFor: 'converting' stamp: 'sk 1/10/2012 23:00:20.943'!
asString
	^ self keyClass asString, ': ', self metricValue asString  ! !

!CSAPerClassEntry methodsFor: 'comparing' stamp: 'sk 1/11/2012 19:46:24.666'!
isFor: aClass
	^ self keyClass = aClass ! !

!CSAPerClassEntry methodsFor: 'accessing' stamp: 'sk 1/11/2012 19:36:00.339'!
keyClass
	^ self key! !

CSAPerThingEntry subclass: #CSAPerMethodEntry
	instanceVariableNames: 'selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSAPerMethodEntry class methodsFor: 'instance creation' stamp: 'sk 1/11/2012 18:33:30.139'!
for: aCompiledMethod with: aValue
	^ self new
		key: aCompiledMethod methodClass -> aCompiledMethod selector;
		metricValue: aValue;
		yourself.! !

!CSAPerMethodEntry methodsFor: 'converting' stamp: 'sk 1/9/2012 18:32:06.391'!
asString
	^ self methodClass asString, '>>', self selector asString, ': ', self metricValue asString  ! !

!CSAPerMethodEntry methodsFor: 'comparing' stamp: 'sk 1/11/2012 19:47:11.552'!
isFor: aCompiledMethod
	^ self methodClass = aCompiledMethod methodClass
		and: [ self selector = aCompiledMethod selector ]! !

!CSAPerMethodEntry methodsFor: 'accessing' stamp: 'sk 1/11/2012 18:28:37.157'!
methodClass
	^ self key key! !

!CSAPerMethodEntry methodsFor: 'accessing' stamp: 'sk 1/11/2012 18:28:13.297'!
selector
	^ self key value! !

!CSAPerThingEntry class methodsFor: 'instance creation' stamp: 'sk 1/11/2012 19:45:16.876'!
for: anObject with: aNumber
	self subclassResponsibility! !

!CSAPerThingEntry methodsFor: 'comparing' stamp: 'sk 1/11/2012 19:33:32.401'!
<= aCSAPerThingEntry
	^ self metricValue <= aCSAPerThingEntry metricValue! !

!CSAPerThingEntry methodsFor: 'comparing' stamp: 'sk 1/11/2012 18:30:06.668'!
forSameKeyAs: aCSAPerThingEntry
	self subclassResponsibility  ! !

!CSAPerThingEntry methodsFor: 'comparing' stamp: 'sk 1/11/2012 19:46:02.398'!
isFor: anObject
	self subclassResponsibility! !

!CSAPerThingEntry methodsFor: 'accessing' stamp: 'sk 1/11/2012 18:26:49.986'!
key
	^ key! !

!CSAPerThingEntry methodsFor: 'accessing' stamp: 'sk 1/11/2012 18:26:50.004'!
key: anObject
	key := anObject! !

!CSAPerThingEntry methodsFor: 'accessing' stamp: 'sk 1/11/2012 18:26:50.015'!
metricValue
	^ metricValue! !

!CSAPerThingEntry methodsFor: 'accessing' stamp: 'sk 1/11/2012 18:26:50.021'!
metricValue: aNumber
	metricValue := aNumber
! !

Object subclass: #CSAResult
	instanceVariableNames: 'metricValue stringFormat metricClass graphColors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA'!

CSAResult subclass: #CSAPerThingResult
	instanceVariableNames: 'highest lowest average median'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA'!

!CSAPerThingResult class methodsFor: 'as yet unclassified' stamp: 'ck 1/17/2012 00:21:52.712'!
defaultGraphColors 
	^ {Color red darker. Color green lighter. Color gray lighter. Color blue lighter}! !

!CSAPerThingResult class methodsFor: 'as yet unclassified' stamp: 'ck 1/12/2012 11:46:53.552'!
for: aMetricClass
	^ self new
		metricClass: aMetricClass;
		stringFormat: '{1}', String cr, '{2}', String cr, '{3}', String cr, '{4}'
		yourself! !

!CSAPerThingResult class methodsFor: 'as yet unclassified' stamp: 'ck 1/17/2012 22:16:34.79'!
visualizer 
	^ CSAHistoryChart! !

!CSAPerThingResult methodsFor: 'accessing' stamp: 'ck 1/17/2012 22:33:09.004'!
asString
	^ self stringFormat format: self contentCollection ! !

!CSAPerThingResult methodsFor: 'accessing' stamp: 'ck 1/12/2012 11:33:54.44'!
average
	^ average! !

!CSAPerThingResult methodsFor: 'accessing' stamp: 'ck 1/12/2012 11:33:54.456'!
average: aPerThingEntry
	average := aPerThingEntry
! !

!CSAPerThingResult methodsFor: 'accessing' stamp: 'ck 1/12/2012 12:15:02.746'!
contentCollection
	^ {self highest asString. self lowest asString. self median asString. self average asString}! !

!CSAPerThingResult methodsFor: 'accessing' stamp: 'ck 1/12/2012 11:48:08.12'!
highest
	^ highest! !

!CSAPerThingResult methodsFor: 'accessing' stamp: 'ck 1/12/2012 11:48:08.132'!
highest: aPerThingResult
	highest := aPerThingResult! !

!CSAPerThingResult methodsFor: 'accessing' stamp: 'ck 1/12/2012 11:45:50.916'!
lowest
	^ lowest! !

!CSAPerThingResult methodsFor: 'accessing' stamp: 'ck 1/12/2012 11:45:50.922'!
lowest: aPerThingEntry
	lowest := aPerThingEntry
! !

!CSAPerThingResult methodsFor: 'accessing' stamp: 'ck 1/12/2012 11:33:54.472'!
median
	^ median! !

!CSAPerThingResult methodsFor: 'accessing' stamp: 'ck 1/12/2012 11:33:54.488'!
median: aPerThingEntry
	median := aPerThingEntry
! !

!CSAPerThingResult methodsFor: 'accessing' stamp: 'ck 1/12/2012 12:14:26.71'!
valueCollection
	^ {self highest metricValue. self lowest metricValue. self median metricValue. self average}! !

!CSAResult class methodsFor: 'initialization' stamp: 'ck 1/17/2012 00:20:14.074'!
defaultGraphColors 
	self subclassResponsibility ! !

!CSAResult class methodsFor: 'initialization' stamp: 'ck 1/11/2012 18:27:59.948'!
for: aMetricClass
	^ self new;
		metricClass: aMetricClass;
		yourself    ! !

!CSAResult class methodsFor: 'initialization' stamp: 'ck 1/11/2012 18:35:17.178'!
for: aMetricClass value: aValue
	^ self for: aMetricClass value: aValue formatAll: '{1}'! !

!CSAResult class methodsFor: 'initialization' stamp: 'ck 1/11/2012 17:30:59.681'!
for: aMetricClass value: aValue formatAll: aStringFormat
	^ self new
		metricClass: aMetricClass;
		metricValue: aValue;
		stringFormat: aStringFormat;
		yourself ! !

!CSAResult class methodsFor: 'initialization' stamp: 'ck 1/12/2012 11:37:37.584'!
visualizer 
	self subclassResponsibility ! !

!CSAResult methodsFor: 'converting' stamp: 'ck 1/17/2012 22:38:55.328'!
asString
	^ self subclassResponsibility
! !

!CSAResult methodsFor: 'accessing' stamp: 'ck 1/17/2012 00:19:30.388'!
graphColors
	^ graphColors! !

!CSAResult methodsFor: 'accessing' stamp: 'ck 1/17/2012 00:19:30.422'!
graphColors: aColorCollection
	graphColors := aColorCollection! !

!CSAResult methodsFor: 'converting' stamp: 'ck 1/17/2012 00:19:53.512'!
initialize 
	self graphColors: self class defaultGraphColors  ! !

!CSAResult methodsFor: 'accessing' stamp: 'ck 1/11/2012 17:27:46.717'!
metricClass
	^ metricClass! !

!CSAResult methodsFor: 'accessing' stamp: 'ck 1/11/2012 17:27:46.747'!
metricClass: anObject
	metricClass := anObject! !

!CSAResult methodsFor: 'accessing' stamp: 'ck 1/9/2012 20:48:24.87'!
metricValue
	^ metricValue! !

!CSAResult methodsFor: 'accessing' stamp: 'ck 1/9/2012 20:48:24.884'!
metricValue: anObject
	metricValue := anObject! !

!CSAResult methodsFor: 'accessing' stamp: 'ck 1/9/2012 21:31:32.984'!
stringFormat
	^ stringFormat! !

!CSAResult methodsFor: 'accessing' stamp: 'ck 1/9/2012 21:31:33'!
stringFormat: anObject
	stringFormat := anObject! !

CSAResult subclass: #CSASingleValueResult
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA'!

CSASingleValueResult subclass: #CSACollectionResult
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA'!

!CSACollectionResult class methodsFor: 'as yet unclassified' stamp: 'ck 1/11/2012 17:31:28.755'!
for: aMetricClass values: aCollection
	^ self 
		for: aMetricClass 
		values: aCollection
		formatSingleItem: '{$}'! !

!CSACollectionResult class methodsFor: 'as yet unclassified' stamp: 'ck 1/11/2012 18:16:25.566'!
for: aMetricClass values: aCollection limitTo: anInteger
	^ self 
		for: aMetricClass 
		values: aCollection
		template: '{$}'
		limitTo: anInteger ! !

!CSACollectionResult class methodsFor: 'as yet unclassified' stamp: 'ck 1/11/2012 17:33:14.785'!
for: aMetricClass values: aCollection template: aSingleItemFormat
	^ super 
		for: aMetricClass 
		value: aCollection 
		formatAll: (self 
			buildFormatFor: aCollection 
			template: aSingleItemFormat
			andLimit: aCollection size)! !

!CSACollectionResult class methodsFor: 'as yet unclassified' stamp: 'ck 1/11/2012 17:40:33.237'!
for: aMetricClass values: aCollection template: aSingleItemFormat limitTo: anInteger
	^ super 
		for: aMetricClass 
		value: aCollection 
		formatAll: (self 
			format: aCollection 
			template: aSingleItemFormat 
			withLimit: anInteger)! !

!CSACollectionResult class methodsFor: 'as yet unclassified' stamp: 'ck 1/11/2012 17:40:44.819'!
format: aCollection template: aStringFormat withLimit: anInteger
	| format limit |
	format := ''.
	limit := (anInteger min: aCollection size).
	limit = 0 ifTrue: [^ 'none'].
	(1 to: limit - 1) do: 
		[:i | format := format, (aStringFormat copyReplaceAll: '$' with: i asString), String cr].
	format := format , (aCollection size ~= limit
		ifTrue: ['and ', (aCollection size - limit) asString, ' more ...']
		ifFalse: [(aStringFormat copyReplaceAll: '$' with: limit asString)]).
	^ format! !

!CSACollectionResult methodsFor: 'accessing' stamp: 'ck 1/12/2012 13:34:50.25'!
contentCollection 
	^ (self metricValue collect: [:item | item asString ]) asArray! !

!CSACollectionResult methodsFor: 'accessing' stamp: 'ck 1/12/2012 13:43:11.838'!
displayableValue  
	^ self metricValue size! !

CSASingleValueResult subclass: #CSANumericResult
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA'!

!CSANumericResult methodsFor: 'accessing' stamp: 'ck 1/12/2012 13:55:18.148'!
contentCollection 
	^ { self metricValue asString }! !

!CSANumericResult methodsFor: 'accessing' stamp: 'ck 1/12/2012 13:52:44.93'!
displayableValue 
	^ self metricValue! !

!CSASingleValueResult class methodsFor: 'as yet unclassified' stamp: 'ck 1/17/2012 00:22:09.002'!
defaultGraphColors 
	^ {Color gray muchDarker}! !

!CSASingleValueResult class methodsFor: 'as yet unclassified' stamp: 'ck 1/17/2012 22:16:27.502'!
visualizer
	^ CSAHistoryChart! !

!CSASingleValueResult methodsFor: 'converting' stamp: 'ck 1/17/2012 22:33:29.43'!
asString
	^ self stringFormat format: self contentCollection! !

!CSASingleValueResult methodsFor: 'converting' stamp: 'ck 1/12/2012 13:42:53.906'!
displayableValue
	self subclassResponsibility ! !

!CSASingleValueResult methodsFor: 'converting' stamp: 'ck 1/12/2012 13:43:03.088'!
valueCollection 
	^ {self displayableValue}! !

Object subclass: #CSAResultHistory
	instanceVariableNames: 'entries metric'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA'!

!CSAResultHistory class methodsFor: 'as yet unclassified' stamp: 'ck 1/11/2012 19:36:38.852'!
for: aMetric
	^ self new initializeWith: aMetric;
		yourself! !

!CSAResultHistory methodsFor: 'accessing' stamp: 'ck 1/9/2012 20:25:02.252'!
entries
	^ entries! !

!CSAResultHistory methodsFor: 'accessing' stamp: 'ck 1/11/2012 16:40:56.833'!
entries: anOrderedCollection
	entries := anOrderedCollection! !

!CSAResultHistory methodsFor: 'accessing' stamp: 'ck 1/11/2012 16:40:45.809'!
initialize
	self entries: OrderedCollection new! !

!CSAResultHistory methodsFor: 'accessing' stamp: 'ck 1/13/2012 20:38:39.48'!
initializeWith: aMetric
	self metric: aMetric.! !

!CSAResultHistory methodsFor: 'accessing' stamp: 'ck 1/9/2012 20:31:56.466'!
metric
	^ metric
  ! !

!CSAResultHistory methodsFor: 'accessing' stamp: 'ck 1/13/2012 20:53:14.002'!
metric: aMetric
	metric := aMetric 
! !

!CSAResultHistory methodsFor: 'accessing' stamp: 'ck 1/17/2012 22:26:02.15'!
store: aResult
	self entries addLast: aResult! !
